/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <sys/msg.h>
#include "Commun.h"
#include "../Debug.h"
#include "Initialisation_Com.h"
#include "../Reseau.h"

void Communication_Envoie_Donnee (gint Pid_Agent, gint ID_Info, gpointer * Donnee, gint Taille_Donnee, struct Struct_Liste_Reseau *Reseau)
{
	struct struct_Info Info;

	bzero (&Info, sizeof (struct struct_Info));
	if ((Taille_Donnee + sizeof (gint)) >= 4096)	
		debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Taille du message >=4096");
	if (Reseau != NULL)
		Reseau->Octet_Envoyer_Agent = Reseau->Octet_Envoyer_Agent + Taille_Donnee;

	Info.type = Pid_Agent;	
	Info.ID_Info = ID_Info;
	memcpy (Info.Donnee, Donnee, Taille_Donnee);
	
	if (msgsnd (File_Info, (void *) &Info, (Taille_Donnee + sizeof (gint)), 0) < 0)
		printf ("msgsnd : %s", strerror (errno));	
}
