/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <gnome.h>
#include "Interface/Root_Interface.h"
#include "Interface/Erreur_Interface.h"
#include "Interface/Debug_Interface.h"
#include "Debug.h"
#include "Reseau.h"
#include "Gconf.h"
#include "Quit.h"
#include "Animation.h"

void debug_printf (gint Id_Reseau, int Niveau_Debug, const char *file, const char *Fonction, int line, char *fmt, ...)
{
	if (Debug >= Niveau_Debug) {
		struct Struct_Liste_Reseau *Reseau = NULL;
		GtkTextBuffer *buffer_text = NULL;
		GtkTextIter iter;
		va_list   args;
		gchar    *Message;
		char      buffer[700];	

		va_start (args, fmt);
		vsnprintf (buffer, 700, fmt, args);
		switch (Niveau_Debug) {
		    case D_ERRO:
			    Id_Reseau_Erreur = Id_Reseau;
			    Reseau = Recupere_Pointeur_Structure_Reseau (Id_Reseau);
			    switch (Id_Reseau) {
				case INTERFACE:
					Message = g_strdup_printf ("File : [%s]\nFonction : [%s]\nLine : [%d] \n\nMessage :\n%s", file, Fonction, line, buffer);
					break;
				case AGENT:
					Message = g_strdup_printf ("Agent\nFile : [%s]\nFonction : [%s]\nLine : [%d] \n\nMessage :\n%s", file, Fonction, line, buffer);
					break;
				default:
					Message = g_strdup_printf ("Agent : [%s]\nFile : [%s]\nFonction : [%s]\nLine : [%d] \n\nMessage :\n%s", Reseau->Nom_Complet_Reseau, file, Fonction, line, buffer);
			    }
			    gtk_label_set_text (GTK_LABEL (label_Erreur), Message);
			    g_free (Message);
			    gtk_widget_show (window_Erreur);
			    break;
		    case D_WARN_USER:
			    if (Id_Reseau == INTERFACE)
				    Message = g_strdup_printf ("****************************\n\n%s\n\n\n\n", buffer);
			    else {
				    if (Id_Reseau == 0)	
					    Message = g_strdup_printf ("****************************\nAgent \n\n%s\n\n\n\n", buffer);
				    else {
					    Reseau = Recupere_Pointeur_Structure_Reseau (Id_Reseau);
					    Message = g_strdup_printf ("****************************\nAgent : [%s]\n\n%s\n\n\n\n", Reseau->Nom_Complet_Reseau, buffer);
				    }
			    }
			    gdk_threads_leave (); 
			    buffer_text = gtk_text_view_get_buffer (GTK_TEXT_VIEW (textview_Debug_Message));
			    gtk_text_buffer_get_end_iter (buffer_text, &iter);
			    gtk_text_buffer_insert (buffer_text, &iter, (const gchar *) Message, -1);
			    gtk_widget_show (Win_Debug);
			    gdk_threads_enter ();
			    refresh ();
			    gdk_threads_leave ();
			    gtk_text_buffer_get_iter_at_offset (buffer_text, &iter, -1);
			    gtk_text_view_scroll_to_iter (GTK_TEXT_VIEW (textview_Debug_Message), &iter, 0, FALSE, 0, 0);
			    gdk_threads_enter ();
			    refresh ();
			    gdk_threads_leave ();
			    break;
		    case D_WARN:
			    printf ("[I] [WARNING] [%s](%s:%d): %s\n", Fonction, file, line, buffer);
			    break;
		    case D_INFO_USER:
			    if (Id_Reseau == INTERFACE)
				    Message = g_strdup_printf ("****************************\nInterface : \n%s\n\n\n\n", buffer);
			    else {
				    Reseau = Recupere_Pointeur_Structure_Reseau (Id_Reseau);
				    Message = g_strdup_printf ("****************************\nAgent : [%s]\n\n%s\n\n\n\n", Reseau->Nom_Complet_Reseau, buffer);
			    } 
				gdk_threads_leave ();
			    buffer_text = gtk_text_view_get_buffer (GTK_TEXT_VIEW (textview_Debug_Message));
			    gtk_text_buffer_get_end_iter (buffer_text, &iter);
			    gtk_text_buffer_insert (buffer_text, &iter, (const gchar *) Message, -1);
			    gtk_widget_show (Win_Debug);
			    gdk_threads_enter ();
			    refresh ();
			    gdk_threads_leave ();
			    gtk_text_buffer_get_iter_at_offset (buffer_text, &iter, -1);
			    gtk_text_view_scroll_to_iter (GTK_TEXT_VIEW (textview_Debug_Message), &iter, 0, FALSE, 0, 0);
			    gdk_threads_enter ();
			    refresh ();
			    gdk_threads_leave ();
			    break;
		    case D_INFO:
			    printf ("[I] [INFO] [%s]: %s\n", Fonction, buffer);
			    break;
		    case D_ALL:
			    printf ("[I] [ALL] [%s]:%s\n", Fonction, buffer);
			    break;
		    default:
			    printf ("[I] [?]  %s\n", buffer);
		}
		va_end (args);
	}
}


void Initialisation_Debug ()
{
	Debug = Lecture_Gconf_Int (INT_DEBUG);
}
