/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Equipement_Signature.h"
#include "Equipement_Port.h"
#include "Settings.h"
#include "Debug.h"
#include "Objet.h"


gboolean Compare_Entete_Equipement (gchar * Entete_Signature, gchar * Entete_Equipement)
{
	gint      i, Taille_Entete_Equipement, Taille_Entete_Signature, index_Entete_Signature;
	gboolean  Saut;

	ERROR_if (Entete_Signature == NULL);
	ERROR_if (Entete_Equipement == NULL);
	
	Taille_Entete_Equipement = strlen (Entete_Equipement);
	Taille_Entete_Signature = strlen (Entete_Signature);
	Saut = FALSE;
	index_Entete_Signature = 0;
	for (i = 0; i < Taille_Entete_Equipement; i++) {
		if ((Saut) && (i < (Taille_Entete_Equipement - 2)) && (index_Entete_Signature < (Taille_Entete_Signature - 2))
			&& (Entete_Signature[index_Entete_Signature] == Entete_Equipement[i])
			&& (Entete_Signature[index_Entete_Signature + 1] == Entete_Equipement[i + 1])
			&& (Entete_Signature[index_Entete_Signature + 2] == Entete_Equipement[i + 2])){	
			Saut = FALSE;
			
		}
		
		if ((index_Entete_Signature < (Taille_Entete_Signature - 1)) && (Entete_Signature[index_Entete_Signature] == '%') && (Entete_Signature[index_Entete_Signature + 1] == '%')) {	
			Saut = TRUE;
			
			index_Entete_Signature = index_Entete_Signature + 2;
		}
		if (!Saut) {
			if (Entete_Signature[index_Entete_Signature] != Entete_Equipement[i]) {
				
				debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "-- Different  [%c%c]  [%c%c]",Entete_Signature[index_Entete_Signature],Entete_Signature[index_Entete_Signature+1],Entete_Equipement[i],Entete_Equipement[i+1]);
				return FALSE;
			}
			
			index_Entete_Signature++;
		}
		else {
			
		}
	}
	
	if (index_Entete_Signature!=Taille_Entete_Signature) 
		return FALSE;
	
	return TRUE;
}


struct Struct_Signature *Retour_Pointeur_Signature_Correspondant (struct Struct_Equipement *Equipement)
{
	struct Struct_Signature *Signature= NULL, *Signature_Equivalent= NULL;
	guint     Nb_Objet_Liste, i;
	gint      Nb_Port_Pouvant_Etre_Ouvert;	
	gint      Nb_Port_Pouvant_Etre_Ouvert_Fermer;
	
	ERROR_if (Equipement == NULL);
	Signature_Equivalent = NULL;
	Nb_Objet_Liste = g_list_length (Settings->GList_Signature);
	if (Nb_Objet_Liste != 0) {
		for (i = 0; i < Nb_Objet_Liste; i++) {
			Signature = g_list_nth_data (Settings->GList_Signature, i);
			if ((Signature->Nb_Fils == 0) && (strcmp (Signature->Md5_Signature, Equipement->Md5_Signature) == 0)) {
				
				debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "Test si equivalent a l'equipement : [%s][%s]\n",Equipement->Adresse_Ip_Char, Signature->System_Name);
				
				debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "Mac : [%s]\n", Signature->MAC);
				if ((Signature->MAC != NULL) && (strlen (Signature->MAC) != 0))	
					if (strncmp (Signature->MAC, Equipement->Adresse_MAC_Char, 8) != 0)	
						continue;	
				debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "Test open port\n");
				if (Signature->Open_Port != -1)	
					if (Signature->Open_Port != Equipement->Nb_Port_Ouvert)
						continue;



				debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "FTP: %d    HTTP: %d    IMAP : %d    TELNET : %d\n", Signature->Etat_FTP, Signature->Etat_HTTP, Signature->Etat_IMAP, Signature->Etat_TELNET);
				Nb_Port_Pouvant_Etre_Ouvert = 0;
				Nb_Port_Pouvant_Etre_Ouvert_Fermer = 0;


				
				debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "test Etat FTP  %d\n", Signature->Etat_FTP);
				if (Signature->Etat_FTP != INDIFFERENT) {	
					if (Signature->Etat_FTP != CAN_BE_OPENED) {	
						debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "Etat FTP  %d  %d\n", Cherche_Si_Port_Ouvert (Equipement, PORT_FTP), (Signature->Etat_FTP == CLOSED));
						if ((Cherche_Si_Port_Ouvert (Equipement, PORT_FTP) == (Signature->Etat_FTP == CLOSED)))
							continue;	
					}
					else
						Nb_Port_Pouvant_Etre_Ouvert++;
					
					if ((Signature->Etat_FTP != CLOSED) && (!Compare_Entete_Equipement (Signature->Header_FTP, Equipement->Entete_FTP))) {
						
						if (Signature->Etat_FTP == CAN_BE_OPENED)
							Nb_Port_Pouvant_Etre_Ouvert_Fermer++;	
						else
							continue;	
					}
				}
				
				debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "test Etat PORT_HTTP  %d   INDIFFERENT=%d\n", Signature->Etat_HTTP,INDIFFERENT);
				if (Signature->Etat_HTTP != INDIFFERENT) {	
					if (Signature->Etat_HTTP != CAN_BE_OPENED) {	
						debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "Etat HTTP  %d  %d\n", Cherche_Si_Port_Ouvert (Equipement, PORT_HTTP), (Signature->Etat_HTTP == CLOSED));
						if ((Cherche_Si_Port_Ouvert (Equipement, PORT_HTTP) == (Signature->Etat_HTTP == CLOSED)))
							continue;	
					}
					else
						Nb_Port_Pouvant_Etre_Ouvert++;
					
					if ((Signature->Etat_HTTP != CLOSED) && (!Compare_Entete_Equipement (Signature->Header_HTTP, Equipement->Entete_HTTP))) {
						
						if (Signature->Etat_HTTP == CAN_BE_OPENED)
							Nb_Port_Pouvant_Etre_Ouvert_Fermer++;	
						else
							continue;	
					}
				}
				
				debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "test Etat PORT_IMAP  %d\n", Signature->Etat_IMAP);
				if (Signature->Etat_IMAP != INDIFFERENT) {	
					if (Signature->Etat_IMAP != CAN_BE_OPENED) {	
						debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "Etat IMAP  %d  %d\n", Cherche_Si_Port_Ouvert (Equipement, PORT_IMAP), (Signature->Etat_IMAP == CLOSED));
						if ((Cherche_Si_Port_Ouvert (Equipement, PORT_IMAP) == (Signature->Etat_IMAP == CLOSED)))
							continue;	
					}
					else
						Nb_Port_Pouvant_Etre_Ouvert++;
					
					if ((Signature->Etat_IMAP != CLOSED) && (!Compare_Entete_Equipement (Signature->Header_IMAP, Equipement->Entete_IMAP))) {
						
						if (Signature->Etat_IMAP == CAN_BE_OPENED)
							Nb_Port_Pouvant_Etre_Ouvert_Fermer++;	
						else
							continue;	
					}
				}
				
				debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "test Etat PORT_TELNET  %d\n", Signature->Etat_TELNET);
				if (Signature->Etat_TELNET != INDIFFERENT) {	
					if (Signature->Etat_TELNET != CAN_BE_OPENED) {	
						debug_printf (INTERFACE, D_ALL, __FILE__,__PRETTY_FUNCTION__, __LINE__, "Etat TELNET  %d  %d\n", Cherche_Si_Port_Ouvert (Equipement, PORT_TELNET), (Signature->Etat_TELNET == CLOSED));
						if ((Cherche_Si_Port_Ouvert (Equipement, PORT_TELNET) == (Signature->Etat_TELNET == CLOSED)))
							continue;	
					}
					else
						Nb_Port_Pouvant_Etre_Ouvert++;
					
					if ((Signature->Etat_TELNET != CLOSED) && (!Compare_Entete_Equipement (Signature->Header_TELNET, Equipement->Entete_TELNET))) {
						
						if (Signature->Etat_TELNET == CAN_BE_OPENED)
							Nb_Port_Pouvant_Etre_Ouvert_Fermer++;	
						else
							continue;	
					}
				}
				if ((Nb_Port_Pouvant_Etre_Ouvert != 0) && (Nb_Port_Pouvant_Etre_Ouvert_Fermer == Nb_Port_Pouvant_Etre_Ouvert))
					continue;	
				Signature_Equivalent = Signature;
			}
		}
	}
	return Signature_Equivalent;
}
