/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gnome.h>
#include <sys/types.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include "Execute.h"
#include "Com/Initialisation_Com.h"
#include "Debug.h"
#include "main.h"


void Execute_Programme_Externe (gchar * path, gchar * param, struct Struct_Equipement *Equipement)
{
	int       pid_fils;

	ERROR_if (path == NULL);
	ERROR_if (param == NULL);
	ERROR_if (Equipement == NULL);
	if (!g_file_exists (path)) {	
		debug_printf (INTERFACE, D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Can't find the '%s' program!", path);
		return;
	}
	pid_fils = fork ();	
	if (pid_fils == 0) {
#define VARIABLE_IP "_IP_"
#define VARIABLE_MAC "_MAC_"
		gchar     Command[255], NCommand[255], *pVariable;

		
		strcpy (Command, path);
		strcat (Command, " ");
		strcat (Command, param);
		if ((pVariable = strstr (Command, VARIABLE_IP)) != 0) {
			
			strncpy (NCommand, Command, pVariable - Command);
			NCommand[pVariable - Command] = '\0';
			
			strcat (NCommand, Equipement->Adresse_Ip_Char);
			
			strcat (NCommand, pVariable + strlen (VARIABLE_IP));
			
			strcpy (Command, NCommand);
		}
		if ((pVariable = strstr (Command, VARIABLE_MAC)) != 0) {
			strncpy (NCommand, Command, pVariable - Command);
			NCommand[pVariable - Command] = '\0';
			strcat (NCommand, Equipement->Adresse_MAC_Char);
			strcat (NCommand, pVariable + strlen (VARIABLE_MAC));
			strcpy (Command, NCommand);
		}
		
		system (Command);	
		_exit (0);
	}
}


void Lance_Nouveau_Agent_Local ()
{
	pid_t     pid_fils;
	gchar     Pid_Parent[6];	

	sprintf (Pid_Parent, "%d", Pid_AutoScan);
	pid_fils = fork ();	
	if (pid_fils == 0) {
		
		execlp ("AutoScan_Agent", "AutoScan_Agent", Pid_Parent, NULL);
		_exit (0);
	}
}

void Kill_Process_AutoScan_Agent ()
{
	
	if ((Pid_Agent_Initialisation == -1) || (Pid_Agent_Initialisation == 0))
		return;
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Arret du processus : %d", Pid_Agent_Initialisation);
	kill (Pid_Agent_Initialisation, SIGINT);
}
