/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "Add_Network_Callbacks.h"
#include "Add_Network_Interface.h"
#include "Root_Interface.h"
#include "../Add_Network_Subnet.h"
#include "../Com/Initialisation_Com.h"
#include "../Execute.h"
#include "Combo.h"
#include "../Reseau.h"
#include "../Restoration_Agent.h"
#include "../Restoration_Interface.h"
#include "../Debug.h"
#include "../Com/Commun.h"

void Modifie_Class_A ()
{
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_A, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_B, FALSE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_C, FALSE);
}

void Modifie_Class_B ()
{
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_A, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_B, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_C, FALSE);
}

void Modifie_Class_C ()
{
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_A, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_B, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_C, TRUE);
}


gboolean Add_Network_cancel (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	gtk_widget_hide (window_Add_Network);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestart_Add_Network));
	Pid_Agent_Initialisation = -1;
	return FALSE;
}


void on_druidpagestandard_Network_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{

}


gboolean on_druidpagestandard_Network_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Network_Restore)) && (strlen ((gchar *) gtk_entry_get_text (GTK_ENTRY (combo_entry_Network_Restore))) == 0))
		return TRUE;
	Enregistrement_Donnee_Xml_Subnet ();
	gtk_expander_set_expanded (GTK_EXPANDER (expander_Network_Private_Subnet), FALSE);
	return FALSE;
}


void Subnet_changed (GtkComboBox * combobox, gpointer user_data)
{
	if (!Liste_Subnet_Modification_Interface) {	
		gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, TRUE);
		gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, TRUE);
		gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
		gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, FALSE);
		Subnet_Modification = Subnet_Selectionner;
	}
}


void on_button_Network_Private_Subnet_Add_clicked (GtkButton * button, gpointer user_data)
{
	gtk_combo_box_set_active (GTK_COMBO_BOX (combobox_Network_Private_Subnet), 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_A), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_B), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_C), (gfloat) 0);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, TRUE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, TRUE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, FALSE);
	gtk_widget_set_sensitive (combobox_Network_Private_Subnet, TRUE);
	Subnet_Modification = NULL;
	Subnet_Selectionner = NULL;
}


void on_button_Network_Private_Subnet_Delete_clicked (GtkButton * button, gpointer user_data)
{
	Supprime_Subnet_liste (Subnet_Selectionner);
	gtk_combo_box_set_active (GTK_COMBO_BOX (combobox_Network_Private_Subnet), -1);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_A), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_B), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_C), (gfloat) 0);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, TRUE);
	Subnet_Sensible (FALSE);
	Subnet_Modification = NULL;
	Subnet_Selectionner = NULL;
}


void on_button_Network_Private_Subnet_OK_clicked (GtkButton * button, gpointer user_data)
{
	Modifie_Ajoute_Nouveau_Subnet ();
	gtk_combo_box_set_active (GTK_COMBO_BOX (combobox_Network_Private_Subnet), -1);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_A), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_B), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_C), (gfloat) 0);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, TRUE);
	Subnet_Sensible (FALSE);
	Subnet_Modification = NULL;
	Subnet_Selectionner = NULL;
}


void on_button_Network_Private_Subnet_Cancel_clicked (GtkButton * button, gpointer user_data)
{
	gtk_combo_box_set_active (GTK_COMBO_BOX (combobox_Network_Private_Subnet), -1);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_A), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_B), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_C), (gfloat) 0);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, TRUE);
	Subnet_Sensible (FALSE);
	Subnet_Modification = NULL;
	Subnet_Selectionner = NULL;
}


void on_radiobutton_Network_New_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_set_sensitive (fileentry_Network_Restore, FALSE);
	gtk_widget_set_sensitive (entry_Network_New_Name, TRUE);
	gtk_widget_set_sensitive (iconentry_Network_New, TRUE);
	gtk_widget_set_sensitive (expander_Network_Private_Subnet, TRUE);
	gtk_widget_set_sensitive (entry_Network_SNMP, TRUE);
}

void on_radiobutton_Select_Network_Restore_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_set_sensitive (fileentry_Network_Restore, TRUE);
	gtk_widget_set_sensitive (entry_Network_New_Name, FALSE);
	gtk_widget_set_sensitive (iconentry_Network_New, FALSE);
	gtk_widget_set_sensitive (expander_Network_Private_Subnet, FALSE);
	gtk_expander_set_expanded (GTK_EXPANDER (expander_Network_Private_Subnet), FALSE);
	gtk_widget_set_sensitive (entry_Network_SNMP, FALSE);
}


void on_druidpagestandard_Localisation_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{

}


gboolean on_druidpagestandard_Localisation_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	Efface_Toute_Interface_Combo ();	
	
	gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Initialize), _("Connecting"));
	gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progressbar_Initialize), 0);
	Agent_Initialiser = FALSE;
	AutoRestore = FALSE;
	Lance_Nouveau_Agent_Local ();
	return FALSE;
}


void on_radiobutton__Select_Network_Local_clicked (GtkButton * button, gpointer user_data)
{

}


void on_radiobutton_Select_Network_Connect_clicked (GtkButton * button, gpointer user_data)
{

}


void on_druidpagestandard_Initialize_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{

}


gboolean on_druidpagestandard_Initialize_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	return !Agent_Initialiser;
}


gboolean on_druidpagestandard_Initialize_back (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	Kill_Process_AutoScan_Agent ();
	return FALSE;
}


gboolean Add_Network_Destroy_Agent_cancel (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	Kill_Process_AutoScan_Agent ();
	gtk_widget_hide (window_Add_Network);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestart_Add_Network));
	Pid_Agent_Initialisation = -1;
	return FALSE;
}


gboolean on_druidpagestandard_Select_Interface_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	return FALSE;
}


void on_druidpagefinish_Add_Network_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
#define TEXTE "Confirm the following information: \n\nName Network : %s\nInterface : %s\n"
	gchar    *text, *Interface_IP, *Index_Fin_Nom_Reseau;

	Interface_IP = Recuperation_Texte_Combo (combobox_Select_Interface);
	ERROR_if (Interface_IP == NULL);
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Network_Restore))) {
		if ((Index_Fin_Nom_Reseau = index (Nom_Reseau_Restauration, '-')) != NULL)	
			Nom_Reseau_Restauration[Index_Fin_Nom_Reseau - Nom_Reseau_Restauration] = '\0';
		
		while (Nom_Reseau_Restauration[strlen (Nom_Reseau_Restauration) - 1] == 0x20) {
			Nom_Reseau_Restauration[strlen (Nom_Reseau_Restauration) - 1] = 0;
		}
		text = g_strdup_printf (TEXTE, Nom_Reseau_Restauration, Interface_IP);
	}
	else
		text = g_strdup_printf (TEXTE, gtk_entry_get_text (GTK_ENTRY (entry_Network_New_Name)), Interface_IP);
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_Network), text);
	g_free (Interface_IP);	
	g_free (text);
}


void on_druidpagefinish_Add_Network_finish (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	gchar    *Interface, *Ip;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct struct_Active_Alerte_Intrus Message_Active;

	Interface = Recuperation_Chaine_Attacher_Combo (combobox_Select_Interface);
	Ip = Recuperation_Chaine2_Attacher_Combo (combobox_Select_Interface);
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Network_Restore))) {
		Reseau = Creation_Nouveau_Reseau (g_strdup(Nom_Reseau_Restauration), g_strdup(Interface), g_strdup(Ip), g_strdup(Communaute_Snmp_Restauration), g_strdup (Icon_Restauration));	
		if (Reseau != NULL) {
			Copie_Subnet (Reseau, Subnet_Restauration);	
			Reseau->Alert_Intrusion = Intrusion_Alert_Restauration;	
		}
	}
	else {
		Reseau = Creation_Nouveau_Reseau ((gchar *) gtk_entry_get_text (GTK_ENTRY (entry_Network_New_Name)), Interface, Ip, (gchar *) gtk_entry_get_text (GTK_ENTRY (entry_Network_SNMP)), gnome_icon_entry_get_filename (GNOME_ICON_ENTRY (iconentry_Network_New)));
		if (Reseau != NULL)
			Copie_Subnet (Reseau, GList_Subnet);	
	}
	gtk_widget_hide (window_Add_Network);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestart_Add_Network));
	
	if ((Reseau != NULL) && (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Network_Restore)))) {	
		Restoration_Interface ((gchar *) gtk_entry_get_text (GTK_ENTRY (combo_entry_Network_Restore)), Reseau->Id_Reseau);
	}
	Pid_Agent_Initialisation = -1;
	if (Reseau != NULL) {
		gtk_widget_set_sensitive (toolbutton_Save, TRUE);
		gtk_widget_set_sensitive (toolbutton_Search, TRUE);
		gtk_widget_set_sensitive (toggletoolbutton_Alert_Intrusion, TRUE);
		if ((Reseau_Selectionner == Reseau) && (Intrusion_Alert_Restauration)) {
			
			Modification_Toggle_En_Cours = TRUE;
			gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Alert_Intrusion), Reseau_Selectionner->Alert_Intrusion);
			Modification_Toggle_En_Cours = FALSE;
			bzero (&Message_Active, sizeof (struct struct_Active_Alerte_Intrus));
			Message_Active.ID_Reseau = Reseau->Id_Reseau;
			Communication_Envoie_Donnee (Reseau->Pid_Agent, ACTIVE_ALERTE_INTRUS, (gpointer *) & Message_Active, sizeof (Message_Active), Reseau);
		}
	}
}


void on_window_Add_Network_destroy (GtkObject * object, gpointer user_data)
{
	if (Pid_Agent_Initialisation != -1)
		Kill_Process_AutoScan_Agent ();
	create_window_Add_Network ();
	Afficher_Liste_Subnet ();
}
