/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <bonobo.h>
#include <gnome.h>

#include "Add_Network_Callbacks.h"
#include "Add_Network_Interface.h"
#include "../Declaration_Constante.h"
#include "Root_Interface.h"
#include "../Gconf.h"
#include "Combo.h"
#include "../Add_Network_Subnet.h"
#include "../Com/Initialisation_Com.h"

GtkWidget *create_window_Add_Network (void)
{
	GdkColor  druidpagestart_Add_Network_bg_color = { 0, 26471, 36237, 45745 };
	GdkColor  druidpagestart_Add_Network_textbox_color = { 0, 65535, 65535, 65535 };
	GdkColor  druidpagestart_Add_Network_logo_bg_color = { 0, 26471, 36237, 45745 };
	GdkColor  druidpagestandard_Network_bg_color = { 0, 26471, 36237, 45745 };	
	GdkColor  druidpagestandard_Network_logo_bg_color = { 0, 26471, 36237, 45745 };	
	GSList   *radiobutton_Network_New_group = NULL;
	GdkColor  druidpagestandard_Localisation_bg_color = { 0, 26471, 36237, 45745 };	
	GdkColor  druidpagestandard_Localisation_logo_bg_color = { 0, 26471, 36237, 45745 };	
	GSList   *radiobutton_Localisation_Localhost_group = NULL;
	GdkColor  druidpagestandard_Initialize_bg_color = { 0, 26471, 36237, 45745 };	
	GdkColor  druidpagestandard_Initialize_logo_bg_color = { 0, 26471, 36237, 45745 };	
	GdkColor  druidpagestandard_Select_Interface_bg_color = { 0, 26471, 36237, 45745 };	
	GdkColor  druidpagestandard_Select_Interface_logo_bg_color = { 0, 26471, 36237, 45745 };	
	GdkColor  druidpagefinish_Add_Network_bg_color = { 0, 26471, 36237, 45745 };
	GdkColor  druidpagefinish_Add_Network_textbox_color = { 0, 65535, 65535, 65535 };
	GdkColor  druidpagefinish_Add_Network_logo_bg_color = { 0, 26471, 36237, 45745 };


	window_Add_Network = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window_Add_Network), _("Wizard"));
	gtk_window_set_modal (GTK_WINDOW (window_Add_Network), TRUE);
	gtk_window_set_resizable (GTK_WINDOW (window_Add_Network), FALSE);
	gtk_window_set_position (GTK_WINDOW (window_Add_Network), GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_transient_for (GTK_WINDOW (window_Add_Network), GTK_WINDOW (window_root));
	gtk_window_set_modal (GTK_WINDOW (window_Add_Network), TRUE);

	druid_Add_Network = gnome_druid_new ();
	gtk_widget_show (druid_Add_Network);
	gtk_container_add (GTK_CONTAINER (window_Add_Network), druid_Add_Network);
	gtk_container_set_border_width (GTK_CONTAINER (druid_Add_Network), 4);

	druidpagestart_Add_Network = gnome_druid_page_edge_new (GNOME_EDGE_START);
	gtk_widget_show (druidpagestart_Add_Network);
	gnome_druid_append_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestart_Add_Network));
	gnome_druid_page_edge_set_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_Network), &druidpagestart_Add_Network_bg_color);
	gnome_druid_page_edge_set_textbox_color (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_Network), &druidpagestart_Add_Network_textbox_color);
	gnome_druid_page_edge_set_logo_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_Network), &druidpagestart_Add_Network_logo_bg_color);
	gnome_druid_page_edge_set_title (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_Network), _("Network Wizard"));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_Network), _("This Wizard will add a network"));
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_edge_set_logo (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_Network), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}

	druidpagestandard_Network = gnome_druid_page_standard_new ();
	gtk_widget_show_all (druidpagestandard_Network);
	gnome_druid_append_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestandard_Network));
	gnome_druid_page_standard_set_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Network), &druidpagestandard_Network_bg_color);
	gnome_druid_page_standard_set_logo_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Network), &druidpagestandard_Network_logo_bg_color);
	gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Network), _("Network"));
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_standard_set_logo (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Network), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}

	druid_vbox_Network = GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Network)->vbox;
	gtk_widget_show (druid_vbox_Network);
	gtk_container_set_border_width (GTK_CONTAINER (druid_vbox_Network), 4);

	vbox_Network = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Network);
	gtk_box_pack_start (GTK_BOX (druid_vbox_Network), vbox_Network, TRUE, TRUE, 0);

	frame_Network_New = gtk_frame_new (NULL);
	gtk_widget_show (frame_Network_New);
	gtk_box_pack_start (GTK_BOX (vbox_Network), frame_Network_New, FALSE, TRUE, 4);

	vbox_Network_New = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Network_New);
	gtk_container_add (GTK_CONTAINER (frame_Network_New), vbox_Network_New);
	gtk_container_set_border_width (GTK_CONTAINER (vbox_Network_New), 4);

	hbox_Network_New_Name = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Network_New_Name);
	gtk_box_pack_start (GTK_BOX (vbox_Network_New), hbox_Network_New_Name, FALSE, TRUE, 0);

	label_Network_New_Name = gtk_label_new (_("Name"));
	gtk_widget_show (label_Network_New_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Network_New_Name), label_Network_New_Name, FALSE, TRUE, 0);

	entry_Network_New_Name = gtk_entry_new ();
	gtk_widget_show (entry_Network_New_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Network_New_Name), entry_Network_New_Name, TRUE, TRUE, 14);
	gtk_entry_set_text (GTK_ENTRY (entry_Network_New_Name), _("Local network"));

	iconentry_Network_New = gnome_icon_entry_new (NULL, NULL);
	gtk_widget_show (iconentry_Network_New);
	gtk_box_pack_start (GTK_BOX (hbox_Network_New_Name), iconentry_Network_New, FALSE, TRUE, 0);
	gtk_widget_set_size_request (iconentry_Network_New, 30, 30);
	gnome_icon_entry_set_pixmap_subdir (GNOME_ICON_ENTRY (iconentry_Network_New), "/usr/share/pixmaps/AutoScan/Network/");
	gnome_icon_entry_set_filename (GNOME_ICON_ENTRY (iconentry_Network_New), Lecture_Gconf_Char (CHAR_WIZARD_ICON_NETWORK));

	expander_Network_Private_Subnet = gtk_expander_new (NULL);
	gtk_widget_show (expander_Network_Private_Subnet);
	gtk_box_pack_start (GTK_BOX (vbox_Network_New), expander_Network_Private_Subnet, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (expander_Network_Private_Subnet), 3);

	vbox_Network_Private_Subnet = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Network_Private_Subnet);
	gtk_container_add (GTK_CONTAINER (expander_Network_Private_Subnet), vbox_Network_Private_Subnet);

	scrolledwindow_Network_Private_Subnet = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Network_Private_Subnet);
	gtk_box_pack_start (GTK_BOX (vbox_Network_Private_Subnet), scrolledwindow_Network_Private_Subnet, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Network_Private_Subnet), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_Network_Private_Subnet), GTK_SHADOW_ETCHED_IN);


	Create_Liste_Subnet ();
	gtk_widget_show (treeview_Network_Private_Subnet);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Network_Private_Subnet), treeview_Network_Private_Subnet);

	hbox_Network_Private_Subnet_Modif = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Network_Private_Subnet_Modif);
	gtk_box_pack_start (GTK_BOX (vbox_Network_Private_Subnet), hbox_Network_Private_Subnet_Modif, FALSE, TRUE, 5);

	combobox_Network_Private_Subnet = creation_combo (FALSE);	
	creation_combo_class();
	gtk_widget_show (combobox_Network_Private_Subnet);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Modif), combobox_Network_Private_Subnet, TRUE, TRUE, 18);
	gtk_widget_set_sensitive (combobox_Network_Private_Subnet, FALSE);


	fixed_Network_Private_Subnet_Milieu = gtk_fixed_new ();
	gtk_widget_show (fixed_Network_Private_Subnet_Milieu);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Modif), fixed_Network_Private_Subnet_Milieu, TRUE, TRUE, 0);

	spinbutton_Network_Private_Subnet_A_adj = gtk_adjustment_new (0, 0, 255, 1, 10, 10);
	spinbutton_Network_Private_Subnet_A = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Network_Private_Subnet_A_adj), 1, 0);
	gtk_widget_show (spinbutton_Network_Private_Subnet_A);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Modif), spinbutton_Network_Private_Subnet_A, FALSE, TRUE, 8);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_A, FALSE);
	gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_A), TRUE);

	spinbutton_Network_Private_Subnet_B_adj = gtk_adjustment_new (0, 0, 255, 1, 10, 10);
	spinbutton_Network_Private_Subnet_B = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Network_Private_Subnet_B_adj), 1, 0);
	gtk_widget_show (spinbutton_Network_Private_Subnet_B);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Modif), spinbutton_Network_Private_Subnet_B, FALSE, TRUE, 8);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_B, FALSE);
	gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_B), TRUE);

	spinbutton_Network_Private_Subnet_C_adj = gtk_adjustment_new (0, 0, 255, 1, 10, 10);
	spinbutton_Network_Private_Subnet_C = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Network_Private_Subnet_C_adj), 1, 0);
	gtk_widget_show (spinbutton_Network_Private_Subnet_C);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Modif), spinbutton_Network_Private_Subnet_C, FALSE, TRUE, 8);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_C, FALSE);
	gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_C), TRUE);

	fixed_Network_Private_Subnet_Droite = gtk_fixed_new ();
	gtk_widget_show (fixed_Network_Private_Subnet_Droite);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Modif), fixed_Network_Private_Subnet_Droite, TRUE, TRUE, 0);

	hbox_Network_Private_Subnet_Button = gtk_hbox_new (TRUE, 0);
	gtk_widget_show (hbox_Network_Private_Subnet_Button);
	gtk_box_pack_start (GTK_BOX (vbox_Network_Private_Subnet), hbox_Network_Private_Subnet_Button, FALSE, TRUE, 5);

	button_Network_Private_Subnet_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Network_Private_Subnet_Add);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Button), button_Network_Private_Subnet_Add, FALSE, TRUE, 8);

	button_Network_Private_Subnet_Delete = gtk_button_new_from_stock ("gtk-delete");
	gtk_widget_show (button_Network_Private_Subnet_Delete);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Button), button_Network_Private_Subnet_Delete, FALSE, TRUE, 8);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);

	button_Network_Private_Subnet_OK = gtk_button_new_from_stock ("gtk-ok");
	gtk_widget_show (button_Network_Private_Subnet_OK);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Button), button_Network_Private_Subnet_OK, FALSE, TRUE, 8);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, FALSE);

	button_Network_Private_Subnet_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Network_Private_Subnet_Cancel);
	gtk_box_pack_start (GTK_BOX (hbox_Network_Private_Subnet_Button), button_Network_Private_Subnet_Cancel, FALSE, TRUE, 8);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, FALSE);

	label_Network_Private_Subnet = gtk_label_new (_("Private subnet"));
	gtk_widget_show (label_Network_Private_Subnet);
	gtk_expander_set_label_widget (GTK_EXPANDER (expander_Network_Private_Subnet), label_Network_Private_Subnet);

	hbox_Network_SNMP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Network_SNMP);
	gtk_box_pack_start (GTK_BOX (vbox_Network_New), hbox_Network_SNMP, TRUE, TRUE, 0);

	label_Network_SNMP = gtk_label_new (_("SNMP community name : "));
	gtk_widget_show (label_Network_SNMP);
	gtk_box_pack_start (GTK_BOX (hbox_Network_SNMP), label_Network_SNMP, FALSE, FALSE, 0);

	entry_Network_SNMP = gtk_entry_new ();
	gtk_widget_show (entry_Network_SNMP);
	gtk_box_pack_start (GTK_BOX (hbox_Network_SNMP), entry_Network_SNMP, FALSE, TRUE, 5);
	gtk_entry_set_text (GTK_ENTRY (entry_Network_SNMP), _("public"));



	radiobutton_Network_New = gtk_radio_button_new_with_mnemonic (NULL, _("New"));
	gtk_widget_show (radiobutton_Network_New);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Network_New), radiobutton_Network_New);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Network_New), radiobutton_Network_New_group);
	radiobutton_Network_New_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Network_New));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_Network_New), TRUE);

	frame_Network_Restore = gtk_frame_new (NULL);
	gtk_widget_show (frame_Network_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Network), frame_Network_Restore, FALSE, TRUE, 0);

	fileentry_Network_Restore = gnome_file_entry_new (NULL, _("Restore"));
	gtk_widget_show (fileentry_Network_Restore);
	gtk_container_add (GTK_CONTAINER (frame_Network_Restore), fileentry_Network_Restore);
	gtk_container_set_border_width (GTK_CONTAINER (fileentry_Network_Restore), 8);
	gnome_file_entry_set_modal (GNOME_FILE_ENTRY (fileentry_Network_Restore), TRUE);
	g_object_set (G_OBJECT (fileentry_Network_Restore), "use_filechooser", TRUE, "filechooser_action", GTK_FILE_CHOOSER_ACTION_OPEN, NULL);

	combo_entry_Network_Restore = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (fileentry_Network_Restore));
	gtk_widget_show (combo_entry_Network_Restore);

	radiobutton_Network_Restore = gtk_radio_button_new_with_mnemonic (NULL, _("Restore"));
	gtk_widget_show (radiobutton_Network_Restore);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Network_Restore), radiobutton_Network_Restore);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Network_Restore), radiobutton_Network_New_group);
	radiobutton_Network_New_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Network_Restore));

	druidpagestandard_Localisation = gnome_druid_page_standard_new ();
	gtk_widget_show_all (druidpagestandard_Localisation);
	gnome_druid_append_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestandard_Localisation));
	gnome_druid_page_standard_set_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Localisation), &druidpagestandard_Localisation_bg_color);
	gnome_druid_page_standard_set_logo_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Localisation), &druidpagestandard_Localisation_logo_bg_color);
	gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Localisation), _("Where is located the network"));
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_standard_set_logo (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Localisation), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}

	druid_vbox_Localisation = GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Localisation)->vbox;
	gtk_widget_show (druid_vbox_Localisation);
	gtk_container_set_border_width (GTK_CONTAINER (druid_vbox_Localisation), 4);

	vbox_Localisation = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Localisation);
	gtk_box_pack_start (GTK_BOX (druid_vbox_Localisation), vbox_Localisation, TRUE, TRUE, 0);

	hbox_Localisation_Localhost = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Localisation_Localhost);
	gtk_box_pack_start (GTK_BOX (vbox_Localisation), hbox_Localisation_Localhost, FALSE, FALSE, 0);

	radiobutton_Localisation_Localhost = gtk_radio_button_new_with_mnemonic (NULL, _("Localhost"));
	gtk_widget_show (radiobutton_Localisation_Localhost);
	gtk_box_pack_start (GTK_BOX (hbox_Localisation_Localhost), radiobutton_Localisation_Localhost, FALSE, FALSE, 5);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Localisation_Localhost), radiobutton_Localisation_Localhost_group);
	radiobutton_Localisation_Localhost_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Localisation_Localhost));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_Localisation_Localhost), TRUE);

	frame_Localisation_Connect = gtk_frame_new (NULL);
	gtk_widget_show (frame_Localisation_Connect);
	gtk_box_pack_start (GTK_BOX (vbox_Localisation), frame_Localisation_Connect, FALSE, TRUE, 0);

	vbox_Localisation_Connect = gtk_vbox_new (TRUE, 0);
	gtk_widget_show (vbox_Localisation_Connect);
	gtk_container_add (GTK_CONTAINER (frame_Localisation_Connect), vbox_Localisation_Connect);
	gtk_container_set_border_width (GTK_CONTAINER (vbox_Localisation_Connect), 3);

	hbox_Localisation_Connect_Haut = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Localisation_Connect_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Localisation_Connect), hbox_Localisation_Connect_Haut, FALSE, TRUE, 3);

	label_Localisation_Connect_Ip_Address = gtk_label_new (_("Ip Address"));
	gtk_widget_show (label_Localisation_Connect_Ip_Address);
	gtk_box_pack_start (GTK_BOX (hbox_Localisation_Connect_Haut), label_Localisation_Connect_Ip_Address, FALSE, TRUE, 4);

	entry_Localisation_Connect_Ip_Address = gtk_entry_new ();
	gtk_widget_show (entry_Localisation_Connect_Ip_Address);
	gtk_box_pack_start (GTK_BOX (hbox_Localisation_Connect_Haut), entry_Localisation_Connect_Ip_Address, FALSE, TRUE, 0);
	gtk_widget_set_sensitive (entry_Localisation_Connect_Ip_Address, FALSE);

	label_Localisation_Connect_Port = gtk_label_new (_("Port"));
	gtk_widget_show (label_Localisation_Connect_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Localisation_Connect_Haut), label_Localisation_Connect_Port, FALSE, FALSE, 19);

	spinbutton_Localisation_Connect_Port_adj = gtk_adjustment_new (4555, 0, 65535, 1, 10, 10);
	spinbutton_Localisation_Connect_Port = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Localisation_Connect_Port_adj), 1, 0);
	gtk_widget_show (spinbutton_Localisation_Connect_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Localisation_Connect_Haut), spinbutton_Localisation_Connect_Port, FALSE, TRUE, 0);
	gtk_widget_set_sensitive (spinbutton_Localisation_Connect_Port, FALSE);

	hbox_Localisation_Connect_Bas = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Localisation_Connect_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Localisation_Connect), hbox_Localisation_Connect_Bas, FALSE, TRUE, 0);

	label_Localisation_Connect_User = gtk_label_new (_("User"));
	gtk_widget_show (label_Localisation_Connect_User);
	gtk_box_pack_start (GTK_BOX (hbox_Localisation_Connect_Bas), label_Localisation_Connect_User, FALSE, TRUE, 19);

	entry_Localisation_Connect_User = gtk_entry_new ();
	gtk_widget_show (entry_Localisation_Connect_User);
	gtk_box_pack_start (GTK_BOX (hbox_Localisation_Connect_Bas), entry_Localisation_Connect_User, FALSE, TRUE, 0);
	gtk_widget_set_sensitive (entry_Localisation_Connect_User, FALSE);

	label_Localisation_Connect_Password = gtk_label_new (_("Password"));
	gtk_widget_show (label_Localisation_Connect_Password);
	gtk_box_pack_start (GTK_BOX (hbox_Localisation_Connect_Bas), label_Localisation_Connect_Password, FALSE, FALSE, 6);

	entry_Localisation_Connect_Password = gtk_entry_new ();
	gtk_widget_show (entry_Localisation_Connect_Password);
	gtk_box_pack_start (GTK_BOX (hbox_Localisation_Connect_Bas), entry_Localisation_Connect_Password, FALSE, TRUE, 0);
	gtk_widget_set_sensitive (entry_Localisation_Connect_Password, FALSE);
	gtk_entry_set_visibility (GTK_ENTRY (entry_Localisation_Connect_Password), FALSE);

	radiobutton_Localisation_Connect = gtk_radio_button_new_with_mnemonic (NULL, _("Connect to host (Not Implemented)"));
	gtk_widget_show (radiobutton_Localisation_Connect);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Localisation_Connect), radiobutton_Localisation_Connect);
	gtk_widget_set_sensitive (radiobutton_Localisation_Connect, FALSE);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Localisation_Connect), radiobutton_Localisation_Localhost_group);
	radiobutton_Localisation_Localhost_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Localisation_Connect));

	druidpagestandard_Initialize = gnome_druid_page_standard_new ();
	gtk_widget_show_all (druidpagestandard_Initialize);
	gnome_druid_append_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestandard_Initialize));
	gnome_druid_page_standard_set_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Initialize), &druidpagestandard_Initialize_bg_color);
	gnome_druid_page_standard_set_logo_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Initialize), &druidpagestandard_Initialize_logo_bg_color);
	gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Initialize), _("Initialize the Agent"));
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_standard_set_logo (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Initialize), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}

	druid_vbox_Initialize = GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Initialize)->vbox;
	gtk_widget_show (druid_vbox_Initialize);
	gtk_container_set_border_width (GTK_CONTAINER (druid_vbox_Initialize), 4);

	vbox_Initialize = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Initialize);
	gtk_box_pack_start (GTK_BOX (druid_vbox_Initialize), vbox_Initialize, TRUE, FALSE, 0);

	label_Initialize = gtk_label_new (_("please wait ..."));
	gtk_widget_show (label_Initialize);
	gtk_box_pack_start (GTK_BOX (vbox_Initialize), label_Initialize, FALSE, FALSE, 14);

	progressbar_Initialize = gtk_progress_bar_new ();
	gtk_widget_show (progressbar_Initialize);
	gtk_box_pack_start (GTK_BOX (vbox_Initialize), progressbar_Initialize, TRUE, FALSE, 11);
	gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Initialize), _("Connecting"));

	druidpagestandard_Select_Interface = gnome_druid_page_standard_new ();
	gtk_widget_show_all (druidpagestandard_Select_Interface);
	gnome_druid_append_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestandard_Select_Interface));
	gnome_druid_page_standard_set_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Select_Interface), &druidpagestandard_Select_Interface_bg_color);
	gnome_druid_page_standard_set_logo_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Select_Interface), &druidpagestandard_Select_Interface_logo_bg_color);
	gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Select_Interface), _("Select the Network Interface"));
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_standard_set_logo (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Select_Interface), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}

	druid_vbox_Select_Interface = GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Select_Interface)->vbox;
	gtk_widget_show (druid_vbox_Select_Interface);
	gtk_container_set_border_width (GTK_CONTAINER (druid_vbox_Select_Interface), 40);

	hbox_Select_Interface = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Select_Interface);
	gtk_box_pack_start (GTK_BOX (druid_vbox_Select_Interface), hbox_Select_Interface, FALSE, TRUE, 19);

	label_Select_Interface = gtk_label_new (_("Interface"));
	gtk_widget_show (label_Select_Interface);
	gtk_box_pack_start (GTK_BOX (hbox_Select_Interface), label_Select_Interface, FALSE, FALSE, 35);

	combobox_Select_Interface = creation_combo (FALSE);	
	gtk_widget_show (combobox_Select_Interface);
	gtk_box_pack_start (GTK_BOX (hbox_Select_Interface), combobox_Select_Interface, FALSE, TRUE, 0);
	druidpagefinish_Add_Network = gnome_druid_page_edge_new (GNOME_EDGE_FINISH);
	gtk_widget_show (druidpagefinish_Add_Network);
	gnome_druid_append_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagefinish_Add_Network));
	gnome_druid_page_edge_set_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_Network), &druidpagefinish_Add_Network_bg_color);
	gnome_druid_page_edge_set_textbox_color (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_Network), &druidpagefinish_Add_Network_textbox_color);
	gnome_druid_page_edge_set_logo_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_Network), &druidpagefinish_Add_Network_logo_bg_color);
	gnome_druid_page_edge_set_title (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_Network), _("Summary"));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_Network), _("Confirm the following information:\n\nName Network : \nInterface :\n"));
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_edge_set_logo (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_Network), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}



	g_signal_connect ((gpointer) window_Add_Network, "destroy", G_CALLBACK (on_window_Add_Network_destroy), NULL);
	g_signal_connect ((gpointer) druidpagestart_Add_Network, "cancel", G_CALLBACK (Add_Network_cancel), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Network, "prepare", G_CALLBACK (on_druidpagestandard_Network_prepare), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Network, "next", G_CALLBACK (on_druidpagestandard_Network_next), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Network, "cancel", G_CALLBACK (Add_Network_cancel), NULL);
	g_signal_connect ((gpointer) combobox_Network_Private_Subnet, "changed", G_CALLBACK (Subnet_changed), NULL);
	g_signal_connect ((gpointer) spinbutton_Network_Private_Subnet_A, "changed", G_CALLBACK (Subnet_changed), NULL);
	g_signal_connect ((gpointer) spinbutton_Network_Private_Subnet_B, "changed", G_CALLBACK (Subnet_changed), NULL);
	g_signal_connect ((gpointer) spinbutton_Network_Private_Subnet_C, "changed", G_CALLBACK (Subnet_changed), NULL);
	g_signal_connect ((gpointer) button_Network_Private_Subnet_Add, "clicked", G_CALLBACK (on_button_Network_Private_Subnet_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Network_Private_Subnet_Delete, "clicked", G_CALLBACK (on_button_Network_Private_Subnet_Delete_clicked), NULL);
	g_signal_connect ((gpointer) button_Network_Private_Subnet_OK, "clicked", G_CALLBACK (on_button_Network_Private_Subnet_OK_clicked), NULL);
	g_signal_connect ((gpointer) button_Network_Private_Subnet_Cancel, "clicked", G_CALLBACK (on_button_Network_Private_Subnet_Cancel_clicked), NULL);
	g_signal_connect ((gpointer) radiobutton_Network_Restore, "clicked", G_CALLBACK (on_radiobutton_Select_Network_Restore_clicked), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Localisation, "prepare", G_CALLBACK (on_druidpagestandard_Localisation_prepare), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Localisation, "next", G_CALLBACK (on_druidpagestandard_Localisation_next), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Localisation, "cancel", G_CALLBACK (Add_Network_cancel), NULL);
	g_signal_connect ((gpointer) radiobutton_Localisation_Localhost, "clicked", G_CALLBACK (on_radiobutton__Select_Network_Local_clicked), NULL);
	g_signal_connect ((gpointer) radiobutton_Localisation_Connect, "clicked", G_CALLBACK (on_radiobutton_Select_Network_Connect_clicked), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Initialize, "prepare", G_CALLBACK (on_druidpagestandard_Initialize_prepare), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Initialize, "next", G_CALLBACK (on_druidpagestandard_Initialize_next), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Initialize, "back", G_CALLBACK (on_druidpagestandard_Initialize_back), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Initialize, "cancel", G_CALLBACK (Add_Network_Destroy_Agent_cancel), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Select_Interface, "next", G_CALLBACK (on_druidpagestandard_Select_Interface_next), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Select_Interface, "cancel", G_CALLBACK (Add_Network_Destroy_Agent_cancel), NULL);
	g_signal_connect ((gpointer) druidpagefinish_Add_Network, "prepare", G_CALLBACK (on_druidpagefinish_Add_Network_prepare), NULL);
	g_signal_connect ((gpointer) druidpagefinish_Add_Network, "finish", G_CALLBACK (on_druidpagefinish_Add_Network_finish), NULL);
	g_signal_connect ((gpointer) druidpagefinish_Add_Network, "cancel", G_CALLBACK (Add_Network_Destroy_Agent_cancel), NULL);
	g_signal_connect ((gpointer) radiobutton_Network_New, "clicked", G_CALLBACK (on_radiobutton_Network_New_clicked), NULL);
	Pid_Agent_Initialisation = -1;	
	gtk_widget_set_sensitive (fileentry_Network_Restore, FALSE);
	return window_Add_Network;
}
