/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "Fingerprinting_Callbacks.h"
#include "Fingerprinting_Interface.h"
#include "../Objet.h"
#include "../Equipement.h"
#include "../Gconf.h"
#include "../Contribution.h"
#include "../Equipement.h"
#include "../Settings_Signature.h"
#include "../Debug.h"
#include "../Thread.h"
#include "Combo.h"


void on_Wizard_Add_OS_Fingerprinting_destroy (GtkObject * object, gpointer user_data)
{
	create_Wizard_Add_OS_Fingerprinting ();
}


gboolean Add_OS_Fingerprinting_cancel (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	gtk_widget_hide (Wizard_Add_OS_Fingerprinting);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestart_Add_OS_Fingerprinting));
	gtk_entry_set_text (GTK_ENTRY (entry_Information_OS_System_Name), "");
	return FALSE;
}


void on_druidpagestandard_Information_OS_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Prepare info OS : %s", Equipement_Selectionner->Adresse_Ip_Char);
	gtk_entry_set_text (GTK_ENTRY (entry_Information_MD5), Equipement_Selectionner->Md5_Signature);
	gnome_icon_entry_set_filename (GNOME_ICON_ENTRY (iconentry_Information_Icon), "/usr/share/pixmaps/AutoScan/Equipment/");
}

gboolean on_druidpagestandard_Information_OS_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	return (strlen (gtk_entry_get_text (GTK_ENTRY (entry_Information_OS_System_Name))) == 0);
}

gboolean on_druidpagestandard_Contribute_OS_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Contribute_OS_Not_Submit)))
		gnome_druid_set_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagefinish_Add_OS_Fingerprinting));
	return FALSE;
}


void on_druidpagefinish_Add_OS_Fingerprinting_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
#define TEXTE "\n\n\nConfirm the following information: \n\nSystem Name : %s\nType : %s\n\n\n\n\nThis data allows you to contribute new equipment fingerprint \nto the AutoScan database. By submitting fingerprints you are\ntransfering any copyright interest in the data to tlagarde@users.sourceforge.net\nThese data can be to modify,relicense or incorporate into programs like AutoScan."
	gchar    *text, *combo;

	combo = Recuperation_Texte_Combo (combobox_Information_OS_Type);
	text = g_strdup_printf (TEXTE, gtk_entry_get_text (GTK_ENTRY (entry_Information_OS_System_Name)), combo);
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), text);
	g_free (combo);		
	g_free (text);
}


void on_druidpagefinish_Add_OS_Fingerprinting_finish (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	Etat_Contribution = CONTRIBUTION_DEBUT;
	Creation_Thread (Thread_Contribution_Fingerprinting, NULL);
	while (Etat_Contribution==CONTRIBUTION_DEBUT) 
		sleep(1);
	Rajouter_Nouvelle_Signature ((gchar *) gtk_entry_get_text (GTK_ENTRY (entry_Information_OS_System_Name)), Equipement_Selectionner->Md5_Signature, gtk_combo_box_get_active (GTK_COMBO_BOX (combobox_Information_OS_Type)), gnome_icon_entry_get_filename (GNOME_ICON_ENTRY (iconentry_Information_Icon)), Equipement_Selectionner->Entete_FTP, Equipement_Selectionner->Entete_HTTP, Equipement_Selectionner->Entete_IMAP, Equipement_Selectionner->Entete_TELNET);
	gtk_widget_hide (Wizard_Add_OS_Fingerprinting);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestart_Add_OS_Fingerprinting));
	gtk_entry_set_text (GTK_ENTRY (entry_Information_OS_System_Name), "");
	Parcours_Equipement_Inconnu (Equipement_Selectionner->Md5_Signature);
}
