/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gnome.h>

#include "Fingerprinting_Callbacks.h"
#include "Fingerprinting_Interface.h"
#include "Settings_Callbacks.h"	
#include "../Declaration_Constante.h"
#include "Root_Interface.h"
#include "Combo.h"

void create_Wizard_Add_OS_Fingerprinting (void)
{
	GdkColor  druidpagestart_Add_OS_Fingerprinting_bg_color = { 0, 26471, 36237, 45745 };
	GdkColor  druidpagestart_Add_OS_Fingerprinting_textbox_color = { 0, 65535, 65535, 65535 };
	GdkColor  druidpagestart_Add_OS_Fingerprinting_logo_bg_color = { 0, 26471, 36237, 45745 };
	GdkColor  druidpagestandard_Information_OS_bg_color = { 0, 26471, 36237, 45745 };	//{ 0, 1, 0, 37968 };
	GdkColor  druidpagestandard_Information_OS_logo_bg_color = { 0, 26471, 36237, 45745 };	//{ 0, 31080, 2080, 0 };
	GdkColor  druidpagefinish_Add_OS_Fingerprinting_bg_color = { 0, 26471, 36237, 45745 };
	GdkColor  druidpagefinish_Add_OS_Fingerprinting_logo_bg_color = { 0, 26471, 36237, 45745 };

	Wizard_Add_OS_Fingerprinting = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), _("Wizard"));
	gtk_window_set_modal (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), TRUE);
	gtk_window_set_resizable (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), FALSE);
	gtk_window_set_position (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_transient_for (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), GTK_WINDOW (window_root));
	Wizard_Add_OS_Fingerprinting_icon_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "/AutoScan.png", NULL);
	if (Wizard_Add_OS_Fingerprinting_icon_pixbuf) {
		gtk_window_set_icon (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), Wizard_Add_OS_Fingerprinting_icon_pixbuf);
		gdk_pixbuf_unref (Wizard_Add_OS_Fingerprinting_icon_pixbuf);
	}

	druid_Add_OS_Fingerprinting = gnome_druid_new ();
	gtk_widget_show (druid_Add_OS_Fingerprinting);
	gtk_container_add (GTK_CONTAINER (Wizard_Add_OS_Fingerprinting), druid_Add_OS_Fingerprinting);
	gtk_container_set_border_width (GTK_CONTAINER (druid_Add_OS_Fingerprinting), 4);

	druidpagestart_Add_OS_Fingerprinting = gnome_druid_page_edge_new (GNOME_EDGE_START);
	gtk_widget_show (druidpagestart_Add_OS_Fingerprinting);
	gnome_druid_append_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestart_Add_OS_Fingerprinting));
	gnome_druid_page_edge_set_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), &druidpagestart_Add_OS_Fingerprinting_bg_color);
	gnome_druid_page_edge_set_textbox_color (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), &druidpagestart_Add_OS_Fingerprinting_textbox_color);
	gnome_druid_page_edge_set_logo_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), &druidpagestart_Add_OS_Fingerprinting_logo_bg_color);
	gnome_druid_page_edge_set_title (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), _("Os Fingerprinting Wizard"));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), _("This Wizard will add an unknown equipment to the AutoScan database"));
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_edge_set_logo (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Os_Fingerprinting.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_edge_set_watermark (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}

	druidpagestandard_Information_OS = gnome_druid_page_standard_new ();
	gtk_widget_show_all (druidpagestandard_Information_OS);
	gnome_druid_append_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestandard_Information_OS));
	gnome_druid_page_standard_set_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS), &druidpagestandard_Information_OS_bg_color);
	gnome_druid_page_standard_set_logo_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS), &druidpagestandard_Information_OS_logo_bg_color);
	gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS), _("Information"));
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_standard_set_logo (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}

	druid_vbox_Information_OS = GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS)->vbox;
	gtk_widget_show (druid_vbox_Information_OS);
	gtk_container_set_border_width (GTK_CONTAINER (druid_vbox_Information_OS), 16);

	vbox_Information_OS = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Information_OS);
	gtk_box_pack_start (GTK_BOX (druid_vbox_Information_OS), vbox_Information_OS, TRUE, TRUE, 0);

	hbox_Information_OS_System_Name = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Information_OS_System_Name);
	gtk_box_pack_start (GTK_BOX (vbox_Information_OS), hbox_Information_OS_System_Name, FALSE, TRUE, 3);

	label_Information_OS_System_Name = gtk_label_new (_("System name "));
	gtk_widget_show (label_Information_OS_System_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Information_OS_System_Name), label_Information_OS_System_Name, FALSE, FALSE, 15);

	entry_Information_OS_System_Name = gtk_entry_new ();
	gtk_widget_show (entry_Information_OS_System_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Information_OS_System_Name), entry_Information_OS_System_Name, FALSE, TRUE, 0);
	gtk_tooltips_set_tip (tooltips, entry_Information_OS_System_Name, _("Example1 : Linux kernel 2.4 (X86) from Debian \\nExample2 : Microsoft - Windows XP Home (French) SP1\\nExample3 : Apple - Mac OS X 10.2 (Jaguar) \\nExample4 : Cisco - 4500 router running IOS 10.1\""), NULL);

	hbox_Information_OS_Type = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Information_OS_Type);
	gtk_box_pack_start (GTK_BOX (vbox_Information_OS), hbox_Information_OS_Type, FALSE, TRUE, 3);

	label_Information_OS_Type = gtk_label_new (_("Type"));
	gtk_widget_show (label_Information_OS_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Information_OS_Type), label_Information_OS_Type, FALSE, FALSE, 41);

	combobox_Information_OS_Type = creation_combo (FALSE);
	gtk_combo_box_new_text ();
	creation_combo_type (combobox_Information_OS_Type);
	gtk_widget_show (combobox_Information_OS_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Information_OS_Type), combobox_Information_OS_Type, FALSE, FALSE, 0);
	//combobox_Information_OS_Type = gtk_combo_box_new_text ();
	//gtk_widget_show (combobox_Information_OS_Type);
	//gtk_box_pack_start (GTK_BOX (hbox_Information_OS_Type), combobox_Information_OS_Type, FALSE, FALSE, 0);

	hbox_Information_MD5 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Information_MD5);
	gtk_box_pack_start (GTK_BOX (vbox_Information_OS), hbox_Information_MD5, FALSE, TRUE, 3);

	label_Information_MD5 = gtk_label_new (_("Md5 Fingerprinting"));
	gtk_widget_show (label_Information_MD5);
	gtk_box_pack_start (GTK_BOX (hbox_Information_MD5), label_Information_MD5, FALSE, FALSE, 3);

	entry_Information_MD5 = gtk_entry_new ();
	gtk_widget_show (entry_Information_MD5);
	gtk_box_pack_start (GTK_BOX (hbox_Information_MD5), entry_Information_MD5, TRUE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry_Information_MD5), FALSE);

	iconentry_Information_Icon = gnome_icon_entry_new (NULL, NULL);
	gtk_widget_show (iconentry_Information_Icon);
	gtk_box_pack_start (GTK_BOX (vbox_Information_OS), iconentry_Information_Icon, TRUE, TRUE, 0);

	druidpagefinish_Add_OS_Fingerprinting = gnome_druid_page_edge_new (GNOME_EDGE_FINISH);
	gtk_widget_show (druidpagefinish_Add_OS_Fingerprinting);
	gnome_druid_append_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagefinish_Add_OS_Fingerprinting));
	gnome_druid_page_edge_set_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), &druidpagefinish_Add_OS_Fingerprinting_bg_color);
	gnome_druid_page_edge_set_logo_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), &druidpagefinish_Add_OS_Fingerprinting_logo_bg_color);
	gnome_druid_page_edge_set_title (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), _("Summary"));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), _("\n\n\nConfirm the following information :\n\nSystem name :\nType :\n\n\n\n\nThis data allows you to contribute new equipment fingerprint \nto the AutoScan database. By submitting fingerprints you are\ntransfering any copyright interest in the data to tlagarde@users.sourceforge.net\nThese data can be to modify,relicense or incorporate into programs like AutoScan."));
	tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	if (tmp_pixbuf) {
		gnome_druid_page_edge_set_logo (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), tmp_pixbuf);
		gdk_pixbuf_unref (tmp_pixbuf);
	}

	g_signal_connect ((gpointer) Wizard_Add_OS_Fingerprinting, "destroy", G_CALLBACK (on_Wizard_Add_OS_Fingerprinting_destroy), NULL);
	g_signal_connect ((gpointer) druidpagestart_Add_OS_Fingerprinting, "cancel", G_CALLBACK (Add_OS_Fingerprinting_cancel), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Information_OS, "cancel", G_CALLBACK (Add_OS_Fingerprinting_cancel), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Information_OS, "prepare", G_CALLBACK (on_druidpagestandard_Information_OS_prepare), NULL);
	g_signal_connect ((gpointer) druidpagestandard_Information_OS, "next", G_CALLBACK (on_druidpagestandard_Information_OS_next), NULL);
	g_signal_connect ((gpointer) druidpagefinish_Add_OS_Fingerprinting, "cancel", G_CALLBACK (Add_OS_Fingerprinting_cancel), NULL);
	g_signal_connect ((gpointer) druidpagefinish_Add_OS_Fingerprinting, "prepare", G_CALLBACK (on_druidpagefinish_Add_OS_Fingerprinting_prepare), NULL);
	g_signal_connect ((gpointer) druidpagefinish_Add_OS_Fingerprinting, "finish", G_CALLBACK (on_druidpagefinish_Add_OS_Fingerprinting_finish), NULL);


	/*Wizard_Add_OS_Fingerprinting = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	 * gtk_window_set_title (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), _("Wizard"));
	 * gtk_window_set_modal (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), TRUE);
	 * gtk_window_set_resizable (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), FALSE);
	 * gtk_window_set_position (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), GTK_WIN_POS_CENTER_ON_PARENT);
	 * gtk_window_set_transient_for (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), GTK_WINDOW (window_root));
	 * Wizard_Add_OS_Fingerprinting_icon_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "/AutoScan.png", NULL);
	 * if (Wizard_Add_OS_Fingerprinting_icon_pixbuf) {
	 * gtk_window_set_icon (GTK_WINDOW (Wizard_Add_OS_Fingerprinting), Wizard_Add_OS_Fingerprinting_icon_pixbuf);
	 * gdk_pixbuf_unref (Wizard_Add_OS_Fingerprinting_icon_pixbuf);
	 * }
	 * 
	 * 
	 * druid_Add_OS_Fingerprinting = gnome_druid_new ();
	 * gtk_widget_show (druid_Add_OS_Fingerprinting);
	 * gtk_container_add (GTK_CONTAINER (Wizard_Add_OS_Fingerprinting), druid_Add_OS_Fingerprinting);
	 * gtk_container_set_border_width (GTK_CONTAINER (druid_Add_OS_Fingerprinting), 4);
	 * 
	 * druidpagestart_Add_OS_Fingerprinting = gnome_druid_page_edge_new (GNOME_EDGE_START);
	 * gtk_widget_show (druidpagestart_Add_OS_Fingerprinting);
	 * gnome_druid_append_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestart_Add_OS_Fingerprinting));
	 * gnome_druid_page_edge_set_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), &druidpagestart_Add_OS_Fingerprinting_bg_color);
	 * gnome_druid_page_edge_set_textbox_color (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), &druidpagestart_Add_OS_Fingerprinting_textbox_color);
	 * gnome_druid_page_edge_set_logo_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), &druidpagestart_Add_OS_Fingerprinting_logo_bg_color);
	 * gnome_druid_page_edge_set_title (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), _("Os Fingerprinting Wizard"));
	 * gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), _("This Wizard will add an unknown equipment to the AutoScan database"));
	 * tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	 * if (tmp_pixbuf) {
	 * gnome_druid_page_edge_set_logo (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), tmp_pixbuf);
	 * gdk_pixbuf_unref (tmp_pixbuf);
	 * }
	 * tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Os_Fingerprinting.png", NULL);
	 * if (tmp_pixbuf) {
	 * gnome_druid_page_edge_set_watermark (GNOME_DRUID_PAGE_EDGE (druidpagestart_Add_OS_Fingerprinting), tmp_pixbuf);
	 * gdk_pixbuf_unref (tmp_pixbuf);
	 * }
	 * 
	 * druidpagestandard_Information_OS = gnome_druid_page_standard_new ();
	 * gtk_widget_show_all (druidpagestandard_Information_OS);
	 * gnome_druid_append_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestandard_Information_OS));
	 * gnome_druid_page_standard_set_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS), &druidpagestandard_Information_OS_bg_color);
	 * gnome_druid_page_standard_set_logo_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS), &druidpagestandard_Information_OS_logo_bg_color);
	 * gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS), _("Information"));
	 * tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	 * if (tmp_pixbuf) {
	 * gnome_druid_page_standard_set_logo (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS), tmp_pixbuf);
	 * gdk_pixbuf_unref (tmp_pixbuf);
	 * }
	 * 
	 * druid_vbox_Information_OS = GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Information_OS)->vbox;
	 * gtk_widget_show (druid_vbox_Information_OS);
	 * gtk_container_set_border_width (GTK_CONTAINER (druid_vbox_Information_OS), 16);
	 * 
	 * vbox_Information_OS = gtk_vbox_new (FALSE, 0);
	 * gtk_widget_show (vbox_Information_OS);
	 * gtk_box_pack_start (GTK_BOX (druid_vbox_Information_OS), vbox_Information_OS, TRUE, TRUE, 0);
	 * 
	 * hbox_Information_OS_System_Name = gtk_hbox_new (FALSE, 0);
	 * gtk_widget_show (hbox_Information_OS_System_Name);
	 * gtk_box_pack_start (GTK_BOX (vbox_Information_OS), hbox_Information_OS_System_Name, FALSE, TRUE, 3);
	 * 
	 * label_Information_OS_System_Name = gtk_label_new (_("System name "));
	 * gtk_widget_show (label_Information_OS_System_Name);
	 * gtk_box_pack_start (GTK_BOX (hbox_Information_OS_System_Name), label_Information_OS_System_Name, FALSE, FALSE, 15);
	 * 
	 * entry_Information_OS_System_Name = gtk_entry_new ();
	 * gtk_widget_show (entry_Information_OS_System_Name);
	 * gtk_box_pack_start (GTK_BOX (hbox_Information_OS_System_Name), entry_Information_OS_System_Name, FALSE, TRUE, 0);
	 * gtk_tooltips_set_tip (tooltips, entry_Information_OS_System_Name, _("Example1 : Linux - Kernel 2.4 (X86) from Debian \nExample2 : Microsoft - Windows XP Home (French) SP1\nExample3 : Apple - Mac OS X 10.2 (Jaguar) \nExample4 : Cisco - 4500 router running IOS 10.1"), NULL);
	 * 
	 * hbox_Information_OS_Type = gtk_hbox_new (FALSE, 0);
	 * gtk_widget_show (hbox_Information_OS_Type);
	 * gtk_box_pack_start (GTK_BOX (vbox_Information_OS), hbox_Information_OS_Type, FALSE, TRUE, 3);
	 * 
	 * label_Information_OS_Type = gtk_label_new (_("Type"));
	 * gtk_widget_show (label_Information_OS_Type);
	 * gtk_box_pack_start (GTK_BOX (hbox_Information_OS_Type), label_Information_OS_Type, FALSE, FALSE, 41);
	 * 
	 * combobox_Information_OS_Type = creation_combo (FALSE);
	 * gtk_combo_box_new_text ();
	 * creation_combo_type (combobox_Information_OS_Type);
	 * gtk_widget_show (combobox_Information_OS_Type);
	 * gtk_box_pack_start (GTK_BOX (hbox_Information_OS_Type), combobox_Information_OS_Type, FALSE, FALSE, 0);
	 * 
	 * hbox_Information_MD5 = gtk_hbox_new (FALSE, 0);
	 * gtk_widget_show (hbox_Information_MD5);
	 * gtk_box_pack_start (GTK_BOX (vbox_Information_OS), hbox_Information_MD5, FALSE, TRUE, 3);
	 * 
	 * label_Information_MD5 = gtk_label_new (_("Md5 Fingerprinting"));
	 * gtk_widget_show (label_Information_MD5);
	 * gtk_box_pack_start (GTK_BOX (hbox_Information_MD5), label_Information_MD5, FALSE, FALSE, 3);
	 * 
	 * entry_Information_MD5 = gtk_entry_new ();
	 * gtk_widget_show (entry_Information_MD5);
	 * gtk_box_pack_start (GTK_BOX (hbox_Information_MD5), entry_Information_MD5, TRUE, TRUE, 0);
	 * gtk_editable_set_editable (GTK_EDITABLE (entry_Information_MD5), FALSE);
	 * 
	 * iconentry_Information_Icon = gnome_icon_entry_new (NULL, NULL);
	 * gtk_widget_show (iconentry_Information_Icon);
	 * gtk_box_pack_start (GTK_BOX (vbox_Information_OS), iconentry_Information_Icon, TRUE, TRUE, 0);
	 * 
	 * druidpagestandard_Contribute_OS = gnome_druid_page_standard_new ();
	 * gtk_widget_show_all (druidpagestandard_Contribute_OS);
	 * gnome_druid_append_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestandard_Contribute_OS));
	 * gnome_druid_page_standard_set_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Contribute_OS), &druidpagestandard_Contribute_OS_bg_color);
	 * gnome_druid_page_standard_set_logo_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Contribute_OS), &druidpagestandard_Contribute_OS_logo_bg_color);
	 * gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Contribute_OS), _("Contribute"));
	 * tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	 * if (tmp_pixbuf) {
	 * gnome_druid_page_standard_set_logo (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Contribute_OS), tmp_pixbuf);
	 * gdk_pixbuf_unref (tmp_pixbuf);
	 * }
	 * 
	 * druid_vbox_Contribute_OS = GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Contribute_OS)->vbox;
	 * gtk_widget_show (druid_vbox_Contribute_OS);
	 * gtk_container_set_border_width (GTK_CONTAINER (druid_vbox_Contribute_OS), 16);
	 * 
	 * vbox_Contribute_OS = gtk_vbox_new (FALSE, 0);
	 * gtk_widget_show (vbox_Contribute_OS);
	 * gtk_box_pack_start (GTK_BOX (druid_vbox_Contribute_OS), vbox_Contribute_OS, TRUE, TRUE, 0);
	 * 
	 * radiobutton_Contribute_OS_Submit = gtk_radio_button_new_with_mnemonic (NULL, _("Submit new equipment to the AutoScan database"));
	 * gtk_widget_show (radiobutton_Contribute_OS_Submit);
	 * gtk_box_pack_start (GTK_BOX (vbox_Contribute_OS), radiobutton_Contribute_OS_Submit, FALSE, FALSE, 0);
	 * gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Contribute_OS_Submit), radiobutton_Contribute_OS_Submit_group);
	 * radiobutton_Contribute_OS_Submit_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Contribute_OS_Submit));
	 * 
	 * radiobutton_Contribute_OS_Not_Submit = gtk_radio_button_new_with_mnemonic (NULL, _("Not to submit"));
	 * gtk_widget_show (radiobutton_Contribute_OS_Not_Submit);
	 * gtk_box_pack_start (GTK_BOX (vbox_Contribute_OS), radiobutton_Contribute_OS_Not_Submit, FALSE, FALSE, 0);
	 * gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Contribute_OS_Not_Submit), radiobutton_Contribute_OS_Submit_group);
	 * radiobutton_Contribute_OS_Submit_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Contribute_OS_Not_Submit));
	 * 
	 * label_Contribute_OS_Info = gtk_label_new (_("This data allows you to contribute new equipment fingerprint \nto the AutoScan database. By submitting fingerprints you are\ntransfering any copyright interest in the data to tlagarde@users.sourceforge.net\nThese data can be to modify,relicense or incorporate into programs like AutoScan."));
	 * gtk_widget_show (label_Contribute_OS_Info);
	 * gtk_box_pack_end (GTK_BOX (vbox_Contribute_OS), label_Contribute_OS_Info, FALSE, FALSE, 0);
	 * gtk_widget_set_sensitive (label_Contribute_OS_Info, FALSE);
	 * gtk_label_set_justify (GTK_LABEL (label_Contribute_OS_Info), GTK_JUSTIFY_CENTER);
	 * 
	 * druidpagestandard_Connection_Internet = gnome_druid_page_standard_new ();
	 * gtk_widget_show_all (druidpagestandard_Connection_Internet);
	 * gnome_druid_append_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestandard_Connection_Internet));
	 * gnome_druid_page_standard_set_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Connection_Internet), &druidpagestandard_Connection_Internet_bg_color);
	 * gnome_druid_page_standard_set_logo_background (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Connection_Internet), &druidpagestandard_Connection_Internet_logo_bg_color);
	 * gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Connection_Internet), _("Connection to the internet"));
	 * tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	 * if (tmp_pixbuf) {
	 * gnome_druid_page_standard_set_logo (GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Connection_Internet), tmp_pixbuf);
	 * gdk_pixbuf_unref (tmp_pixbuf);
	 * }
	 * 
	 * druid_vbox_Connection_internet = GNOME_DRUID_PAGE_STANDARD (druidpagestandard_Connection_Internet)->vbox;
	 * gtk_widget_show (druid_vbox_Connection_internet);
	 * gtk_container_set_border_width (GTK_CONTAINER (druid_vbox_Connection_internet), 16);
	 * 
	 * vbox_Connection_Internet = gtk_vbox_new (TRUE, 0);
	 * gtk_widget_show (vbox_Connection_Internet);
	 * gtk_box_pack_start (GTK_BOX (druid_vbox_Connection_internet), vbox_Connection_Internet, TRUE, TRUE, 0);
	 * 
	 * radiobutton_Direct_Connection = gtk_radio_button_new_with_mnemonic (NULL, _("Direct connection to the Internet"));
	 * gtk_widget_show (radiobutton_Direct_Connection);
	 * gtk_box_pack_start (GTK_BOX (vbox_Connection_Internet), radiobutton_Direct_Connection, FALSE, FALSE, 1);
	 * gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Direct_Connection), radiobutton_Direct_Connection_group);
	 * radiobutton_Direct_Connection_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Direct_Connection));
	 * gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_Direct_Connection), TRUE);
	 * 
	 * radiobutton_Manual_Connection = gtk_radio_button_new_with_mnemonic (NULL, _("Manual proxy configuration"));
	 * gtk_widget_show (radiobutton_Manual_Connection);
	 * gtk_box_pack_start (GTK_BOX (vbox_Connection_Internet), radiobutton_Manual_Connection, FALSE, FALSE, 0);
	 * gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Manual_Connection), radiobutton_Direct_Connection_group);
	 * radiobutton_Direct_Connection_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Manual_Connection));
	 * 
	 * hbox_Manual_Connection = gtk_hbox_new (FALSE, 0);
	 * gtk_widget_show (hbox_Manual_Connection);
	 * gtk_box_pack_start (GTK_BOX (vbox_Connection_Internet), hbox_Manual_Connection, TRUE, TRUE, 0);
	 * 
	 * label_Manual_HTTP_Proxy = gtk_label_new (_("HTTP Proxy :"));
	 * gtk_widget_show (label_Manual_HTTP_Proxy);
	 * gtk_box_pack_start (GTK_BOX (hbox_Manual_Connection), label_Manual_HTTP_Proxy, FALSE, FALSE, 10);
	 * 
	 * entry_Manual_HTTP_Proxy = gtk_entry_new ();
	 * gtk_widget_show (entry_Manual_HTTP_Proxy);
	 * gtk_box_pack_start (GTK_BOX (hbox_Manual_Connection), entry_Manual_HTTP_Proxy, FALSE, TRUE, 0);
	 * 
	 * label_Manual_Port = gtk_label_new (_("Port :"));
	 * gtk_widget_show (label_Manual_Port);
	 * gtk_box_pack_start (GTK_BOX (hbox_Manual_Connection), label_Manual_Port, FALSE, FALSE, 10);
	 * 
	 * spinbutton_Manual_Port_adj = gtk_adjustment_new (8080, 1, 65535, 1, 10, 10);
	 * spinbutton_Manual_Port = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Manual_Port_adj), 1, 0);
	 * gtk_widget_show (spinbutton_Manual_Port);
	 * gtk_box_pack_start (GTK_BOX (hbox_Manual_Connection), spinbutton_Manual_Port, FALSE, TRUE, 0);
	 * 
	 * radiobutton_Automatic_Proxy = gtk_radio_button_new_with_mnemonic (NULL, _("Automatic proxy configuration"));
	 * gtk_widget_show (radiobutton_Automatic_Proxy);
	 * gtk_box_pack_start (GTK_BOX (vbox_Connection_Internet), radiobutton_Automatic_Proxy, FALSE, FALSE, 0);
	 * gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Automatic_Proxy), radiobutton_Direct_Connection_group);
	 * radiobutton_Direct_Connection_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Automatic_Proxy));
	 * 
	 * hbox_Automatic_URL_Proxy = gtk_hbox_new (FALSE, 0);
	 * gtk_widget_show (hbox_Automatic_URL_Proxy);
	 * gtk_box_pack_start (GTK_BOX (vbox_Connection_Internet), hbox_Automatic_URL_Proxy, TRUE, TRUE, 0);
	 * 
	 * label_Automatic_URL = gtk_label_new (_("URL :"));
	 * gtk_widget_show (label_Automatic_URL);
	 * gtk_box_pack_start (GTK_BOX (hbox_Automatic_URL_Proxy), label_Automatic_URL, FALSE, FALSE, 14);
	 * 
	 * entry_Automatic_URL = gtk_entry_new ();
	 * gtk_widget_show (entry_Automatic_URL);
	 * gtk_box_pack_start (GTK_BOX (hbox_Automatic_URL_Proxy), entry_Automatic_URL, FALSE, TRUE, 0);
	 * 
	 * checkbutton_Authentication = gtk_check_button_new_with_mnemonic (_("Authentication"));
	 * gtk_widget_show (checkbutton_Authentication);
	 * gtk_box_pack_start (GTK_BOX (vbox_Connection_Internet), checkbutton_Authentication, FALSE, FALSE, 0);
	 * 
	 * hbox_User_Authentication = gtk_hbox_new (FALSE, 0);
	 * gtk_widget_show (hbox_User_Authentication);
	 * gtk_box_pack_start (GTK_BOX (vbox_Connection_Internet), hbox_User_Authentication, TRUE, TRUE, 0);
	 * 
	 * label_User_Authentication = gtk_label_new (_("User :"));
	 * gtk_widget_show (label_User_Authentication);
	 * gtk_box_pack_start (GTK_BOX (hbox_User_Authentication), label_User_Authentication, FALSE, FALSE, 15);
	 * 
	 * entry_User_Authentication = gtk_entry_new ();
	 * gtk_widget_show (entry_User_Authentication);
	 * gtk_box_pack_start (GTK_BOX (hbox_User_Authentication), entry_User_Authentication, FALSE, TRUE, 0);
	 * 
	 * hbox_Password_Authentication = gtk_hbox_new (FALSE, 0);
	 * gtk_widget_show (hbox_Password_Authentication);
	 * gtk_box_pack_start (GTK_BOX (vbox_Connection_Internet), hbox_Password_Authentication, FALSE, TRUE, 0);
	 * 
	 * label_Password_Authentication = gtk_label_new (_("Password : "));
	 * gtk_widget_show (label_Password_Authentication);
	 * gtk_box_pack_start (GTK_BOX (hbox_Password_Authentication), label_Password_Authentication, FALSE, FALSE, 0);
	 * 
	 * entry_Password_Authentication = gtk_entry_new ();
	 * gtk_widget_show (entry_Password_Authentication);
	 * gtk_box_pack_start (GTK_BOX (hbox_Password_Authentication), entry_Password_Authentication, FALSE, TRUE, 0);
	 * gtk_entry_set_visibility (GTK_ENTRY (entry_Password_Authentication), FALSE);
	 * 
	 * druidpagefinish_Add_OS_Fingerprinting = gnome_druid_page_edge_new (GNOME_EDGE_FINISH);
	 * gtk_widget_show (druidpagefinish_Add_OS_Fingerprinting);
	 * gnome_druid_append_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagefinish_Add_OS_Fingerprinting));
	 * gnome_druid_page_edge_set_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), &druidpagefinish_Add_OS_Fingerprinting_bg_color);
	 * gnome_druid_page_edge_set_logo_bg_color (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), &druidpagefinish_Add_OS_Fingerprinting_logo_bg_color);
	 * gnome_druid_page_edge_set_title (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), _("Summary"));
	 * gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), _("Confirm the following information :\n\nSystem name :\nType :"));
	 * tmp_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "Logo_32.png", NULL);
	 * if (tmp_pixbuf) {
	 * gnome_druid_page_edge_set_logo (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), tmp_pixbuf);
	 * gdk_pixbuf_unref (tmp_pixbuf);
	 * }
	 * 
	 * 
	 * g_signal_connect ((gpointer) Wizard_Add_OS_Fingerprinting, "destroy", G_CALLBACK (on_Wizard_Add_OS_Fingerprinting_destroy), NULL);
	 * g_signal_connect ((gpointer) druidpagestart_Add_OS_Fingerprinting, "cancel", G_CALLBACK (Add_OS_Fingerprinting_cancel), NULL);
	 * g_signal_connect ((gpointer) druidpagestandard_Information_OS, "next", G_CALLBACK (on_druidpagestandard_Information_OS_next), NULL);
	 * g_signal_connect ((gpointer) druidpagestandard_Information_OS, "cancel", G_CALLBACK (Add_OS_Fingerprinting_cancel), NULL);
	 * g_signal_connect ((gpointer) druidpagestandard_Information_OS, "prepare", G_CALLBACK (on_druidpagestandard_Information_OS_prepare), NULL);
	 * g_signal_connect ((gpointer) druidpagestandard_Contribute_OS, "cancel", G_CALLBACK (Add_OS_Fingerprinting_cancel), NULL);
	 * g_signal_connect ((gpointer) druidpagestandard_Contribute_OS, "next", G_CALLBACK (on_druidpagestandard_Contribute_OS_next), NULL);
	 * g_signal_connect ((gpointer) druidpagestandard_Contribute_OS, "prepare", G_CALLBACK (on_druidpagestandard_Contribute_OS_prepare), NULL);
	 * g_signal_connect ((gpointer) druidpagestandard_Connection_Internet, "cancel", G_CALLBACK (Add_OS_Fingerprinting_cancel), NULL);
	 * g_signal_connect ((gpointer) druidpagestandard_Connection_Internet, "prepare", G_CALLBACK (on_druidpagestandard_Connection_Internet_prepare), NULL);
	 * g_signal_connect ((gpointer) radiobutton_Direct_Connection, "clicked", G_CALLBACK (on_radiobutton_General_Internet_Direct_New_clicked), NULL);
	 * g_signal_connect ((gpointer) radiobutton_Manual_Connection, "clicked", G_CALLBACK (on_radiobutton_General_Internet_Http_Proxy_New_clicked), NULL);
	 * g_signal_connect ((gpointer) radiobutton_Automatic_Proxy, "clicked", G_CALLBACK (on_radiobutton_General_Internet_Url_New_clicked), NULL);
	 * g_signal_connect ((gpointer) checkbutton_Authentication, "clicked", G_CALLBACK (on_checkbutton_General_Internet_Authentication_New_clicked), NULL);
	 * g_signal_connect ((gpointer) druidpagestandard_Connection_Internet, "next", G_CALLBACK (on_druidpagestandard_Connection_Internet_next), NULL);
	 * g_signal_connect ((gpointer) druidpagefinish_Add_OS_Fingerprinting, "cancel", G_CALLBACK (Add_OS_Fingerprinting_cancel), NULL);
	 * g_signal_connect ((gpointer) druidpagefinish_Add_OS_Fingerprinting, "prepare", G_CALLBACK (on_druidpagefinish_Add_OS_Fingerprinting_prepare), NULL);
	 * g_signal_connect ((gpointer) druidpagefinish_Add_OS_Fingerprinting, "finish", G_CALLBACK (on_druidpagefinish_Add_OS_Fingerprinting_finish), NULL);
	 */ }
