/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <bonobo.h>
#include <gnome.h>

#include "Menu_Samba_Callbacks.h"
#include "Menu_Samba_Interface.h"


static GnomeUIInfo Menu_Samba_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, "Rename",
    NULL,
    (gpointer) on_rename_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, "Delete",
    NULL,
    (gpointer) on_delete_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, "gtk-delete",
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, "New folder",
    NULL,
    (gpointer) on_new_folder_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, "gtk-open",
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, "New_file",
    NULL,
    (gpointer) on_newfile_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, "gtk-edit",
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};


void create_Menu_Samba (void)
{

	GtkAccelGroup *accel_group;

	accel_group = gtk_accel_group_new ();

	Menu_Samba = gtk_menu_new ();
	gnome_app_fill_menu (GTK_MENU_SHELL (Menu_Samba), Menu_Samba_uiinfo, accel_group, FALSE, 0);

	gtk_menu_set_accel_group (GTK_MENU (Menu_Samba), accel_group);
}
