/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gnome.h>

#include "Nessus_Callbacks.h"
#include "Nessus_Interface.h"
#include "../Declaration_Constante.h"
#include "Root_Interface.h"

GtkWidget *create_win_Nessus_Connect (void)
{
	scrolledwindow_Nessus_Connect = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Nessus_Connect);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), scrolledwindow_Nessus_Connect);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Nessus_Connect), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Nessus_Connect = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Nessus_Connect);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Nessus_Connect), viewport_Nessus_Connect);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_Nessus_Connect), GTK_SHADOW_NONE);

	hbox_Nessus_Connect = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Nessus_Connect);
	gtk_container_add (GTK_CONTAINER (viewport_Nessus_Connect), hbox_Nessus_Connect);

	fixed_Nessus_Connect_Gauche = gtk_fixed_new ();
	gtk_widget_show (fixed_Nessus_Connect_Gauche);
	gtk_box_pack_start (GTK_BOX (hbox_Nessus_Connect), fixed_Nessus_Connect_Gauche, TRUE, TRUE, 0);

	vbox_Nessus_Connect = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Nessus_Connect);
	gtk_box_pack_start (GTK_BOX (hbox_Nessus_Connect), vbox_Nessus_Connect, TRUE, TRUE, 0);

	fixed_Nessus_Connect_Haut = gtk_fixed_new ();
	gtk_widget_show (fixed_Nessus_Connect_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Nessus_Connect), fixed_Nessus_Connect_Haut, TRUE, TRUE, 0);

	fixed_Nessus_Connect_Milieu = gtk_fixed_new ();
	gtk_widget_show (fixed_Nessus_Connect_Milieu);
	gtk_box_pack_start (GTK_BOX (vbox_Nessus_Connect), fixed_Nessus_Connect_Milieu, TRUE, TRUE, 0);

	entry_Nessus_Connect_User = gtk_entry_new ();
	gtk_widget_show (entry_Nessus_Connect_User);
	gtk_fixed_put (GTK_FIXED (fixed_Nessus_Connect_Milieu), entry_Nessus_Connect_User, 184, 16);
	gtk_widget_set_size_request (entry_Nessus_Connect_User, 159, 21);

	entry_Nessus_Connect_Password = gtk_entry_new ();
	gtk_widget_show (entry_Nessus_Connect_Password);
	gtk_fixed_put (GTK_FIXED (fixed_Nessus_Connect_Milieu), entry_Nessus_Connect_Password, 184, 48);
	gtk_widget_set_size_request (entry_Nessus_Connect_Password, 159, 21);
	gtk_entry_set_visibility (GTK_ENTRY (entry_Nessus_Connect_Password), FALSE);

	entry_Nessus_Connect_Domaine = gtk_entry_new ();
	gtk_widget_show (entry_Nessus_Connect_Domaine);
	gtk_fixed_put (GTK_FIXED (fixed_Nessus_Connect_Milieu), entry_Nessus_Connect_Domaine, 184, 80);
	gtk_widget_set_size_request (entry_Nessus_Connect_Domaine, 159, 21);
	gtk_entry_set_text (GTK_ENTRY (entry_Nessus_Connect_Domaine), "localhost");

	label_Nessus_Connect_User = gtk_label_new ("User : ");
	gtk_widget_show (label_Nessus_Connect_User);
	gtk_fixed_put (GTK_FIXED (fixed_Nessus_Connect_Milieu), label_Nessus_Connect_User, 136, 16);
	gtk_widget_set_size_request (label_Nessus_Connect_User, 40, 16);

	label_Nessus_Connect_IP = gtk_label_new ("IP server:");
	gtk_widget_show (label_Nessus_Connect_IP);
	gtk_fixed_put (GTK_FIXED (fixed_Nessus_Connect_Milieu), label_Nessus_Connect_IP, 128, 83);
	gtk_widget_set_size_request (label_Nessus_Connect_IP, 54, 16);

	button_Nessus_Connect = gtk_button_new ();
	gtk_widget_show (button_Nessus_Connect);
	gtk_fixed_put (GTK_FIXED (fixed_Nessus_Connect_Milieu), button_Nessus_Connect, 216, 110);
	gtk_widget_set_size_request (button_Nessus_Connect, 96, 32);
	GTK_WIDGET_SET_FLAGS (button_Nessus_Connect, GTK_CAN_DEFAULT);

	alignment_button_Nessus_Connect = gtk_alignment_new (0.5, 0.5, 0, 0);
	gtk_widget_show (alignment_button_Nessus_Connect);
	gtk_container_add (GTK_CONTAINER (button_Nessus_Connect), alignment_button_Nessus_Connect);

	hbox_button_Nessus_Connect = gtk_hbox_new (FALSE, 2);
	gtk_widget_show (hbox_button_Nessus_Connect);
	gtk_container_add (GTK_CONTAINER (alignment_button_Nessus_Connect), hbox_button_Nessus_Connect);

	image_button_Nessus_Connect = gtk_image_new_from_file (PATH_ICONE "Start.png");
	gtk_widget_show (image_button_Nessus_Connect);
	gtk_box_pack_start (GTK_BOX (hbox_button_Nessus_Connect), image_button_Nessus_Connect, FALSE, FALSE, 0);

	label_button_Nessus_Connect = gtk_label_new_with_mnemonic ("Start");
	gtk_widget_show (label_button_Nessus_Connect);
	gtk_box_pack_start (GTK_BOX (hbox_button_Nessus_Connect), label_button_Nessus_Connect, FALSE, FALSE, 0);

	label_Nessus_Connect_Password = gtk_label_new ("Password :");
	gtk_widget_show (label_Nessus_Connect_Password);
	gtk_fixed_put (GTK_FIXED (fixed_Nessus_Connect_Milieu), label_Nessus_Connect_Password, 128, 51);
	gtk_widget_set_size_request (label_Nessus_Connect_Password, 51, 16);

	image_Nessus_Connect = gtk_image_new_from_file (PATH_ICONE "nessus_logo.png");
	gtk_widget_show (image_Nessus_Connect);
	gtk_fixed_put (GTK_FIXED (fixed_Nessus_Connect_Milieu), image_Nessus_Connect, 0, 0);
	gtk_widget_set_size_request (image_Nessus_Connect, 128, 128);

	fixed_Nessus_Connect_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Nessus_Connect_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Nessus_Connect), fixed_Nessus_Connect_Bas, TRUE, TRUE, 0);

	fixed_Nessus_Connect_Droit = gtk_fixed_new ();
	gtk_widget_show (fixed_Nessus_Connect_Droit);
	gtk_box_pack_start (GTK_BOX (hbox_Nessus_Connect), fixed_Nessus_Connect_Droit, TRUE, TRUE, 0);

	g_signal_connect ((gpointer) button_Nessus_Connect, "clicked", G_CALLBACK (on_button_Nessus_Connect_clicked), NULL);



	
	return scrolledwindow_Nessus_Connect;
}
