/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <bonobo.h>
#include <gnome.h>

#include "NetSend_Callbacks.h"
#include "NetSend_Interface.h"
#include "../Declaration_Constante.h"
#include "Root_Interface.h"

GtkWidget *create_win_NetSend (void)
{
	scrolledwindow_NetSend = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_NetSend);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), scrolledwindow_NetSend);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_NetSend), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_NetSend = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_NetSend);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_NetSend), viewport_NetSend);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_NetSend), GTK_SHADOW_NONE);

	vbox_NetSend_Milieu = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_NetSend_Milieu);
	gtk_container_add (GTK_CONTAINER (viewport_NetSend), vbox_NetSend_Milieu);

	scrolledwindow_NetSend_Texte = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_NetSend_Texte);
	gtk_box_pack_start (GTK_BOX (vbox_NetSend_Milieu), scrolledwindow_NetSend_Texte, TRUE, TRUE, 11);
	gtk_widget_set_size_request (scrolledwindow_NetSend_Texte, 312, 136);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_NetSend_Texte), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_NetSend_Texte), GTK_SHADOW_IN);

	textview_NetSend = gtk_text_view_new ();
	gtk_widget_show (textview_NetSend);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_NetSend_Texte), textview_NetSend);

	hbox_NetSend_Button = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_NetSend_Button);
	gtk_box_pack_start (GTK_BOX (vbox_NetSend_Milieu), hbox_NetSend_Button, FALSE, TRUE, 6);

	fixed_NetSend_Button_Gauche = gtk_fixed_new ();
	gtk_widget_show (fixed_NetSend_Button_Gauche);
	gtk_box_pack_start (GTK_BOX (hbox_NetSend_Button), fixed_NetSend_Button_Gauche, TRUE, TRUE, 0);

	button_NetSend = gtk_button_new ();
	gtk_widget_show (button_NetSend);
	gtk_box_pack_start (GTK_BOX (hbox_NetSend_Button), button_NetSend, FALSE, FALSE, 0);
	gtk_widget_set_size_request (button_NetSend, 96, 32);

	alignment_NetSend = gtk_alignment_new (0.5, 0.5, 0, 0);
	gtk_widget_show (alignment_NetSend);
	gtk_container_add (GTK_CONTAINER (button_NetSend), alignment_NetSend);

	hbox_NetSend = gtk_hbox_new (FALSE, 2);
	gtk_widget_show (hbox_NetSend);
	gtk_container_add (GTK_CONTAINER (alignment_NetSend), hbox_NetSend);

	image_NetSend = gtk_image_new_from_file (PATH_ICONE "Send.png");
	gtk_widget_show (image_NetSend);
	gtk_box_pack_start (GTK_BOX (hbox_NetSend), image_NetSend, FALSE, FALSE, 0);

	label_NetSend = gtk_label_new_with_mnemonic (_("Send"));
	gtk_widget_show (label_NetSend);
	gtk_box_pack_start (GTK_BOX (hbox_NetSend), label_NetSend, FALSE, FALSE, 0);

	fixed_NetSend_Button_Droite = gtk_fixed_new ();
	gtk_widget_show (fixed_NetSend_Button_Droite);
	gtk_box_pack_start (GTK_BOX (hbox_NetSend_Button), fixed_NetSend_Button_Droite, TRUE, TRUE, 0);

	g_signal_connect ((gpointer) button_NetSend, "clicked", G_CALLBACK (on_button_NetSend_clicked), NULL);


	return scrolledwindow_NetSend;
}
