/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gnome.h>

#include "Root_Callbacks.h"
#include "Root_Interface.h"
#include "Settings_Interface.h"
#include "About_Interface.h"
#include "Recherche_Interface.h"
#include "Save_Interface.h"
#include "Add_Network_Interface.h"
#include "../Quit.h"
#include "../Objet.h"
#include "../Objet_Bulle.h"
#include "../Settings.h"
#include "../Add_Network_Subnet.h"
#include "../Reseau.h"
#include "../Com/Commun.h"
#include "../Debug.h"
#include "../Modules.h"
#include "../Applet.h"


gboolean on_window_root_delete_event (GtkWidget * widget, GdkEvent * event, gpointer user_data)
{
	GtkWidget *Win_Quit;

	if (tray_icon_Afficher) {
		gtk_widget_hide (window_root);
		Root_Afficher = FALSE;
	}
	else {
		Win_Quit = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, "Are you sure you want to quit?");
		switch (gtk_dialog_run (GTK_DIALOG (Win_Quit))) {
		    case GTK_RESPONSE_YES:
			    Arret_Utilisateur ();
			    break;
		}
		gtk_widget_destroy (Win_Quit);
	}
	return TRUE;
}


void on_toolbutton_Add_Network_clicked (GtkToolButton * toolbutton, gpointer user_data)
{
	gtk_widget_show (window_Add_Network);
}


void on_toolbutton_Save_clicked (GtkToolButton * toolbutton, gpointer user_data)
{
	gchar    *Nom_Fenetre, *Nom_Fichier;

	gtk_widget_show (file_Save);
	Nom_Fenetre = g_strdup_printf ("Save [%s]", Reseau_Selectionner->Nom_Reseau);
	gtk_window_set_title (GTK_WINDOW (file_Save), Nom_Fenetre);
	g_free (Nom_Fenetre);
	Nom_Fichier = g_strdup_printf ("%s.xml", Reseau_Selectionner->Nom_Reseau);
	gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (file_Save), Nom_Fichier);
	g_free (Nom_Fichier);
}


void on_toolbutton_Search_clicked (GtkToolButton * toolbutton, gpointer user_data)
{
	gtk_widget_show (window_Recherche);
}


void on_toolbutton_Settings_clicked (GtkToolButton * toolbutton, gpointer user_data)
{
	if (dialog_Settings != NULL) {
		Preparation_Interface_Settings ();
		gtk_widget_show (dialog_Settings);
	}
}


void on_toggletoolbutton_Notification_clicked (GtkToolButton * toolbutton, gpointer user_data)
{
	if (!Modification_Toggle_En_Cours) {
		if (Objet_Selectionner->Action_Notification != NULL) {
			(*Objet_Selectionner->Action_Notification) ((gpointer *) Objet_Selectionner);
		}
		else
			debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Impossible de lancer Action_Notification");
	}
}


void on_toggletoolbutton_Alert_Intrusion_toggled (GtkToggleToolButton * toggletoolbutton, gpointer user_data)
{
	struct struct_Active_Alerte_Intrus Message_Active;
	struct struct_Desactive_Alerte_Intrus Message_Desactive;
	struct Struct_Liste_Reseau *Reseau;
	GtkWidget *Win_Demande_User;

	if (!Modification_Toggle_En_Cours) {
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		if (gtk_toggle_tool_button_get_active (toggletoolbutton)) {
			debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Intrusion Alert : enable");
			Win_Demande_User = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, "If you active this function, the new equipments \nfound will be considered as intruders");
			switch (gtk_dialog_run (GTK_DIALOG (Win_Demande_User))) {
			    case GTK_RESPONSE_YES:
				    bzero (&Message_Active, sizeof (struct struct_Active_Alerte_Intrus));
				    Message_Active.ID_Reseau = Reseau->Id_Reseau;
				    Communication_Envoie_Donnee (Reseau->Pid_Agent, ACTIVE_ALERTE_INTRUS, (gpointer *) & Message_Active, sizeof (Message_Active), Reseau);
				    Reseau->Alert_Intrusion = TRUE;
				    break;
			    case GTK_RESPONSE_NO:
				    Modification_Toggle_En_Cours = TRUE;	
				    gtk_toggle_tool_button_set_active (toggletoolbutton, FALSE);
				    Modification_Toggle_En_Cours = FALSE;
				    Reseau->Alert_Intrusion = FALSE;
				    break;
			}
			gtk_widget_destroy (Win_Demande_User);
		}
		else {
			printf ("Desactive Alerte intrusion\n");
			bzero (&Message_Desactive, sizeof (struct struct_Desactive_Alerte_Intrus));
			Message_Desactive.ID_Reseau = Reseau->Id_Reseau;
			Communication_Envoie_Donnee (Reseau->Pid_Agent, DESACTIVE_ALERTE_INTRUS, (gpointer *) & Message_Desactive, sizeof (Message_Desactive), Reseau);
			Reseau->Alert_Intrusion = FALSE;
		}
	}
}


void on_toolbutton_About_clicked (GtkToolButton * toolbutton, gpointer user_data)
{
	gtk_widget_show (about);
}


void on_toolbutton_Exit_clicked (GtkToolButton * toolbutton, gpointer user_data)
{
	Arret_Utilisateur ();
}


void on_notebook_reseau_switch_page (GtkNotebook * notebook, GtkNotebookPage * page, guint page_num, gpointer user_data)
{
	
	if (Reseau_Selectionner != NULL) {
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);	
		Initialisation_Aucun_Module ();
	}
	Equipement_Selectionner = NULL;
	Objet_Equipement_Selectionner = NULL;
	Reseau_Selectionner = Recupere_Pointeur_Reseau_Selectionner (gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_reseau), page_num));
	ID_Reseau_En_Cours = Reseau_Selectionner->Id_Reseau;
	gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
	gtk_widget_set_sensitive (button_Refresh, FALSE);
	Modification_Toggle_En_Cours = TRUE;	
	gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Alert_Intrusion), Reseau_Selectionner->Alert_Intrusion);
	gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification), FALSE);
	Modification_Toggle_En_Cours = FALSE;
	
	Reseau_Selectionner->Octet_Envoyer = 0;
	Reseau_Selectionner->Octet_Recu = 0;
	Reseau_Selectionner->Octet_Envoyer_Agent = 0;
	Reseau_Selectionner->Octet_Recu_Agent = 0;
	Affiche_Info_Reseau (Reseau_Selectionner);
	gtk_widget_hide (vbox_Milieu);
}



void on_togglebutton_Favoris_clicked (GtkButton * button, gpointer user_data)
{
	if (!Modification_Toggle_En_Cours) {
		debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Favoris");
		if (Objet_Selectionner->Action_Favoris != NULL) {
			(*Objet_Selectionner->Action_Favoris) ((gpointer *) Objet_Selectionner);
		}
		else
			debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Impossible de lancer Favoris");
	}
}


void on_button_Plus_clicked (GtkButton * button, gpointer user_data)
{

}


void on_button_Moins_clicked (GtkButton * button, gpointer user_data)
{

}


void on_button_Rafraichir_clicked (GtkButton * button, gpointer user_data)
{
	if (Objet_Selectionner->Action_Rafraichissement != NULL) {
		(*Objet_Selectionner->Action_Rafraichissement) ((gpointer *) Objet_Selectionner);
	}
	else
		debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Impossible de lancer Rafraichissement");
}


void on_button_Alerte_clicked (GtkButton * button, gpointer user_data)
{

}


void on_button_Warning_clicked (GtkButton * button, gpointer user_data)
{

}
