/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gnome.h>

#include "Save_Callbacks.h"
#include "Save_Interface.h"
#include "../Declaration_Constante.h"

void create_file_Save (void)
{

	file_Save = gtk_file_chooser_dialog_new (_("Save"), NULL, GTK_FILE_CHOOSER_ACTION_SAVE, NULL);
	g_object_set (file_Save, "local-only", FALSE, "show-hidden", TRUE, NULL);
	file_Save_icon_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "/AutoScan.png", NULL);
	if (file_Save_icon_pixbuf) {
		gtk_window_set_icon (GTK_WINDOW (file_Save), file_Save_icon_pixbuf);
		gdk_pixbuf_unref (file_Save_icon_pixbuf);
	}
	gtk_window_set_type_hint (GTK_WINDOW (file_Save), GDK_WINDOW_TYPE_HINT_DIALOG);

	dialog_vbox1 = GTK_DIALOG (file_Save)->vbox;
	gtk_widget_show (dialog_vbox1);

	dialog_action_area_Save = GTK_DIALOG (file_Save)->action_area;
	gtk_widget_show (dialog_action_area_Save);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area_Save), GTK_BUTTONBOX_END);

	button_Save_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Save_Cancel);
	gtk_dialog_add_action_widget (GTK_DIALOG (file_Save), button_Save_Cancel, GTK_RESPONSE_CANCEL);
	GTK_WIDGET_SET_FLAGS (button_Save_Cancel, GTK_CAN_DEFAULT);

	button_Save = gtk_button_new_from_stock ("gtk-save");
	gtk_widget_show (button_Save);
	gtk_dialog_add_action_widget (GTK_DIALOG (file_Save), button_Save, GTK_RESPONSE_OK);
	GTK_WIDGET_SET_FLAGS (button_Save, GTK_CAN_DEFAULT);

	g_signal_connect ((gpointer) file_Save, "destroy", G_CALLBACK (on_file_Save_destroy), NULL);
	g_signal_connect ((gpointer) button_Save_Cancel, "clicked", G_CALLBACK (on_button_Save_Cancel_clicked), NULL);
	g_signal_connect ((gpointer) button_Save, "clicked", G_CALLBACK (on_button_Save_clicked), NULL);

	gtk_widget_grab_default (button_Save);
}
