/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <bonobo.h>
#include <gnome.h>

#include "Root_Interface.h"
#include "Settings_Callbacks.h"
#include "Settings_Interface.h"
#include "../Declaration_Constante.h"
#include "../Settings_Signature.h"
#include "../Settings_Port.h"
#include "../Settings_Script.h"
#include "../Settings_Restore.h"
#include "Combo.h"
#include "../Gconf.h"

void create_dialog_Settings (void)
{

	GSList   *radiobutton_General_Internet_Direct_group = NULL;


	dialog_Settings = gtk_dialog_new ();
	gtk_widget_set_size_request (dialog_Settings, Lecture_Gconf_Int (INT_SETTINGS_SIZE_X), Lecture_Gconf_Int (INT_SETTINGS_SIZE_Y));
	gtk_window_set_title (GTK_WINDOW (dialog_Settings), _("Settings"));
	gtk_window_set_modal (GTK_WINDOW (dialog_Settings), TRUE);
	gtk_window_set_position (GTK_WINDOW (dialog_Settings), GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_transient_for (GTK_WINDOW (dialog_Settings), GTK_WINDOW (window_root));
	gtk_window_set_policy (GTK_WINDOW (dialog_Settings), TRUE, TRUE, FALSE);	
	dialog_Settings_icon_pixbuf = gdk_pixbuf_new_from_file (PATH_ICONE "/AutoScan.png", NULL);
	if (dialog_Settings_icon_pixbuf) {
		gtk_window_set_icon (GTK_WINDOW (dialog_Settings), dialog_Settings_icon_pixbuf);
		gdk_pixbuf_unref (dialog_Settings_icon_pixbuf);
	}
	gtk_window_set_type_hint (GTK_WINDOW (dialog_Settings), GDK_WINDOW_TYPE_HINT_DIALOG);

	dialog_vbox_Settings = GTK_DIALOG (dialog_Settings)->vbox;
	gtk_widget_show (dialog_vbox_Settings);

	notebook_Settings = gtk_notebook_new ();
	gtk_widget_show (notebook_Settings);
	gtk_box_pack_start (GTK_BOX (dialog_vbox_Settings), notebook_Settings, TRUE, TRUE, 0);
	gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook_Settings), GTK_POS_LEFT);

	scrolledwindow_General = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_General);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_General);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_General), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_General = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_General);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_General), viewport_General);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_General), GTK_SHADOW_NONE);

	vbox_General = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_General);
	gtk_container_add (GTK_CONTAINER (viewport_General), vbox_General);

	frame_General_Interface = gtk_frame_new (NULL);
	gtk_widget_show (frame_General_Interface);
	gtk_box_pack_start (GTK_BOX (vbox_General), frame_General_Interface, FALSE, TRUE, 0);

	alignment_General_Interface = gtk_alignment_new (0.5, 0.5, 1, 1);
	gtk_widget_show (alignment_General_Interface);
	gtk_container_add (GTK_CONTAINER (frame_General_Interface), alignment_General_Interface);
	gtk_alignment_set_padding (GTK_ALIGNMENT (alignment_General_Interface), 0, 0, 12, 0);

	vbox_General_General = gtk_vbox_new (TRUE, 0);
	gtk_widget_show (vbox_General_General);
	gtk_container_add (GTK_CONTAINER (alignment_General_Interface), vbox_General_General);

	checkbutton_General_Interface_TrayIcon = gtk_check_button_new_with_mnemonic (_("Minimize to trayicon"));
	gtk_widget_show (checkbutton_General_Interface_TrayIcon);
	gtk_box_pack_start (GTK_BOX (vbox_General_General), checkbutton_General_Interface_TrayIcon, FALSE, FALSE, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_General_Interface_TrayIcon), Lecture_Gconf_Boolean (BOOL_MINIMIZED_TRAY_ICON));


	checkbutton_General_Interface_Minimized = gtk_check_button_new_with_mnemonic (_("Start minimized"));
	gtk_widget_show (checkbutton_General_Interface_Minimized);
	gtk_box_pack_start (GTK_BOX (vbox_General_General), checkbutton_General_Interface_Minimized, FALSE, FALSE, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_General_Interface_Minimized), Lecture_Gconf_Boolean (BOOL_START_MINIMIZED));


	hbox_General_SMTP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_SMTP);
	gtk_box_pack_start (GTK_BOX (vbox_General_General), hbox_General_SMTP, TRUE, TRUE, 0);

	label_General_SMTP = gtk_label_new (_("SMTP : "));
	gtk_widget_show (label_General_SMTP);
	gtk_box_pack_start (GTK_BOX (hbox_General_SMTP), label_General_SMTP, FALSE, FALSE, 0);

	entry_General_SMTP = gtk_entry_new ();
	gtk_widget_show (entry_General_SMTP);
	gtk_box_pack_start (GTK_BOX (hbox_General_SMTP), entry_General_SMTP, FALSE, TRUE, 0);
	gtk_entry_set_text (GTK_ENTRY (entry_General_SMTP), Lecture_Gconf_Char (CHAR_SERVEUR_SMTP));

	hbox_General_Audio_Device = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Audio_Device);
	gtk_box_pack_start (GTK_BOX (vbox_General_General), hbox_General_Audio_Device, TRUE, TRUE, 0);

	label_General_Audio_Device = gtk_label_new (_("Audio device : "));
	gtk_widget_show (label_General_Audio_Device);
	gtk_box_pack_start (GTK_BOX (hbox_General_Audio_Device), label_General_Audio_Device, FALSE, FALSE, 0);

	combobox_General_Audio_Device = creation_combo (FALSE);	
	creation_combo_Audio_Device ();
	gtk_widget_show (combobox_General_Audio_Device);
	gtk_box_pack_start (GTK_BOX (hbox_General_Audio_Device), combobox_General_Audio_Device, FALSE, TRUE, 0);


	label_General_Interface = gtk_label_new (_("General"));
	gtk_widget_show (label_General_Interface);
	gtk_frame_set_label_widget (GTK_FRAME (frame_General_Interface), label_General_Interface);
	gtk_label_set_use_markup (GTK_LABEL (label_General_Interface), TRUE);

	frame_General_Internet = gtk_frame_new (NULL);
	gtk_widget_show (frame_General_Internet);
	gtk_box_pack_start (GTK_BOX (vbox_General), frame_General_Internet, FALSE, TRUE, 5);

	alignment_General_Internet = gtk_alignment_new (0.5, 0.5, 1, 1);
	gtk_widget_show (alignment_General_Internet);
	gtk_container_add (GTK_CONTAINER (frame_General_Internet), alignment_General_Internet);
	gtk_alignment_set_padding (GTK_ALIGNMENT (alignment_General_Internet), 0, 0, 12, 0);

	vbox_General_Connection = gtk_vbox_new (TRUE, 0);
	gtk_widget_show (vbox_General_Connection);
	gtk_container_add (GTK_CONTAINER (alignment_General_Internet), vbox_General_Connection);

	radiobutton_General_Internet_Direct = gtk_radio_button_new_with_mnemonic (NULL, _("Direct connection to the Internet"));
	gtk_widget_show (radiobutton_General_Internet_Direct);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), radiobutton_General_Internet_Direct, FALSE, FALSE, 1);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Direct), radiobutton_General_Internet_Direct_group);
	radiobutton_General_Internet_Direct_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Direct));

	radiobutton_General_Internet_Http_Proxy = gtk_radio_button_new_with_mnemonic (NULL, _("Manual proxy configuration"));
	gtk_widget_show (radiobutton_General_Internet_Http_Proxy);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), radiobutton_General_Internet_Http_Proxy, FALSE, FALSE, 0);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Http_Proxy), radiobutton_General_Internet_Direct_group);
	radiobutton_General_Internet_Direct_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Http_Proxy));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_General_Internet_Http_Proxy), TRUE);

	hbox_General_Connection_Manual = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Connection_Manual);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), hbox_General_Connection_Manual, TRUE, TRUE, 0);

	label_General_Internet_Http_Proxy = gtk_label_new (_("HTTP Proxy :"));
	gtk_widget_show (label_General_Internet_Http_Proxy);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Manual), label_General_Internet_Http_Proxy, FALSE, FALSE, 10);

	entry_General_Internet_Http_Proxy = gtk_entry_new ();
	gtk_widget_show (entry_General_Internet_Http_Proxy);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Manual), entry_General_Internet_Http_Proxy, FALSE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry_General_Internet_Http_Proxy), TRUE);

	label_General_Internet_Port = gtk_label_new (_("Port :"));
	gtk_widget_show (label_General_Internet_Port);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Manual), label_General_Internet_Port, FALSE, FALSE, 10);

	spinbutton_General_Internet_Port_adj = gtk_adjustment_new (8080, 1, 65535, 1, 10, 10);
	spinbutton_General_Internet_Port = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_General_Internet_Port_adj), 1, 0);
	gtk_widget_show (spinbutton_General_Internet_Port);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Manual), spinbutton_General_Internet_Port, FALSE, TRUE, 0);

	radiobutton_General_Internet_Url = gtk_radio_button_new_with_mnemonic (NULL, _("Automatic proxy configuration"));
	gtk_widget_show (radiobutton_General_Internet_Url);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), radiobutton_General_Internet_Url, FALSE, FALSE, 0);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Url), radiobutton_General_Internet_Direct_group);
	radiobutton_General_Internet_Direct_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Url));

	hbox_General_Connection_Auto = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Connection_Auto);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), hbox_General_Connection_Auto, TRUE, TRUE, 0);

	label_Generel_Internet_Url = gtk_label_new (_("URL :"));
	gtk_widget_show (label_Generel_Internet_Url);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Auto), label_Generel_Internet_Url, FALSE, FALSE, 14);

	entry_General_Internet_Url = gtk_entry_new ();
	gtk_widget_show (entry_General_Internet_Url);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Auto), entry_General_Internet_Url, FALSE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry_General_Internet_Url), TRUE);

	checkbutton_General_Internet_Authentication = gtk_check_button_new_with_mnemonic (_("Authentication"));
	gtk_widget_show (checkbutton_General_Internet_Authentication);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), checkbutton_General_Internet_Authentication, FALSE, FALSE, 0);

	hbox_General_Connection_Authentication_User = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Connection_Authentication_User);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), hbox_General_Connection_Authentication_User, TRUE, TRUE, 0);

	label_General_Internet_Authentication_User = gtk_label_new (_("User :"));
	gtk_widget_show (label_General_Internet_Authentication_User);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Authentication_User), label_General_Internet_Authentication_User, FALSE, FALSE, 15);

	entry_General_Internet_Authentication_User = gtk_entry_new ();
	gtk_widget_show (entry_General_Internet_Authentication_User);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Authentication_User), entry_General_Internet_Authentication_User, FALSE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry_General_Internet_Authentication_User), TRUE);

	hbox_General_Connection_Authentication_Password = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Connection_Authentication_Password);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), hbox_General_Connection_Authentication_Password, FALSE, TRUE, 0);

	label_General_Internet_Authentication_Password = gtk_label_new (_("Password : "));
	gtk_widget_show (label_General_Internet_Authentication_Password);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Authentication_Password), label_General_Internet_Authentication_Password, FALSE, FALSE, 0);

	entry_General_Internet_Authentication_Password = gtk_entry_new ();
	gtk_widget_show (entry_General_Internet_Authentication_Password);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Authentication_Password), entry_General_Internet_Authentication_Password, FALSE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry_General_Internet_Authentication_Password), TRUE);
	gtk_entry_set_visibility (GTK_ENTRY (entry_General_Internet_Authentication_Password), FALSE);

	label_General_Internet = gtk_label_new (_("Connection to the Internet"));
	gtk_widget_show (label_General_Internet);
	gtk_frame_set_label_widget (GTK_FRAME (frame_General_Internet), label_General_Internet);
	gtk_label_set_use_markup (GTK_LABEL (label_General_Internet), TRUE);

	vbox_General_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_General_Icone);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 0), vbox_General_Icone);

	image_General = gtk_image_new_from_file (PATH_ICONE "configure.png");
	gtk_widget_show (image_General);
	gtk_box_pack_start (GTK_BOX (vbox_General_Icone), image_General, TRUE, TRUE, 0);

	label_General = gtk_label_new (_("General"));
	gtk_widget_show (label_General);
	gtk_box_pack_start (GTK_BOX (vbox_General_Icone), label_General, FALSE, FALSE, 0);

	scrolledwindow_Liste_Ports_Root = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Ports_Root);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_Liste_Ports_Root);
	gtk_widget_set_size_request (scrolledwindow_Liste_Ports_Root, 51, 70);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Ports_Root), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Liste_Ports = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Liste_Ports);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Ports_Root), viewport_Liste_Ports);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_Liste_Ports), GTK_SHADOW_NONE);

	vbox_Liste_Ports = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports);
	gtk_container_add (GTK_CONTAINER (viewport_Liste_Ports), vbox_Liste_Ports);

	scrolledwindow_Liste_Ports = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports), scrolledwindow_Liste_Ports, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Ports), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Ports), GTK_SHADOW_IN);

	
	Create_Liste_Port ();
	gtk_widget_show (treeview_Liste_Ports);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Ports), treeview_Liste_Ports);
	gtk_tree_view_set_enable_search (GTK_TREE_VIEW (treeview_Liste_Ports), FALSE);

	hbox_Liste_Ports = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports), hbox_Liste_Ports, FALSE, TRUE, 0);

	frame_Liste_Ports = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports), frame_Liste_Ports, TRUE, TRUE, 0);

	vbox_Liste_Ports_Change = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change);
	gtk_container_add (GTK_CONTAINER (frame_Liste_Ports), vbox_Liste_Ports_Change);

	hbox_Liste_Ports_Change = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change), hbox_Liste_Ports_Change, FALSE, TRUE, 0);

	vbox_Liste_Ports_Change_Port = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change), vbox_Liste_Ports_Change_Port, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Port_Port = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Port_Port);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port), hbox_Liste_Ports_Change_Port_Port, FALSE, TRUE, 2);

	label_Liste_Ports_Info_Port = gtk_label_new (_("Port :"));
	gtk_widget_show (label_Liste_Ports_Info_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Port), label_Liste_Ports_Info_Port, FALSE, FALSE, 20);

	spinbutton_Liste_Ports_Info_Port_adj = gtk_adjustment_new (1, 0, 65535, 1, 10, 10);
	spinbutton_Liste_Ports_Info_Port = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Liste_Ports_Info_Port_adj), 1, 0);
	gtk_widget_show (spinbutton_Liste_Ports_Info_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Port), spinbutton_Liste_Ports_Info_Port, FALSE, TRUE, 0);

	label_Liste_Ports_Info_Type = gtk_label_new (_("Type :"));
	gtk_widget_show (label_Liste_Ports_Info_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Port), label_Liste_Ports_Info_Type, FALSE, FALSE, 6);

	combobox_Liste_Ports_Info_Type = creation_combo (FALSE);	
	creation_combo_type_port ();
	gtk_widget_show (combobox_Liste_Ports_Info_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Port), combobox_Liste_Ports_Info_Type, FALSE, TRUE, 6);

	hbox_Liste_Ports_Change_Port_Service = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Port_Service);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port), hbox_Liste_Ports_Change_Port_Service, FALSE, TRUE, 2);

	label_Liste_Ports_Info_Service = gtk_label_new (_("Service : "));
	gtk_widget_show (label_Liste_Ports_Info_Service);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Service), label_Liste_Ports_Info_Service, FALSE, FALSE, 11);

	entry_Liste_Ports_Info_Service = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Ports_Info_Service);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Service), entry_Liste_Ports_Info_Service, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Port_Description = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Port_Description);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port), hbox_Liste_Ports_Change_Port_Description, FALSE, TRUE, 2);

	label_Liste_Ports_Info_Description = gtk_label_new (_("Description : "));
	gtk_widget_show (label_Liste_Ports_Info_Description);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Description), label_Liste_Ports_Info_Description, FALSE, FALSE, 2);

	entry_Liste_Ports_Info_Description = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Ports_Info_Description);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Description), entry_Liste_Ports_Info_Description, TRUE, TRUE, 0);

	vbox_Liste_Ports_Change_Port_Icon = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change_Port_Icon);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change), vbox_Liste_Ports_Change_Port_Icon, FALSE, TRUE, 8);

	fixed_Liste_Ports_Change_Port_Icon_Haut = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Port_Icon_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port_Icon), fixed_Liste_Ports_Change_Port_Icon_Haut, TRUE, TRUE, 0);

	iconentry_Liste_Ports_Info = gnome_icon_entry_new (NULL, NULL);
	gtk_widget_show (iconentry_Liste_Ports_Info);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port_Icon), iconentry_Liste_Ports_Info, FALSE, TRUE, 0);

	fixed_Liste_Ports_Change_Port_Icon_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Port_Icon_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port_Icon), fixed_Liste_Ports_Change_Port_Icon_Bas, TRUE, TRUE, 0);

	frame_Liste_Ports_Program = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liste_Ports_Program);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change), frame_Liste_Ports_Program, FALSE, TRUE, 0);

	hbox_Liste_Ports_Change_Program = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program);
	gtk_container_add (GTK_CONTAINER (frame_Liste_Ports_Program), hbox_Liste_Ports_Change_Program);

	vbox_Liste_Ports_Change_Program_Program = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change_Program_Program);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program), vbox_Liste_Ports_Change_Program_Program, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Program_Name = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program_Name);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Program), hbox_Liste_Ports_Change_Program_Name, FALSE, TRUE, 0);

	label_Liste_Ports_Program_Name = gtk_label_new (_("Name :"));
	gtk_widget_show (label_Liste_Ports_Program_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Name), label_Liste_Ports_Program_Name, FALSE, FALSE, 5);

	entry_Liste_Ports_Program_Name = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Ports_Program_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Name), entry_Liste_Ports_Program_Name, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Program_Path = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program_Path);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Program), hbox_Liste_Ports_Change_Program_Path, TRUE, TRUE, 0);

	label_Liste_Ports_Program_Path = gtk_label_new (_("Path :"));
	gtk_widget_show (label_Liste_Ports_Program_Path);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Path), label_Liste_Ports_Program_Path, FALSE, FALSE, 9);

	fileentry_Liste_Ports_Program_Path = gnome_file_entry_new (NULL, _("Path"));
	gtk_widget_show (fileentry_Liste_Ports_Program_Path);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Path), fileentry_Liste_Ports_Program_Path, FALSE, TRUE, 0);
	gnome_file_entry_set_modal (GNOME_FILE_ENTRY (fileentry_Liste_Ports_Program_Path), TRUE);
	g_object_set (G_OBJECT (fileentry_Liste_Ports_Program_Path), "use_filechooser", TRUE, "filechooser_action", GTK_FILE_CHOOSER_ACTION_OPEN, NULL);

	combo_entry_Liste_Ports_Program_Path = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (fileentry_Liste_Ports_Program_Path));
	gtk_widget_show (combo_entry_Liste_Ports_Program_Path);

	hbox_Liste_Ports_Change_Program_Params = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program_Params);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Program), hbox_Liste_Ports_Change_Program_Params, FALSE, TRUE, 0);

	label_Liste_Ports_Program_Param = gtk_label_new (_("Params :"));
	gtk_widget_show (label_Liste_Ports_Program_Param);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Params), label_Liste_Ports_Program_Param, FALSE, FALSE, 2);

	entry_Liste_Ports_Program_Param = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Ports_Program_Param);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Params), entry_Liste_Ports_Program_Param, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Program_Button = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program_Button);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Program), hbox_Liste_Ports_Change_Program_Button, FALSE, TRUE, 3);

	fixed_Liste_Ports_Change_Program_Button_Gauche = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Program_Button_Gauche);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Button), fixed_Liste_Ports_Change_Program_Button_Gauche, TRUE, TRUE, 0);

	button_Liste_Ports_Program_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Ports_Program_Add);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Button), button_Liste_Ports_Program_Add, FALSE, FALSE, 10);

	button_Liste_Ports_Program_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Ports_Program_Delete);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Button), button_Liste_Ports_Program_Delete, FALSE, FALSE, 0);

	fixed_Liste_Ports_Change_Program_Droite = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Program_Droite);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Button), fixed_Liste_Ports_Change_Program_Droite, TRUE, TRUE, 0);

	vbox_Liste_Ports_Change_Program_Icon = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change_Program_Icon);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program), vbox_Liste_Ports_Change_Program_Icon, FALSE, TRUE, 8);

	fixed_Liste_Ports_Change_Program_Icon_Haut = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Program_Icon_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Icon), fixed_Liste_Ports_Change_Program_Icon_Haut, TRUE, TRUE, 0);

	iconentry_Liste_Ports_Program = gnome_icon_entry_new (NULL, NULL);
	gtk_widget_show (iconentry_Liste_Ports_Program);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Icon), iconentry_Liste_Ports_Program, FALSE, TRUE, 3);

	fixed_Liste_Ports_Change_Program_Icon_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Program_Icon_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Icon), fixed_Liste_Ports_Change_Program_Icon_Bas, TRUE, TRUE, 0);

	label_Liste_Ports_Program = gtk_label_new (_("Programs"));
	gtk_widget_show (label_Liste_Ports_Program);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liste_Ports_Program), label_Liste_Ports_Program);
	gtk_label_set_use_markup (GTK_LABEL (label_Liste_Ports_Program), TRUE);

	label_Frame_Liste_Ports = gtk_label_new (_("Change, add, delete port"));
	gtk_widget_show (label_Frame_Liste_Ports);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liste_Ports), label_Frame_Liste_Ports);
	gtk_label_set_use_markup (GTK_LABEL (label_Frame_Liste_Ports), TRUE);

	vbox_Liste_Ports_Button = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Button);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports), vbox_Liste_Ports_Button, FALSE, TRUE, 9);

	fixed_Liste_Ports_Button_Haut = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Button_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), fixed_Liste_Ports_Button_Haut, TRUE, TRUE, 0);

	button_Liste_Ports_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Ports_Add);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), button_Liste_Ports_Add, FALSE, FALSE, 5);

	button_Liste_Ports_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Ports_Delete);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), button_Liste_Ports_Delete, FALSE, FALSE, 0);

	fixed_Liste_Ports_Button_Milieu = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Button_Milieu);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), fixed_Liste_Ports_Button_Milieu, TRUE, TRUE, 0);

	button_Liste_Ports_Ok = gtk_button_new_from_stock ("gtk-apply");
	gtk_widget_show (button_Liste_Ports_Ok);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), button_Liste_Ports_Ok, FALSE, FALSE, 5);

	button_Liste_Ports_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Liste_Ports_Cancel);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), button_Liste_Ports_Cancel, FALSE, FALSE, 0);

	fixed_Liste_Ports_Button_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Button_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), fixed_Liste_Ports_Button_Bas, TRUE, TRUE, 0);

	vbox_Liste_Ports_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Icone);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 1), vbox_Liste_Ports_Icone);

	image_Liste_Ports = gtk_image_new_from_file (PATH_ICONE "Port.png");
	gtk_widget_show (image_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Icone), image_Liste_Ports, FALSE, FALSE, 0);

	label_Liste_Ports = gtk_label_new (_("Ports"));
	gtk_widget_show (label_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Icone), label_Liste_Ports, FALSE, FALSE, 0);

	scrolledwindow_Liste_Signature_Root = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Signature_Root);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_Liste_Signature_Root);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Signature_Root), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Liste_Signature = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Liste_Signature);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Signature_Root), viewport_Liste_Signature);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_Liste_Signature), GTK_SHADOW_NONE);

	vbox_Liste_Signature = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature);
	gtk_container_add (GTK_CONTAINER (viewport_Liste_Signature), vbox_Liste_Signature);

	scrolledwindow_Liste_Signature = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature), scrolledwindow_Liste_Signature, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Signature), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Signature), GTK_SHADOW_IN);

	
	Create_Liste_Signature ();
	gtk_widget_show (treeview_Liste_Signature);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Signature), treeview_Liste_Signature);
	gtk_tree_view_set_enable_search (GTK_TREE_VIEW (treeview_Liste_Signature), FALSE);

	hbox_Liste_Signature = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature), hbox_Liste_Signature, FALSE, TRUE, 0);

	frame_Liste_Signature = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature), frame_Liste_Signature, TRUE, TRUE, 0);

	vbox_Liste_Signature_Change = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Change);
	gtk_container_add (GTK_CONTAINER (frame_Liste_Signature), vbox_Liste_Signature_Change);

	hbox_Liste_Signature_Change_Haut = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_Haut, FALSE, TRUE, 2);

	vbox_Liste_Signature_Change_Haut_Gauche = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Change_Haut_Gauche);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Haut), vbox_Liste_Signature_Change_Haut_Gauche, TRUE, TRUE, 0);

	hbox_Liste_Signature_Change_Name = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Name);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change_Haut_Gauche), hbox_Liste_Signature_Change_Name, FALSE, TRUE, 0);

	label_Liste_Signature_System_Name = gtk_label_new (_("System name : "));
	gtk_widget_show (label_Liste_Signature_System_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Name), label_Liste_Signature_System_Name, FALSE, FALSE, 5);

	entry_Liste_Signature_System_name = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_System_name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Name), entry_Liste_Signature_System_name, FALSE, TRUE, 7);

	hbox_Liste_Signature_Change_Type = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Type);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change_Haut_Gauche), hbox_Liste_Signature_Change_Type, FALSE, TRUE, 0);

	label_Liste_Signature_Type = gtk_label_new (_("Type  :"));
	gtk_widget_show (label_Liste_Signature_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Type), label_Liste_Signature_Type, FALSE, FALSE, 32);

	combobox_Liste_Signature_Type = creation_combo (FALSE);	
	creation_combo_type (combobox_Liste_Signature_Type);
	gtk_widget_show (combobox_Liste_Signature_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Type), combobox_Liste_Signature_Type, FALSE, TRUE, 0);

	

	hbox_Liste_Signature_Change_Signature = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change_Haut_Gauche), hbox_Liste_Signature_Change_Signature, TRUE, TRUE, 0);

	label_Liste_Signature_Md5 = gtk_label_new (_("Md5 Signature :"));
	gtk_widget_show (label_Liste_Signature_Md5);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Signature), label_Liste_Signature_Md5, FALSE, FALSE, 0);
	gtk_widget_set_size_request (label_Liste_Signature_Md5, 86, 16);

	entry_Liste_Signature_Md5 = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Md5);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Signature), entry_Liste_Signature_Md5, TRUE, TRUE, 8);
	gtk_widget_set_size_request (entry_Liste_Signature_Md5, 250, 21);

	vbox_Liste_Signature_Change_Haut_Icon = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Change_Haut_Icon);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Haut), vbox_Liste_Signature_Change_Haut_Icon, FALSE, TRUE, 0);

	iconentry_Liste_Signature = gnome_icon_entry_new (NULL, NULL);
	gtk_widget_show (iconentry_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change_Haut_Icon), iconentry_Liste_Signature, FALSE, TRUE, 0);
	gtk_widget_set_size_request (iconentry_Liste_Signature, 60, 60);

	hbox_Liste_Signature_Change_MAC = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_MAC);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_MAC, TRUE, TRUE, 0);

	label_Liste_Signature_MAC = gtk_label_new (_("MAC :"));
	gtk_widget_show (label_Liste_Signature_MAC);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), label_Liste_Signature_MAC, FALSE, FALSE, 27);

	entry_Liste_Signature_MAC = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_MAC);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), entry_Liste_Signature_MAC, FALSE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_MAC, 83, -1);
	gtk_entry_set_max_length (GTK_ENTRY (entry_Liste_Signature_MAC), 8);

	label_Liste_Signature_Open_Port = gtk_label_new (_("Open port :"));
	gtk_widget_show (label_Liste_Signature_Open_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), label_Liste_Signature_Open_Port, FALSE, FALSE, 23);

	spinbutton_Liste_Signature_Open_Port_adj = gtk_adjustment_new (-1, -1, 100, 1, 10, 10);
	spinbutton_Liste_Signature_Open_Port = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Liste_Signature_Open_Port_adj), 1, 0);
	gtk_widget_show (spinbutton_Liste_Signature_Open_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), spinbutton_Liste_Signature_Open_Port, FALSE, TRUE, 0);
	gtk_widget_set_size_request (spinbutton_Liste_Signature_Open_Port, 52, -1);
	gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_Liste_Signature_Open_Port), TRUE);

	hbox_Liste_Signature_Change_FTP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_FTP);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_FTP, TRUE, TRUE, 0);

	label_Liste_Signature_Header_FTP = gtk_label_new (_("FTP :"));
	gtk_widget_show (label_Liste_Signature_Header_FTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_FTP), label_Liste_Signature_Header_FTP, FALSE, FALSE, 5);
	gtk_widget_set_size_request (label_Liste_Signature_Header_FTP, 41, 16);

	combobox_Liste_Signature_FTP = creation_combo (FALSE);	
	creation_combo_etat_port (combobox_Liste_Signature_FTP);
	gtk_widget_show (combobox_Liste_Signature_FTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_FTP), combobox_Liste_Signature_FTP, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_FTP, 140, -1);

	entry_Liste_Signature_Header_FTP = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_FTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_FTP), entry_Liste_Signature_Header_FTP, TRUE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_Header_FTP, 238, -1);

	hbox_Liste_Signature_Change_HTTP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_HTTP);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_HTTP, TRUE, TRUE, 0);

	label_Liste_Signature_Header_HTTP = gtk_label_new (_("HTTP :"));
	gtk_widget_show (label_Liste_Signature_Header_HTTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_HTTP), label_Liste_Signature_Header_HTTP, FALSE, FALSE, 9);
	gtk_widget_set_size_request (label_Liste_Signature_Header_HTTP, 33, 16);

	combobox_Liste_Signature_HTTP = creation_combo (FALSE);	
	creation_combo_etat_port (combobox_Liste_Signature_HTTP);
	gtk_widget_show (combobox_Liste_Signature_HTTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_HTTP), combobox_Liste_Signature_HTTP, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_HTTP, 140, -1);

	entry_Liste_Signature_Header_HTTP = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_HTTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_HTTP), entry_Liste_Signature_Header_HTTP, TRUE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_Header_HTTP, 238, -1);

	hbox_Liste_Signature_Change_IMAP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_IMAP);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_IMAP, TRUE, TRUE, 0);

	label_Liste_Signature_Header_IMAP = gtk_label_new (_("IMAP :"));
	gtk_widget_show (label_Liste_Signature_Header_IMAP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_IMAP), label_Liste_Signature_Header_IMAP, FALSE, FALSE, 9);
	gtk_widget_set_size_request (label_Liste_Signature_Header_IMAP, 33, 16);

	combobox_Liste_Signature_IMAP = creation_combo (FALSE);	
	creation_combo_etat_port (combobox_Liste_Signature_IMAP);
	gtk_widget_show (combobox_Liste_Signature_IMAP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_IMAP), combobox_Liste_Signature_IMAP, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_IMAP, 140, -1);

	entry_Liste_Signature_Header_IMAP = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_IMAP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_IMAP), entry_Liste_Signature_Header_IMAP, TRUE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_Header_IMAP, 238, -1);

	hbox_Liste_Signature_Change_Telnet = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Telnet);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_Telnet, TRUE, TRUE, 0);

	label_Liste_Signature_Header_TELNET = gtk_label_new (_("Telnet :"));
	gtk_widget_show (label_Liste_Signature_Header_TELNET);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Telnet), label_Liste_Signature_Header_TELNET, FALSE, FALSE, 8);
	gtk_widget_set_size_request (label_Liste_Signature_Header_TELNET, 35, 16);

	combobox_Liste_Signature_Telnet = creation_combo (FALSE);	
	creation_combo_etat_port (combobox_Liste_Signature_Telnet);
	gtk_widget_show (combobox_Liste_Signature_Telnet);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Telnet), combobox_Liste_Signature_Telnet, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_Telnet, 140, -1);

	entry_Liste_Signature_Header_TELNET = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_TELNET);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Telnet), entry_Liste_Signature_Header_TELNET, TRUE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_Header_TELNET, 238, -1);

	label_Frame_Liste_Signature = gtk_label_new (_("Change, add, delete Os Fingerprinting"));
	gtk_widget_show (label_Frame_Liste_Signature);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liste_Signature), label_Frame_Liste_Signature);
	gtk_label_set_use_markup (GTK_LABEL (label_Frame_Liste_Signature), TRUE);

	vbox_Liste_Signature_Button = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Button);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature), vbox_Liste_Signature_Button, FALSE, TRUE, 9);

	fixed_Liste_Signature_Button_Haut = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Signature_Button_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), fixed_Liste_Signature_Button_Haut, TRUE, TRUE, 0);

	button_Liste_Signature_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Signature_Add);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), button_Liste_Signature_Add, FALSE, FALSE, 4);

	button_Liste_Signature_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Signature_Delete);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), button_Liste_Signature_Delete, FALSE, FALSE, 4);

	fixed_Liste_Signature_Button_Milieu = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Signature_Button_Milieu);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), fixed_Liste_Signature_Button_Milieu, TRUE, TRUE, 0);

	button_Liste_Signature_Ok = gtk_button_new_from_stock ("gtk-apply");
	gtk_widget_show (button_Liste_Signature_Ok);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), button_Liste_Signature_Ok, FALSE, FALSE, 4);

	button_Liste_Signature_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Liste_Signature_Cancel);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), button_Liste_Signature_Cancel, FALSE, FALSE, 4);

	fixed_Liste_Signature_Button_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Signature_Button_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), fixed_Liste_Signature_Button_Bas, TRUE, TRUE, 0);

	vbox_Liste_Signature_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Icone);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 2), vbox_Liste_Signature_Icone);

	image_Liste_Signature = gtk_image_new_from_file (PATH_ICONE "goto.png");
	gtk_widget_show (image_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Icone), image_Liste_Signature, TRUE, TRUE, 0);

	label_Liste_Signature = gtk_label_new (_("Fingerprinting"));
	gtk_widget_show (label_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Icone), label_Liste_Signature, FALSE, FALSE, 0);

	scrolledwindow_Liste_Scripts_Root = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Scripts_Root);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_Liste_Scripts_Root);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Scripts_Root), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Liste_Scripts = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Liste_Scripts);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Scripts_Root), viewport_Liste_Scripts);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_Liste_Scripts), GTK_SHADOW_NONE);

	vbox_Liste_Scripts = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts);
	gtk_container_add (GTK_CONTAINER (viewport_Liste_Scripts), vbox_Liste_Scripts);

	scrolledwindow_Liste_Scripts = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts), scrolledwindow_Liste_Scripts, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Scripts), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Scripts), GTK_SHADOW_IN);

	
	Create_Liste_Script ();
	gtk_widget_show (treeview_Liste_Scripts);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Scripts), treeview_Liste_Scripts);
	gtk_tree_view_set_enable_search (GTK_TREE_VIEW (treeview_Liste_Scripts), FALSE);

	hbox_Liste_Scripts = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts), hbox_Liste_Scripts, FALSE, TRUE, 0);

	frame_Liste_Scripts = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts), frame_Liste_Scripts, TRUE, TRUE, 0);

	hbox_Liste_Scripts_Change = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts_Change);
	gtk_container_add (GTK_CONTAINER (frame_Liste_Scripts), hbox_Liste_Scripts_Change);

	vbox_Liste_Scripts_Change_Gauche = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts_Change_Gauche);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change), vbox_Liste_Scripts_Change_Gauche, TRUE, TRUE, 0);

	hbox_Liste_Scripts_Change_Name = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts_Change_Name);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Gauche), hbox_Liste_Scripts_Change_Name, FALSE, TRUE, 0);

	label_Liste_Scripts_Name = gtk_label_new (_("Script name : "));
	gtk_widget_show (label_Liste_Scripts_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Name), label_Liste_Scripts_Name, FALSE, FALSE, 13);
	gtk_widget_set_size_request (label_Liste_Scripts_Name, -1, 16);

	entry_Liste_Scripts_name = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Scripts_name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Name), entry_Liste_Scripts_name, FALSE, TRUE, 0);

	hbox_Liste_Scripts_Change_Path = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts_Change_Path);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Gauche), hbox_Liste_Scripts_Change_Path, FALSE, TRUE, 0);

	label_Liste_Scripts_Path = gtk_label_new (_("Path  :"));
	gtk_widget_show (label_Liste_Scripts_Path);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Path), label_Liste_Scripts_Path, FALSE, FALSE, 34);

	fileentry_Liste_Scripts_Path = gnome_file_entry_new (NULL, NULL);
	gtk_widget_show (fileentry_Liste_Scripts_Path);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Path), fileentry_Liste_Scripts_Path, FALSE, TRUE, 0);
	gnome_file_entry_set_modal (GNOME_FILE_ENTRY (fileentry_Liste_Scripts_Path), TRUE);
	g_object_set (G_OBJECT (fileentry_Liste_Scripts_Path), "use_filechooser", TRUE, "filechooser_action", GTK_FILE_CHOOSER_ACTION_OPEN, NULL);

	combo_entry_Liste_Scripts_Path = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (fileentry_Liste_Scripts_Path));
	gtk_widget_show (combo_entry_Liste_Scripts_Path);

	hbox_Liste_Scripts_Change_Param = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts_Change_Param);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Gauche), hbox_Liste_Scripts_Change_Param, FALSE, TRUE, 0);

	label_Liste_Scripts_Params = gtk_label_new (_("Params :"));
	gtk_widget_show (label_Liste_Scripts_Params);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Param), label_Liste_Scripts_Params, FALSE, FALSE, 27);

	entry_Liste_Scripts_Params = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Scripts_Params);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Param), entry_Liste_Scripts_Params, FALSE, TRUE, 0);

	vbox_Liste_Scripts_Change_Icon = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts_Change_Icon);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change), vbox_Liste_Scripts_Change_Icon, FALSE, TRUE, 10);

	iconentry_Liste_Scripts = gnome_icon_entry_new (NULL, NULL);
	gtk_widget_show (iconentry_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Icon), iconentry_Liste_Scripts, FALSE, TRUE, 0);

	fixed_Liste_Scripts_Change_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Scripts_Change_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Icon), fixed_Liste_Scripts_Change_Bas, TRUE, TRUE, 0);

	label_Frame_Liste_Scripts = gtk_label_new (_("Change, add, delete Scripts"));
	gtk_widget_show (label_Frame_Liste_Scripts);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liste_Scripts), label_Frame_Liste_Scripts);
	gtk_label_set_use_markup (GTK_LABEL (label_Frame_Liste_Scripts), TRUE);

	vbox_Liste_Scripts_Change_Button = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts_Change_Button);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts), vbox_Liste_Scripts_Change_Button, FALSE, TRUE, 6);
	gtk_container_set_border_width (GTK_CONTAINER (vbox_Liste_Scripts_Change_Button), 4);

	button_Liste_Scripts_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Scripts_Add);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Button), button_Liste_Scripts_Add, FALSE, FALSE, 0);

	button_Liste_Scripts_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Scripts_Delete);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Button), button_Liste_Scripts_Delete, FALSE, FALSE, 6);

	button_Liste_Scripts_Ok = gtk_button_new_from_stock ("gtk-apply");
	gtk_widget_show (button_Liste_Scripts_Ok);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Button), button_Liste_Scripts_Ok, FALSE, FALSE, 6);

	button_Liste_Scripts_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Liste_Scripts_Cancel);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Button), button_Liste_Scripts_Cancel, FALSE, FALSE, 0);

	vbox_Liste_Scripts_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts_Icone);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 3), vbox_Liste_Scripts_Icone);

	image_Liste_Scripts = gtk_image_new_from_file (PATH_ICONE "openterm.png");
	gtk_widget_show (image_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Icone), image_Liste_Scripts, TRUE, TRUE, 0);

	label_Liste_Scripts = gtk_label_new (_("Scripts"));
	gtk_widget_show (label_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Icone), label_Liste_Scripts, FALSE, FALSE, 0);


	scrolledwindow_Liste_Restore_Root = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Restore_Root);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_Liste_Restore_Root);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Restore_Root), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Liste_Restore = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Liste_Restore);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Restore_Root), viewport_Liste_Restore);

	vbox_Liste_Restore = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Restore);
	gtk_container_add (GTK_CONTAINER (viewport_Liste_Restore), vbox_Liste_Restore);

	scrolledwindow_Liste_Restore = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore), scrolledwindow_Liste_Restore, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Restore), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	
	Create_Liste_Restore ();
	gtk_widget_show (treeview_Liste_Restore);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Restore), treeview_Liste_Restore);

	hbox_Liste_Restore = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore), hbox_Liste_Restore, FALSE, TRUE, 0);

	frame_Liest_Restore = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liest_Restore);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Restore), frame_Liest_Restore, TRUE, TRUE, 0);
	gtk_frame_set_shadow_type (GTK_FRAME (frame_Liest_Restore), GTK_SHADOW_NONE);

	vbox_Liste_Restore_Change = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Restore_Change);
	gtk_container_add (GTK_CONTAINER (frame_Liest_Restore), vbox_Liste_Restore_Change);


	fileentry_Liste_Restore = gnome_file_entry_new (NULL, NULL);
	gtk_widget_show (fileentry_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change), fileentry_Liste_Restore, FALSE, TRUE, 0);
	gnome_file_entry_set_modal (GNOME_FILE_ENTRY (fileentry_Liste_Restore), TRUE);
	g_object_set (G_OBJECT (fileentry_Liste_Restore), "use_filechooser", TRUE, "filechooser_action", GTK_FILE_CHOOSER_ACTION_OPEN, NULL);

	combo_entry_Liste_Restore = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (fileentry_Liste_Restore));
	gtk_widget_show (combo_entry_Liste_Restore);

	label_Frame_Liste_Restore = gtk_label_new (_("Change, add, delete"));
	gtk_widget_show (label_Frame_Liste_Restore);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liest_Restore), label_Frame_Liste_Restore);
	gtk_label_set_use_markup (GTK_LABEL (label_Frame_Liste_Restore), TRUE);

	vbox_Liste_Restore_Change_Button = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Restore_Change_Button);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Restore), vbox_Liste_Restore_Change_Button, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (vbox_Liste_Restore_Change_Button), 4);

	button_Liste_Restore_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Restore_Add);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change_Button), button_Liste_Restore_Add, FALSE, FALSE, 0);

	button_Liste_Restore_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Restore_Delete);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change_Button), button_Liste_Restore_Delete, FALSE, FALSE, 6);

	button_Liste_Restore_Ok = gtk_button_new_from_stock ("gtk-apply");
	gtk_widget_show (button_Liste_Restore_Ok);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change_Button), button_Liste_Restore_Ok, FALSE, FALSE, 6);

	button_Liste_Restore_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Liste_Restore_Cancel);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change_Button), button_Liste_Restore_Cancel, FALSE, FALSE, 0);

	vbox_Liste_Restore_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Restore_Icone);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 4), vbox_Liste_Restore_Icone);

	image_Liste_Restore = gtk_image_new_from_file (PATH_ICONE "Restore.png");
	gtk_widget_show (image_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Icone), image_Liste_Restore, TRUE, TRUE, 0);

	label_Liste_Restore = gtk_label_new (_("Restore"));
	gtk_widget_show (label_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Icone), label_Liste_Restore, FALSE, FALSE, 0);


	dialog_action_area_Settings = GTK_DIALOG (dialog_Settings)->action_area;
	gtk_widget_show (dialog_action_area_Settings);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area_Settings), GTK_BUTTONBOX_END);

	button_Settings_Save = gtk_button_new_from_stock ("gtk-save");
	gtk_widget_show (button_Settings_Save);
	gtk_dialog_add_action_widget (GTK_DIALOG (dialog_Settings), button_Settings_Save, GTK_RESPONSE_CLOSE);
	GTK_WIDGET_SET_FLAGS (button_Settings_Save, GTK_CAN_DEFAULT);

	g_signal_connect ((gpointer) radiobutton_General_Internet_Direct, "clicked", G_CALLBACK (on_radiobutton_General_Internet_Direct_clicked), NULL);
	g_signal_connect ((gpointer) radiobutton_General_Internet_Http_Proxy, "clicked", G_CALLBACK (on_radiobutton_General_Internet_Http_Proxy_clicked), NULL);
	g_signal_connect ((gpointer) radiobutton_General_Internet_Url, "clicked", G_CALLBACK (on_radiobutton_General_Internet_Url_clicked), NULL);
	g_signal_connect ((gpointer) checkbutton_General_Internet_Authentication, "clicked", G_CALLBACK (on_checkbutton_General_Internet_Authentication_clicked), NULL);
	
	g_signal_connect ((gpointer) spinbutton_Liste_Ports_Info_Port, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Ports_Info_Type, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Ports_Info_Service, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Ports_Info_Description, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) iconentry_Liste_Ports_Info, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Ports_Program_Name, "changed", G_CALLBACK (Liste_Ports_changed_Program), NULL);
	g_signal_connect ((gpointer) combo_entry_Liste_Ports_Program_Path, "changed", G_CALLBACK (Liste_Ports_changed_Program), NULL);
	g_signal_connect ((gpointer) entry_Liste_Ports_Program_Param, "changed", G_CALLBACK (Liste_Ports_changed_Program), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Program_Add, "clicked", G_CALLBACK (on_button_Liste_Ports_Program_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Program_Delete, "clicked", G_CALLBACK (on_button_Liste_Ports_Program_Delete_clicked), NULL);
	g_signal_connect ((gpointer) iconentry_Liste_Ports_Program, "changed", G_CALLBACK (Liste_Ports_changed_Program), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Add, "clicked", G_CALLBACK (on_button_Liste_Ports_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Delete, "clicked", G_CALLBACK (on_button_Liste_Ports_Delete_clicked), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_System_name, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_Type, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	
	g_signal_connect ((gpointer) entry_Liste_Signature_Md5, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) iconentry_Liste_Signature, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_MAC, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) spinbutton_Liste_Signature_Open_Port, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_FTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_FTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_HTTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_HTTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_IMAP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_IMAP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_Telnet, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_TELNET, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) button_Liste_Signature_Add, "clicked", G_CALLBACK (on_button_Liste_Signature_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Signature_Delete, "clicked", G_CALLBACK (on_button_Liste_Signature_Delete_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Signature_Ok, "clicked", G_CALLBACK (on_button_Liste_Signature_Ok_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Signature_Cancel, "clicked", G_CALLBACK (on_button_Liste_Signature_Cancel_clicked), NULL);
	g_signal_connect ((gpointer) entry_Liste_Scripts_name, "changed", G_CALLBACK (Liste_Script_changed), NULL);
	g_signal_connect ((gpointer) combo_entry_Liste_Scripts_Path, "changed", G_CALLBACK (Liste_Script_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Scripts_Params, "changed", G_CALLBACK (Liste_Script_changed), NULL);
	g_signal_connect ((gpointer) iconentry_Liste_Scripts, "changed", G_CALLBACK (Liste_Script_changed), NULL);
	g_signal_connect ((gpointer) button_Liste_Scripts_Add, "clicked", G_CALLBACK (on_button_Liste_Scripts_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Scripts_Delete, "clicked", G_CALLBACK (on_button_Liste_Scripts_Delete_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Scripts_Ok, "clicked", G_CALLBACK (on_button_Liste_Scripts_Ok_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Scripts_Cancel, "clicked", G_CALLBACK (on_button_Liste_Scripts_Cancel_clicked), NULL);
	g_signal_connect ((gpointer) button_Settings_Save, "clicked", G_CALLBACK (on_button_Settings_Save_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Cancel, "clicked", G_CALLBACK (on_button_Liste_Ports_Cancel_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Ok, "clicked", G_CALLBACK (on_button_Liste_Ports_Ok_clicked), NULL);
	g_signal_connect ((gpointer) dialog_Settings, "delete_event", G_CALLBACK (on_dialog_Settings_delete_event), NULL);
	
	g_signal_connect ((gpointer) combo_entry_Liste_Restore, "changed", G_CALLBACK (Liste_Restore_changed), NULL);
	g_signal_connect ((gpointer) button_Liste_Restore_Add, "clicked", G_CALLBACK (on_button_Liste_Restore_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Restore_Delete, "clicked", G_CALLBACK (on_button_Liste_Restore_Delete_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Restore_Ok, "clicked", G_CALLBACK (on_button_Liste_Restore_Ok_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Restore_Cancel, "clicked", G_CALLBACK (on_button_Liste_Restore_Cancel_clicked), NULL);

	Initialisation_Liste_Signature ();
	Initialisation_Liste_Port ();
	Initialisation_Liste_Script ();
	Initialisation_Liste_Restore ();
}
