/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gnome.h>
#include "Modules.h"
#include "Objet_Liste.h"
#include "Objet_Icone.h"
#include "Reseau.h"
#include "Objet.h"
#include "Interface/Nessus_Interface.h"
#include "Interface/Samba_Connect_Interface.h"
#include "Interface/NetSend_Interface.h"
#include "Interface/Snmp_Interface.h"
#include "Interface/Nessus_Message_Interface.h"
#include "Interface/Script_Interface.h"
#include "Interface/Root_Interface.h"
#include "Interface/Console.h"
#include "Equipement_Port.h"
#include "Settings_Port.h"
#include "Module_Samba.h"
#include "Debug.h"
#include "Animation.h"

void Initialisation_Aucun_Module ()
{
	GtkWidget *Liste_Vide;

	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_Aucun_Module");
	Destruction_Modules ();
	scrolledwindow_Vide = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Vide);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), scrolledwindow_Vide);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Vide), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	Liste_Vide = Create_Liste (FALSE, FALSE, FALSE, FALSE);
	gtk_widget_show (Liste_Vide);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Vide), Liste_Vide);
	Modules_Actuel = AUCUN_MODULES_SELECTIONNER;
}


void Initialisation_Liste_ports ()
{
	struct Struct_Port *Port = NULL;
	struct Struct_Modele_Objet *Objet = NULL;
	gchar    *Nom_Port = NULL;
	gint      i, Nb_Objet_Liste;

	if (Reseau_Selectionner == NULL)
		return;
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_Liste_ports");
	Destruction_Modules ();
	Modules_Actuel = MODULES_LISTE_PORTS;
	
	treeview_Modules = Create_Icone (FALSE, TRUE, FALSE);	
	
	Nb_Objet_Liste = g_list_length (Equipement_Selectionner->GList_Port);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Port = g_list_nth_data (Equipement_Selectionner->GList_Port, i);
		if ((Nom_Port = Nom_Du_Port (Port->Num_Port)) != NULL) {
			Objet = Ajouter_Nouvelle_Objet (PORTS, Nom_Port, (gpointer *) Port, NULL, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_MODULE);
			if (Port->Etat_Port == FERMER) {
				Affiche_Icone_Defaut_Griser_Objet_liste (Objet, Reseau_Selectionner);
				Change_Couleur_Gris_Texte_liste (Objet, Reseau_Selectionner);
			}
			Objet->Notification_En_Cours = Port->Notification_En_Cours;	
			if (Port->Alert_notification)
				Active_Test_Etat_Objet (Objet, Reseau_Selectionner);
		}
		else
			debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port a ete supprimer");
	}
}


void Initialisation_Partage_Fichier_Smb ()
{
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_Partage_Fichier_Smb");
	Destruction_Modules ();
	Modules_Actuel = MODULES_PARTAGE_FICHIER_SMB;
	create_win_Samba_Connect ();
	if (Equipement_Selectionner->User_Smb != NULL)
		gtk_entry_set_text (GTK_ENTRY (entry_Samba_Connect_User), Equipement_Selectionner->User_Smb);
	if (Equipement_Selectionner->Password_Smb != NULL)
		gtk_entry_set_text (GTK_ENTRY (entry_Samba_Connect_Password), Equipement_Selectionner->Password_Smb);
	gtk_entry_set_text (GTK_ENTRY (entry_Samba_Connect_Domaine), Equipement_Selectionner->Smb.DomainName);
}


void Initialisation_Partage_Fichier_Smb_Browser ()
{
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_Partage_Fichier_Smb_Browser");
	Destruction_Modules ();
	Modules_Actuel = MODULES_PARTAGE_FICHIER_SMB_BROWSER;
	scrolledwindow_Liste = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), scrolledwindow_Liste);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	treeview_Modules = Create_Liste (TRUE, TRUE, TRUE, TRUE);	
	gtk_widget_show (treeview_Modules);	
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste), treeview_Modules);	
}


void Initialisation_Nessus ()
{
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_Nessus");
	Destruction_Modules ();
	create_win_Nessus_Connect ();
	if (Reseau_Selectionner->User_Nessus != NULL)
		gtk_entry_set_text (GTK_ENTRY (entry_Nessus_Connect_User), Reseau_Selectionner->User_Nessus);
	if (Reseau_Selectionner->Password_Nessus != NULL)
		gtk_entry_set_text (GTK_ENTRY (entry_Nessus_Connect_Password), Reseau_Selectionner->Password_Nessus);
	if (Reseau_Selectionner->IP_Nessus != NULL)
		gtk_entry_set_text (GTK_ENTRY (entry_Nessus_Connect_Domaine), Reseau_Selectionner->IP_Nessus);
	Modules_Actuel = MODULES_NESSUS;
}


void Initialisation_Telnet ()
{
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_Telnet");
	Destruction_Modules ();
	Widget_Telnet = Creation_Console ("telnet");
	Modules_Actuel = MODULES_TELNET;
}


void Initialisation_SSH ()
{
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_SSH");
	Destruction_Modules ();
	Widget_Telnet = Creation_Console ("ssh");
	Modules_Actuel = MODULES_SSH;
}


void Initialisation_NetSend ()
{
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_NetSend");
	Destruction_Modules ();
	create_win_NetSend ();
	Modules_Actuel = MODULES_NET_SEND;
}

void Initialisation_Nessus_Message ()
{
	if (Modules_Actuel != MODULES_NESSUS_MESSAGE) {
		debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_Nessus");
		gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
		gtk_widget_set_sensitive (button_Refresh, FALSE);
		Destruction_Modules ();
		create_win_Nessus ();
		Modules_Actuel = MODULES_NESSUS_MESSAGE;
	}
}


void Initialisation_Script ()
{
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_Script");
	Destruction_Modules ();
	create_win_Script ();
	Modules_Actuel = MODULES_SCRIPTS;
}


void Initialisation_Snmp ()
{
	if (Modules_Actuel != MODULES_SNMP) {
		debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Initialisation_Snmp");
		Destruction_Modules ();
		create_win_Snmp ();
		gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
		Modules_Actuel = MODULES_SNMP;
	}
}

void Destruction_Modules ()
{
	switch (Modules_Actuel) {
	    case AUCUN_MODULES_SELECTIONNER:
		    gtk_widget_destroy (scrolledwindow_Vide);
		    break;
	    case MODULES_LISTE_PORTS:
		    Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_MODULE);	
		    gtk_widget_destroy (scrolledwindow_Icone_Liste);
		    break;
	    case MODULES_PARTAGE_FICHIER_SMB:
		    gtk_widget_destroy (scrolledwindow_Samba_Connect);
		    break;
	    case MODULES_PARTAGE_FICHIER_SMB_BROWSER:
		    Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_MODULE);	
		    gtk_widget_destroy (scrolledwindow_Liste);
		    break;
	    case MODULES_NESSUS:
		    gtk_widget_destroy (scrolledwindow_Nessus_Connect);
		    break;
	    case MODULES_TELNET:
		    gtk_widget_destroy (Widget_Telnet);
		    break;
	    case MODULES_SSH:
		    gtk_widget_destroy (Widget_Telnet);
		    break;
	    case MODULES_SCRIPTS:
		    gtk_widget_destroy (scrolledwindow_Script);
		    break;
	    case MODULES_NET_SEND:
		    gtk_widget_destroy (scrolledwindow_NetSend);
		    break;
	    case MODULES_NESSUS_MESSAGE:
		    gtk_widget_destroy (scrolledwindow_Nessus);
		    gtk_widget_set_sensitive (combobox_liste_Modules, TRUE);
		    gtk_widget_set_sensitive (button_Refresh, TRUE);
		    break;
	    case MODULES_SNMP:
		    gtk_widget_set_sensitive (combobox_liste_Modules, TRUE);
		    gtk_widget_destroy (scrolledwindow_Snmp);
		    break;
	    default:
		    debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Erreur : Destruction_Modules modules %d Inconnu", Modules_Actuel);
	}

}


void Initialisation_Modules ()
{
	GtkWidget *Liste_Vide;

	scrolledwindow_Vide = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Vide);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), scrolledwindow_Vide);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Vide), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	Liste_Vide = Create_Liste (FALSE, FALSE, FALSE, FALSE);
	gtk_widget_show (Liste_Vide);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Vide), Liste_Vide);
	Modules_Actuel = AUCUN_MODULES_SELECTIONNER;
}
