/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gnome.h>
#include "Objet.h"
#include "Image.h"
#include "Objet_Liste.h"
#include "Declaration_Constante.h"
#include "Interface/Root_Interface.h"
#include "Objet_Gestion_Texte.h"
#include "Equipement_Port.h"
#include "Module_Samba.h"
#include "Debug.h"
#include "Nessus.h"
#include "Snmp.h"

struct Struct_Modele_Objet Liste_Modele_Objet[] = {
	
	{LISTE_SERVEUR, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Server", NULL, NULL, NULL, PATH_ICONE "Type/Serveur.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_SWITCH, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Switch", NULL, NULL, NULL, PATH_ICONE "Type/switch.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_MULTIMEDIA, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Multimedia", NULL, NULL, NULL, PATH_ICONE "Type/tv.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_CONSOLE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Console", NULL, NULL, NULL, PATH_ICONE "Type/Console.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_WIFI, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Wifi", NULL, NULL, NULL, PATH_ICONE "Type/Wifi.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_PDA, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Pda", NULL, NULL, NULL, PATH_ICONE "Type/pda.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_IMPRIMANTE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Printer", NULL, NULL, NULL, PATH_ICONE "Type/printer.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_ROUTEUR, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Router", NULL, NULL, NULL, PATH_ICONE "Type/router.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_STATION, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Workstation", NULL, NULL, NULL, PATH_ICONE "Type/mycomputer.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_DISQUE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Disk", NULL, NULL, NULL, PATH_ICONE "Type/Disk.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_CAMERA, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Camera", NULL, NULL, NULL, PATH_ICONE "Type/camera.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_UPS, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "UPS", NULL, NULL, NULL, PATH_ICONE "Type/ups.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_TELEPHONIE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Ip phone", NULL, NULL, NULL, PATH_ICONE "/Type/Phone.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_ROUTEUR_SWITCH, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Router-Switch", NULL, NULL, NULL, PATH_ICONE "Type/routerswitch.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_ROUTEUR_ADSL, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Router ADSL", NULL, NULL, NULL, PATH_ICONE "Type/Modem.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_MODEM, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Modem", NULL, NULL, NULL, PATH_ICONE "Type/Modem.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_FIREWALL, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Firewall", NULL, NULL, NULL, PATH_ICONE "Type/firewall.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_VPN, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Vpn", NULL, NULL, NULL, PATH_ICONE "Type/firewall.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_INCONNU, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Unknown", NULL, NULL, NULL, PATH_ICONE "Type/Inconnu.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_FIREWALLED, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Firewalled", NULL, NULL, NULL, PATH_ICONE "Type/firewall.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_MODELE_DOMAINE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Domaine???", NULL, NULL, NULL, PATH_ICONE "Type/Domaine.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Type_OU_Domaine, NULL, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{LISTE_MODELE_EQUIPEMENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Type/Default.png", &Copie_Icone_Equipement, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Equipement, &Action_Test_Click, &Action_Switch_Mode_Detaille, &Action_Raffraichir_Equipement, &Notification_Equipement, FALSE, NULL, NULL, NULL, NULL, FALSE, &Action_Test_Favoris},
	{LISTE_MODELE_EQUIPEMENT_INCONNU, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Type/Inconnu.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Equipement_Inconnu, &Action_Test_Click, &Action_Switch_Mode_Detaille, &Action_Raffraichir_Equipement, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, &Action_Test_Favoris},
	{LISTE_MODELE_EQUIPEMENT_AGENT_AUTOSCAN, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Localhost.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Action_Selection_Equipement, &Action_Test_Click, &Action_Switch_Mode_Detaille, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, &Action_Test_Favoris},


	{INFO_ADRESSE_IP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Ip Address : %s", &Gestion_Texte_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_ADRESSE_MAC, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Mac Address : %s", &Gestion_Texte_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_FOURNISSEUR, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Network card : %s", &Gestion_Texte_Fournisseur_Equipement, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_OS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "System : %s", &Gestion_Texte_Syteme_Equipement, NULL, NULL, PATH_ICONE "System.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NOM_HOTE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Host Name : %s", &Gestion_Texte_HostName_Equipement, NULL, NULL, PATH_ICONE "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_ALIAS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Alias : %s", NULL, NULL, NULL, PATH_ICONE "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NOM_DOMAINE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Domain/WorkGroup : %s", &Gestion_Texte_Domaine_Equipement, NULL, NULL, PATH_ICONE "Domaine.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NOM_UTILISATEUR, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "User : %s", &Gestion_Texte_Utilisateur_Equipement, NULL, NULL, PATH_ICONE "user.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INFO, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Info", NULL, NULL, NULL, PATH_ICONE "Information.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_PORTS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "TCP port : Open (%d/%d) Firewalled (%d/%d)", &Gestion_Texte_Port_Info_Equipement, NULL, NULL, PATH_ICONE "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_CONTACT_ADMIN, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Admin Email : %s", &Gestion_Pointeur_Texte_Default, NULL, "Admin Email : ", PATH_ICONE "Email.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},


	{INFO_SNMP, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Snmp", NULL, NULL, NULL, PATH_ICONE "Snmp.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_SYSTEM, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "System", NULL, NULL, NULL, PATH_ICONE "System.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_SYSTEM_NAME, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "System name : %s", &Gestion_Texte_Default, NULL, NULL, PATH_ICONE "System.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_SYSTEM_DESCRIPTION, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Description : %s", &Gestion_Texte_Default, NULL, NULL, PATH_ICONE "Notes.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_SYSTEM_CONTACT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Contact : %s", &Gestion_Texte_Default, NULL, NULL, PATH_ICONE "user.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_SYSTEM_LOCATION, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Location : %s", &Gestion_Texte_Default, NULL, NULL, PATH_ICONE "Localisation.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_SYSTEM_UPTIME, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Uptime : %s", &Gestion_Texte_Default, NULL, NULL, PATH_ICONE "clock.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_SYSTEM_RAM, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Ram : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "Memory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_SYSTEM_DEVICE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Device", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_SYSTEM_LOGICAL_STORAGE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Logical storage", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_SYSTEM_SERVICE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Service", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_NETWORK, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Network", NULL, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_ARP, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "ARP Table", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_ROUTES, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Routes", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_NETWORK_INTERFACES, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Interfaces", NULL, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_INTERFACES_BASIC, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Basic Info", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_INTERFACES_IN, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "In Statistic", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_INTERFACES_OUT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Out Statistic", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_NETWORK_TCPIP, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "TCP/IP", NULL, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_NETWORK, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Networks", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_TCP_CONNECTIONS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "TCP Connections", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_UDP_SERVICES, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "UDP Services", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_NETWORK_TCPIP_IP, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "IP", NULL, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Info", NULL, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_FORWARDING, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Ip forwarding : %s", &Gestion_Texte_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_TTL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Default TTL : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_REASS_TIMEOUT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Reassembly timeout : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_NEED_REASS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Needed to be reassembled : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_RE_ASSEM, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Re-assembled : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_REAS_FAIL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Reassembly failures : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_SUCCESS_FRAG, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Successfully fragmented : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_FRAG_FAIL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Fragmentation failures : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_CREAT_FRAG, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Created fragments : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_DISC_ROUT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Discarded routing entries : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Input datagrams", NULL, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_ALL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "All : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_FORWARDED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Forwarded : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_DELIVERED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Delivered : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_HEADER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Header errors : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_ADDRESS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Address errors : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_PROTOCOL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Unknown protocols : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_INPUT_BUFFER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Buffer errors : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_NETWORK_TCPIP_IP_OUPUT, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Output datagrams", NULL, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_REQUESTED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Requested : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_BUFFER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Buffer errors : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_ROUTED, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Not routed : %i", &Gestion_Integer_Default, NULL, NULL, PATH_ICONE "hwinfo.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_SOFTWARE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Software", NULL, NULL, NULL, PATH_ICONE "Software.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_RUNNING_SOFTWARE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Running Software", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	
	{INFO_SNMP_BRIDGE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Brigde, Switch", NULL, NULL, NULL, PATH_ICONE "Switch.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_BRIDGE_FORWARDING_DATABASE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Forwarding database", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_SNMP_BRIDGE_STATIC_DATABASE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Static database", NULL, NULL, NULL, PATH_ICONE "tableau.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Affiche_Snmp, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},


	
	{INFO_INVENTAIRE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Inventory", NULL, NULL, NULL, PATH_ICONE "Inventory.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_CONTACT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Contact Person : %s", &Gestion_Pointeur_Texte_Default, NULL, "Contact Person : ", PATH_ICONE "user.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_TEL_CONTACT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Contact : %s", &Gestion_Pointeur_Texte_Default, NULL, "Contact : ", PATH_ICONE "Phone.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_NUM_SERIE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Serial Number : %s", &Gestion_Pointeur_Texte_Default, NULL, "Serial Number : ", PATH_ICONE "UC.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_NUM_SERIE_ECRAN, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Serial Number (Display) : %s", &Gestion_Pointeur_Texte_Default, NULL, "Serial Number (Display) : ", PATH_ICONE "Display.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_NUM_SERIE_IMPRIMANTE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Serial Number (Printer) : %s", &Gestion_Pointeur_Texte_Default, NULL, "Serial Number (Printer) : ", PATH_ICONE "Printer.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_NUM_SERIE_OS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Serial Number (OS) : %s", &Gestion_Pointeur_Texte_Default, NULL, "Serial Number (OS) : ", PATH_ICONE "System.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_NUM_SERIE_SUITE_OFFICE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Serial Number (Office Suite) : %s", &Gestion_Pointeur_Texte_Default, NULL, "Serial Number (Office Suite) : ", PATH_ICONE "soffice.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_PROCESSEUR, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Processor : %s", &Gestion_Pointeur_Texte_Default, NULL, "Processor : ", PATH_ICONE "Processor.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_MEMOIRE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "RAM (in MB) : %s", &Gestion_Pointeur_Texte_Default, NULL, "RAM (in MB) : ", PATH_ICONE "Memory.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_DISQUE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Hard Drive Space (in gigabytes) : %s", &Gestion_Pointeur_Texte_Default, NULL, "Hard Drive Space (in gigabytes) : ", PATH_ICONE "Disk.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_NOTES, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Notes : %s", &Gestion_Pointeur_Texte_Default, NULL, "Notes : ", PATH_ICONE "Notes.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_INVENTAIRE_LOCALISATION, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Localisation : %s", &Gestion_Pointeur_Texte_Default, NULL, "Localisation : ", PATH_ICONE "Localisation.png", NULL, NULL, NULL, 0, FALSE, &Edit_Texte_Liste_Machine, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},

	{INFO_NETBIOS, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "NetBios names", NULL, NULL, NULL, PATH_ICONE "NetBios.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NETBIOS_ENFANT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "NetBios.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NESSUS, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Nessus", NULL, NULL, NULL, PATH_ICONE "Nessus.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NESSUS_VULNERABILITE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Vulnerabilities", NULL, NULL, NULL, PATH_ICONE "Nessus_Error.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NESSUS_POTENTIEL, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Potential Vulnerabilities", NULL, NULL, NULL, PATH_ICONE "Nessus_Warning.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NESSUS_INFO, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "Info", NULL, NULL, NULL, PATH_ICONE "Nessus_Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NESSUS_ENFANT_VULNERABILITE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Nessus.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Nessus_Affiche_Message, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NESSUS_ENFANT_POTENTIEL, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Nessus.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Nessus_Affiche_Message, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_NESSUS_ENFANT_INFO, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Nessus.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, &Nessus_Affiche_Message, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_HISTORIQUE, 0, 0, OBJET_PARENT, NULL, LISTE, TRUE, FALSE, "History", NULL, NULL, NULL, PATH_ICONE "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_HISTORIQUE_ALERTE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Error.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_HISTORIQUE_WARNING, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Warning.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_HISTORIQUE_INFO, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_DERNIER_CHANGEMENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Last State Change : %s", &Gestion_Texte_Dernier_Changement_Equipement, NULL, NULL, PATH_ICONE "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_DATE_DECOUVERTE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Decouvert le [%s]", NULL, NULL, NULL, PATH_ICONE "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{PARTAGE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Partage.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, &Double_Clic_Partage, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{PARTAGE_IMPRIMANTE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "unknown.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{PARTAGE_REPERTOIRE, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "folder.png", NULL, NULL, NULL, 0, FALSE, NULL, &Termine_Renommer_Nom_Repertoire_Samba, NULL, &Double_Clic_Repertoire, &Affiche_Menu_Samba, &Rafraichir_Samba, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{FICHIER_PARTAGER, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "unknown.png", &Copie_Icone_Partage, NULL, NULL, 0, FALSE, NULL, &Termine_Renommer_Nom_Fichier_Samba, NULL, &Double_Clic_Fichier, &Affiche_Menu_Samba, &Rafraichir_Samba, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{PARTAGE_REPERTOIRE_SUPERIEUR, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "Retour.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, &Double_Clic_Repertoire, &Affiche_Menu_Samba, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{PORTS, 0, 0, OBJET_FILS, NULL, ICONE, TRUE, FALSE, NULL, NULL, NULL, NULL, PATH_ICONE "kservices.png", &Copie_Icone_Port, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, &Notification_Port, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_TYPE_PARENT, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Type : %s", &Gestion_Texte_Type_Parent, NULL, NULL, PATH_ICONE "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
	{INFO_PARENT_NB_FILS, 0, 0, OBJET_FILS, NULL, LISTE, TRUE, FALSE, "Total : %d", &Gestion_Texte_Parent_Nb_Fils, NULL, NULL, PATH_ICONE "Info.png", NULL, NULL, NULL, 0, FALSE, NULL, NULL, NULL, NULL, &Action_Click_Droit, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, FALSE, NULL},
};


GtkWidget *Widget_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	switch (Objet->ID_Liste) {
	    case LISTE_MACHINE:
		    return Reseau->Liste_Equipement;
	    case LISTE_INFO:
		    return treeview_Info;	
	    case LISTE_MODULE:
		    return treeview_Modules;	
	    default:
		    debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Erreur : Widget Liste inconnu");
	}
	return NULL;
}


void Modifie_Etat_Bouton (struct Struct_Modele_Objet *Objet)
{
	ERROR_if (Objet == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Modif etat bouton sur l'objet (%s)   [%p]  [%d]   ID_Liste[%d]", Objet->Texte_Defaut, Objet, Objet->Notification_En_Cours, Objet->ID_Liste);
	gtk_widget_set_sensitive (toggletoolbutton_Notification, FALSE);
	Modification_Toggle_En_Cours = TRUE;	
	gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification), Objet->Notification_En_Cours);
	Modification_Toggle_En_Cours = FALSE;	
	gtk_widget_set_sensitive (toggletoolbutton_Notification, (Objet->Action_Notification != NULL));
	gtk_widget_set_sensitive (button_Refresh, (Objet->Action_Rafraichissement != NULL));
	Reseau_Selectionner->ID_Derniere_Liste_Selectionner = Objet->ID_Liste;
}


GList    *GList_Liste_ID_Liste (struct Struct_Liste_Reseau *Reseau, guint ID_Liste)
{
	ERROR_if (Reseau == NULL);
	switch (ID_Liste) {
	    case LISTE_MACHINE:
		    return Reseau->GList_Liste_Equipement;
	    case LISTE_INFO:
		    return Reseau->GList_Liste_Info;
	    case LISTE_MODULE:
		    return Reseau->GList_Liste_Module;
	    default:
		    debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Erreur : Glist Liste inconnu");
	}
	return NULL;
}


GList    *GList_Liste (struct Struct_Modele_Objet * Objet, struct Struct_Liste_Reseau * Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	return GList_Liste_ID_Liste (Reseau, Objet->ID_Liste);
}


void Recupere_Nouveau_Pointeur_Liste_ID_Liste (guint ID_Liste, struct Struct_Liste_Reseau *Reseau, GList * Nouveau_Pointeur_Glist)
{
	ERROR_if (Reseau == NULL);
	switch (ID_Liste) {
	    case LISTE_MACHINE:
		    Reseau->GList_Liste_Equipement = Nouveau_Pointeur_Glist;
		    break;
	    case LISTE_INFO:
		    Reseau->GList_Liste_Info = Nouveau_Pointeur_Glist;
		    break;
	    case LISTE_MODULE:
		    Reseau->GList_Liste_Module = Nouveau_Pointeur_Glist;
		    break;
	    default:
		    debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Erreur : Recupere_Nouveau_Pointeur_Liste Liste inconnu = [%d]\n", ID_Liste);
	}
}


void Recupere_Nouveau_Pointeur_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau, GList * Nouveau_Pointeur_Glist)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Recupere_Nouveau_Pointeur_Liste_ID_Liste (Objet->ID_Liste, Reseau, Nouveau_Pointeur_Glist);
}


struct Struct_Modele_Objet *Recupere_Pointeur_Objet_Dans_Une_Liste (GList * GList, int rang)
{
	return g_list_nth_data (GList, rang);
}


guint Recupere_Rang_Objet_Dans_Une_Liste (GList * GList, struct Struct_Modele_Objet * Objet)
{
	ERROR_if (Objet == NULL);
	return g_list_position (GList, g_list_find (GList, Objet));
}


GList    *Supprime_Dans_Liste_Objets (GList * GList, struct Struct_Modele_Objet * Objet, gboolean Message_Erreur)
{
	ERROR_if (Objet == NULL);
	if (g_list_find (GList, Objet) != NULL) {
		return g_list_remove (GList, Objet);
	}
	if (Message_Erreur)
		debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Tentative de suppression d'un objet dans une liste qui n'est pas present");
	return GList;
}


GList    *Ajouter_Dans_Liste_Objets (GList * GList, struct Struct_Modele_Objet * Objet)
{
	ERROR_if (Objet == NULL);
	if (g_list_find (GList, Objet) == NULL)
		return g_list_append (GList, Objet);

	debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Warning : Tentative d'ajout d'un objet dans une liste qui est deja present");
	return GList;
}


void Affiche_Icone_Defaut_Griser_Objet_liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	GtkTreeModel *model = NULL;

	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	if (Objet->Presentation == LISTE) {
		model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
		gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, COL_ICON_LIST, Objet->icone_griser, -1);
	}
	else {
		model = gtk_icon_view_get_model (GTK_ICON_VIEW (Widget_Liste (Objet, Reseau)));
		gtk_list_store_set (GTK_LIST_STORE (model), &Objet->ID_Arbre_Ligne, COL_ICON_LIST, Objet->icone_griser, -1);
	}
}


void Affiche_Icone_Defaut_Objet_liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	GtkTreeModel *model = NULL;

	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	if (Objet->Presentation == LISTE) {
		model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
		gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, COL_ICON_LIST, Objet->icone, -1);
	}
	else {
		model = gtk_icon_view_get_model (GTK_ICON_VIEW (Widget_Liste (Objet, Reseau)));
		gtk_list_store_set (GTK_LIST_STORE (model), &Objet->ID_Arbre_Ligne, COL_ICON_LIST, Objet->icone, -1);
	}
}


void Active_Rachaichissment_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Rafraichissement = Ajouter_Dans_Liste_Objets (Reseau->GList_Rafraichissement, Objet);
}

void Active_Alerte_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Alerte = Ajouter_Dans_Liste_Objets (Reseau->GList_Alerte, Objet);
}

void Active_Test_Etat_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Test_Etat = Ajouter_Dans_Liste_Objets (Reseau->GList_Test_Etat, Objet);
}


void Desactive_Rachaichissment_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau, gboolean Message_Erreur)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Rafraichissement = Supprime_Dans_Liste_Objets (Reseau->GList_Rafraichissement, Objet, Message_Erreur);
	Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
}

void Desactive_Alerte_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau, gboolean Message_Erreur)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Alerte = Supprime_Dans_Liste_Objets (Reseau->GList_Alerte, Objet, Message_Erreur);
}

void Desactive_Test_Etat_Objet (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau, gboolean Message_Erreur)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Reseau->GList_Test_Etat = Supprime_Dans_Liste_Objets (Reseau->GList_Test_Etat, Objet, Message_Erreur);
	Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
}


void Selectionne_Objet_Dans_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	GtkTreeViewColumn *column = NULL;
	GtkTreePath *path = NULL;
	GtkTreeModel *model = NULL;

	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
	column = gtk_tree_view_get_column (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)), 0);
	path = gtk_tree_model_get_path (model, &Objet->ID_Arbre_Ligne);
	gtk_tree_view_expand_to_path (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)), path);
	gtk_tree_view_set_cursor (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)), path, NULL, FALSE);
	gtk_tree_path_free (path);
}


void Afficher_Liste (GList * GList)
{
	struct Struct_Modele_Objet *Objet = NULL, *ObjetPere = NULL;
	guint     Nb_Objet_Liste, i, rangPere;

	if (GList != NULL) {	
		Nb_Objet_Liste = g_list_length (GList);
		debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Affiche Liste (%d)******************", Nb_Objet_Liste);
		for (i = 0; i < Nb_Objet_Liste; i++) {
			Objet = g_list_nth_data (GList, i);
			ObjetPere = (struct Struct_Modele_Objet *) Objet->Objet_Pere;
			rangPere = g_list_position (GList, g_list_find (GList, ObjetPere));
			debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%d : [%d][%s][%d]  Pere:(%d)", i, Objet->ID_Modele_Objet, Objet->Texte_Defaut, Objet->Nb_Enfant, rangPere);
		}
		debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Fin Liste *****************");
	}
}


void Supprime_Objet_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	struct Struct_Modele_Objet *ObjetPere = NULL;
	GtkTreeModel *model = NULL;
	guint     Nb_Objet_Liste, rangObjet;

	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	Nb_Objet_Liste = g_list_length (GList_Liste (Objet, Reseau));
	if (Nb_Objet_Liste != 0) {
		Objet->Nb_Enfant--;
		rangObjet = g_list_position (GList_Liste (Objet, Reseau), g_list_find (GList_Liste (Objet, Reseau), Objet));
		if (rangObjet == -1)
			debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Suppression Objet dans une liste non present");
		ObjetPere = (struct Struct_Modele_Objet *) Objet->Objet_Pere;	
		if (Objet->Nb_Enfant <= 0) {	
			debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "On supprime l'objet au rang (%d) [%s]  ayant (%d) enfants", rangObjet, Objet->Texte_Defaut, Objet->Nb_Enfant);
			Desactive_Rachaichissment_Objet (Objet, Reseau, FALSE);	
			Desactive_Alerte_Objet (Objet, Reseau, FALSE);
			Desactive_Test_Etat_Objet (Objet, Reseau, FALSE);
			Recupere_Nouveau_Pointeur_Liste (Objet, Reseau, Supprime_Dans_Liste_Objets (GList_Liste (Objet, Reseau), Objet, TRUE));
			if (Objet->Presentation == LISTE) {
				model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
				gtk_tree_store_remove (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne);
			}
			else {
				model = gtk_icon_view_get_model (GTK_ICON_VIEW (Widget_Liste (Objet, Reseau)));
				gtk_list_store_remove (GTK_LIST_STORE (model), &Objet->ID_Arbre_Ligne);
			}
			
			g_free (Objet);	
		}
		else
			debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Suppression annule le pere [%s] a encore (%d) enfants", Objet->Texte_Defaut, Objet->Nb_Enfant);
		if (ObjetPere != NULL) {
			debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "On va supprimer le pere de [%s]  rang [%d]", Objet->Texte_Defaut, rangObjet);
			Supprime_Objet_Liste (ObjetPere, Reseau);	
		}
	}
	else
		debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Erreur: Suppression Objet dans une liste vide");
}


void Supprime_Objet_Fils_Liste (struct Struct_Modele_Objet *Objet, struct Struct_Liste_Reseau *Reseau)
{
	ERROR_if (Objet == NULL);
	ERROR_if (Reseau == NULL);
	if (Objet->Nb_Enfant == 0) {	
		Supprime_Objet_Liste (Objet, Reseau);
	}
	else
		debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Erreur : Tentative de suppression d'un objet parent");
}



void Efface_Toute_Objet_Liste (struct Struct_Liste_Reseau *Reseau, guint ID_Liste)
{
	struct Struct_Modele_Objet *Objet = NULL;
	guint     Nb_Objet_Liste, i;

	ERROR_if (Reseau == NULL);
	Nb_Objet_Liste = g_list_length (GList_Liste_ID_Liste (Reseau, ID_Liste));
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Efface tout (%d)******************", Nb_Objet_Liste);
	if (Nb_Objet_Liste != 0) {
		i = 0;
		while ((Objet = g_list_nth_data (GList_Liste_ID_Liste (Reseau, ID_Liste), i)) != NULL) {
			debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%d : objet :[%s]  enfant:[%d]", i, Objet->Texte_Defaut, Objet->Nb_Enfant);
			if (Objet == NULL)
				debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Erreur : Liste chaines probleme pendant la suppression donnee == NULL");
			if ((Objet->ID_Type_Objet == OBJET_FILS) || ((Objet->ID_Type_Objet == OBJET_PARENT) && (Objet->Nb_Enfant == 0))) {
				debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Supprime objet :[%s]", Objet->Texte_Defaut);
				Supprime_Objet_Fils_Liste (Objet, Reseau);
				i = 0;	
			}
			else {
				i++;
			}
		}
	}
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Suppression termine *****************");
	if (g_list_length (GList_Liste_ID_Liste (Reseau, ID_Liste)) != 0)
		debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Efface_Toute_Objet_Liste n'a pas supprimé toute la liste");
	if (ID_Liste == Reseau->ID_Derniere_Liste_Selectionner)
		gtk_widget_set_sensitive (button_Refresh, FALSE);	
}


struct Struct_Modele_Objet *Recherche_Si_Objet_Deja_Afficher (struct Struct_Liste_Reseau *Reseau, int Modele_Objet, gchar * Texte, struct Struct_Modele_Objet *Parent, guint ID_Liste)
{
	struct Struct_Modele_Objet *Objet = NULL, *ObjetPere = NULL;
	guint     Nb_Objet_Liste, i;

	ERROR_if (Reseau == NULL);
	Nb_Objet_Liste = g_list_length (GList_Liste_ID_Liste (Reseau, ID_Liste));
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Recherche_Si_Objet_Deja_Afficher nb_maillon(%d) Recherche 'ID_Modele_Objet'[%d] [%s]", Nb_Objet_Liste, Modele_Objet, Texte);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Objet = g_list_nth_data (GList_Liste_ID_Liste (Reseau, ID_Liste), i);
		ObjetPere = (struct Struct_Modele_Objet *) Objet->Objet_Pere;
		if (ObjetPere != NULL)
			debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%d : [%d][%s][%d]   Parent [%d][%s][%d]  -->", i, Objet->ID_Modele_Objet, Objet->Texte_Defaut, Objet->Nb_Enfant, ObjetPere->ID_Modele_Objet, ObjetPere->Texte_Defaut, ObjetPere->Nb_Enfant);
		else
			debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%d : [%d][%s][%d]   Pas de parent  -->", i, Objet->ID_Modele_Objet, Objet->Texte_Defaut, Objet->Nb_Enfant);
		
		if (Texte != NULL) {
			if ((Objet->ID_Modele_Objet == Modele_Objet) && (strcmp (Objet->Texte_Defaut, Texte) == 0) && (Parent == ObjetPere)) {
				debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, " ---- trouvé");
				return Objet;
			}
		}
		else {
			if ((Objet->ID_Modele_Objet == Modele_Objet) && (Parent == ObjetPere)) {
				debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, " ---- trouvé2");
				return Objet;
			}
		}
		debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, " ---- Different\n");
	}
	return NULL;
}


struct Struct_Modele_Objet *Ajouter_Objet_comme_modele (struct Struct_Liste_Reseau *Reseau, int Modele_Objet, gchar * Texte, guint ID_Liste, gpointer * Pointeur_Attacher)
{
	struct Struct_Modele_Objet *Objet = NULL;

	ERROR_if (Reseau == NULL);
	if (Liste_Modele_Objet[Modele_Objet].icone == NULL) {	
		Liste_Modele_Objet[Modele_Objet].icone = Chargement_Image (Liste_Modele_Objet[Modele_Objet].Chemin_Icone, COULEUR);	
		Liste_Modele_Objet[Modele_Objet].icone_griser = Chargement_Image (Liste_Modele_Objet[Modele_Objet].Chemin_Icone, NOIR_ET_BLANC);	
	}
	
	Objet = (struct Struct_Modele_Objet *) malloc (sizeof (struct Struct_Modele_Objet));
	ERROR_if (Objet == NULL);
	bzero (Objet, sizeof (struct Struct_Modele_Objet));	
	memcpy (Objet, &Liste_Modele_Objet[Modele_Objet], sizeof (struct Struct_Modele_Objet));
	Objet->Pointeur_Attacher = Pointeur_Attacher;	
	if (Texte == NULL) {
		if (Objet->Gestion_Texte != NULL)	
			Objet->Texte_Defaut = (*Objet->Gestion_Texte) ((gpointer *) Objet);
	}
	else
		Objet->Texte_Defaut = g_strdup (Texte);
	Recupere_Nouveau_Pointeur_Liste_ID_Liste (ID_Liste, Reseau, Ajouter_Dans_Liste_Objets (GList_Liste_ID_Liste (Reseau, ID_Liste), Objet));
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter_Objet_comme_modele   modele : [%s]  nb_maillon:(%d)  pointeur :(%p)", Objet->Texte_Defaut, g_list_length (GList_Liste_ID_Liste (Reseau, ID_Liste)), Objet);
	return Objet;
}


struct Struct_Modele_Objet *Ajouter_Nouvelle_Objet (int Modele_Objet, gchar * Texte, gpointer * Pointeur_Attacher, gchar * Chaine_Attacher, int Modele_Objet_Parent, gchar * Texte_Parent, int Modele_Objet_Grand_Parent, int Modele_Objet_AGrand_Parent, int Modele_Objet_AAGrand_Parent, int Modele_Objet_AAAGrand_Parent, guint ID_Reseau, guint ID_Liste)
{
	struct Struct_Modele_Objet *Objet = NULL, *Parent = NULL, *Grand_parent = NULL;
	struct Struct_Liste_Reseau *Reseau = NULL;
	GtkTreeModel *model = NULL;
	GtkTreeIter Ligne;

	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter_Nouvelle_Objet   [%d][%s]   [%d][%s]  [%d] ID_Reseau[%d]", Modele_Objet, Texte, Modele_Objet_Parent, Texte_Parent, Modele_Objet_Grand_Parent, ID_Reseau);
	
	if (Modele_Objet_Parent != PERE_RACINE) {
		
		if (Liste_Modele_Objet[Modele_Objet_Parent].ID_Type_Objet == OBJET_PARENT) {
			
			Parent = Ajouter_Nouvelle_Objet (Modele_Objet_Parent, Texte_Parent, NULL, NULL, Modele_Objet_Grand_Parent, NULL, Modele_Objet_AGrand_Parent, Modele_Objet_AAGrand_Parent, Modele_Objet_AAAGrand_Parent, PERE_RACINE, ID_Reseau, ID_Liste);
		}
		else
			debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "creation parent avec l'objet [%d] qui ne peut pas etre un parent   (Modele_Objet[Modele_Objet_Parent].ID_Type_Objet!=OBJET_PARENT)", Modele_Objet_Parent);
	}
	
	if ((Objet = Recherche_Si_Objet_Deja_Afficher (Reseau, Modele_Objet, Texte, Parent, ID_Liste)) == NULL) {
		Objet = Ajouter_Objet_comme_modele (Reseau, Modele_Objet, Texte, ID_Liste, Pointeur_Attacher);
		if (Chaine_Attacher != NULL)
			Objet->Chaine_Attacher = g_strdup (Chaine_Attacher);	
	}
	else {
		if ((Parent != NULL) && (Objet->ID_Type_Objet == OBJET_FILS)) {	
			Parent->Nb_Enfant--;
			Grand_parent = (struct Struct_Modele_Objet *) Parent->Objet_Pere;
			if (Grand_parent != NULL)	
				Grand_parent->Nb_Enfant--;
		}
	}
	Objet->Objet_Pere = (gpointer *) Parent;	
	if (Objet->ID_Type_Objet == OBJET_PARENT)	
		Objet->Nb_Enfant++;
	if (Objet->Recupere_icone != NULL)
		(*Objet->Recupere_icone) ((gpointer *) Objet);	
	if (Objet->icone == NULL) {	
		debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Chargement de l'icone");
		Objet->icone = Chargement_Image (Objet->Chemin_Icone, COULEUR);	
		Objet->icone_griser = Chargement_Image (Objet->Chemin_Icone, NOIR_ET_BLANC);	
	}
	if (!Objet->Afficher) {	
		
		Objet->ID_Liste = ID_Liste;
		Objet->ID_Reseau = ID_Reseau;
		if (Objet->Presentation == LISTE) {
			
			model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
			if (Parent != NULL)
				gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, &Parent->ID_Arbre_Ligne);
			else
				gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, NULL);
			Objet->ID_Arbre_Ligne = Ligne;
			gtk_tree_store_set (GTK_TREE_STORE (model), &Ligne, COL_TEXT_LIST, Objet->Texte_Defaut, COLUMN_EDITABLE_LIST, (Objet->Modification != NULL), POINTER_LIST, Objet, COL_IS_DIRECTORY_LIST, ((Objet->ID_Type_Objet) == OBJET_PARENT), -1);
			Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
		}
		else {		
			model = gtk_icon_view_get_model (GTK_ICON_VIEW (Widget_Liste (Objet, Reseau)));
			gtk_list_store_append (GTK_LIST_STORE (model), &Ligne);
			Objet->ID_Arbre_Ligne = Ligne;
			gtk_list_store_set (GTK_LIST_STORE (model), &Ligne, COL_ICON_LIST, Objet->icone, COL_TEXT_LIST, Objet->Texte_Defaut, POINTER_LIST, Objet, -1);
		}
		debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "--[%s]", Objet->Texte_Defaut);
		Objet->Afficher = TRUE;
	}
	else
		debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "L'objet est deja afficher [%s] Fils(%d)", Objet->Texte_Defaut, Objet->Nb_Enfant);
	return Objet;
}


void Force_Objet_Repertoire_Liste (struct Struct_Modele_Objet *Objet, guint ID_Reseau)
{				
	struct Struct_Liste_Reseau *Reseau = NULL;
	GtkTreeModel *model = NULL;

	ERROR_if (Objet == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau);
	if (Objet->Afficher) {
		if (Objet->Presentation == LISTE) {
			
			model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
			gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, COL_IS_DIRECTORY_LIST, TRUE, -1);
		}
	}
}
