/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gnome.h>
#include "Objet.h"
#include "Reseau.h"
#include "Interface/Root_Interface.h"
#include "Interface/Fingerprinting_Interface.h"
#include "Interface/Combo.h"
#include "Debug.h"
#include "Equipement_Port.h"
#include "Equipement_Historique.h"
#include "Modules.h"
#include "Com/Commun.h"
#include "Equipement_Nessus.h"
#include "Objet_Liste.h"
#include "Animation.h"

void Action_Test_Favoris (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click Favoris sur l'objet (%s)   [%p]", Objet->Texte_Defaut, Objet);
	Objet->Favoris = !Objet->Favoris;
}


void Action_Raffraichir_Equipement (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct Struct_Equipement *Equipement = NULL;
	struct struct_Demande_Rafraichir_Equipement Message;

	ERROR_if (pointer == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
	Equipement->Rafraichir_Equipement = TRUE;
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Rafraichir sur l'objet (%s)", Objet->Texte_Defaut);
	Active_Rachaichissment_Objet (Objet, Reseau);
	
	bzero (&Message, sizeof (struct struct_Demande_Rafraichir_Equipement));
	Message.ID_Reseau = Objet->ID_Reseau;
	memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
	Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_RAFRAICHIR_EQUIPEMENT, (gpointer *) & Message, sizeof (Message), Reseau);
}


void Notification_Port (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Port *Port_Equipement = NULL;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct struct_Demande_Notication_Critique_Etat_Port Message;
	struct struct_Annulation_Notification_Etat_Port Message_Annulation;

	ERROR_if (pointer == NULL);
	Port_Equipement = (struct Struct_Port *) Objet->Pointeur_Attacher;
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click Notification_Port sur l'objet (%s)   [%p]   [%s]:[%d]", Objet->Texte_Defaut, Objet, Equipement_Selectionner->Adresse_Ip_Char, Port_Equipement->Num_Port);
	if (gtk_toggle_tool_button_get_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification))) {
		Objet->Notification_En_Cours = TRUE;
		Port_Equipement->Notification_En_Cours = TRUE;
		bzero (&Message, sizeof (struct struct_Demande_Notication_Critique_Etat_Port));
		Message.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement_Selectionner->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Message.Num_Port = Port_Equipement->Num_Port;
		Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_NOTIFICATION_CRITIQUE_ETAT_PORT, (gpointer *) & Message, sizeof (Message), Reseau);
	}
	else {

		if (Port_Equipement->Alert_notification)
			Reseau->GList_Test_Etat = Supprime_Dans_Liste_Objets (Reseau->GList_Test_Etat, Objet, TRUE);
		if (Port_Equipement->Etat_Port == OUVERT) {
			Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
			Change_Couleur_Noir_Texte_liste (Objet, Reseau);
		}
		else {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet, Reseau);
		}
		Objet->Notification_En_Cours = FALSE;
		Port_Equipement->Notification_En_Cours = FALSE;
		Port_Equipement->Alert_notification = FALSE;
		bzero (&Message_Annulation, sizeof (struct struct_Annulation_Notification_Etat_Port));
		Message_Annulation.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message_Annulation.ID_Equipement, Equipement_Selectionner->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Message_Annulation.Num_Port = Port_Equipement->Num_Port;
		Communication_Envoie_Donnee (Reseau->Pid_Agent, ANNULATION_NOTIFICATION_ETAT_PORT, (gpointer *) & Message_Annulation, sizeof (Message_Annulation), Reseau);
	}
}


void Notification_Equipement (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Liste_Reseau *Reseau = NULL;
	GtkTreeModel *model = NULL;
	struct struct_Demande_Notication_Critique_Etat_Equipement Message;
	struct struct_Annulation_Notification_Etat_Equipement Message_Annulation;
	gint      Position_Glist;

	ERROR_if (pointer == NULL);
	Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click Notification_Equipement sur l'objet (%s)   [%p]   [%s]", Objet->Texte_Defaut, Objet, Equipement->Adresse_Ip_Char);
	if (gtk_toggle_tool_button_get_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification))) {
		Objet->Notification_En_Cours = TRUE;
		Equipement->Notification_En_Cours = TRUE;
		bzero (&Message, sizeof (struct struct_Demande_Notication_Critique_Etat_Equipement));
		Message.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_NOTIFICATION_CRITIQUE_ETAT_EQUIPEMENT, (gpointer *) & Message, sizeof (Message), Reseau);
		if (Reseau->Mode_Liste_Detaille) {
			model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
			gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, NOTIFICATION, "YES", -1);
		}
	}
	else {
		Objet->Notification_En_Cours = FALSE;
		Equipement->Notification_En_Cours = FALSE;
		Equipement->Alert_Notification_En_Cours = FALSE;
		bzero (&Message_Annulation, sizeof (struct struct_Annulation_Notification_Etat_Equipement));
		Message_Annulation.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message_Annulation.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, ANNULATION_NOTIFICATION_ETAT_EQUIPEMENT, (gpointer *) & Message_Annulation, sizeof (Message_Annulation), Reseau);
		if ((Position_Glist = Recupere_Rang_Objet_Dans_Une_Liste (Reseau->GList_Test_Etat, Objet)) != -1)
			Reseau->GList_Test_Etat = Supprime_Dans_Liste_Objets (Reseau->GList_Test_Etat, Objet, TRUE);
		if (Equipement->Equipement_Allumer) {
			Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
			Change_Couleur_Noir_Texte_liste (Objet, Reseau);
		}
		else {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet, Reseau);
		}
		if (Reseau->Mode_Liste_Detaille) {
			model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
			gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, NOTIFICATION, "", -1);
		}
	}
}


void Action_Test_Notification (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click Notification sur l'objet (%s)   [%p]", Objet->Texte_Defaut, Objet);
	Objet->Notification_En_Cours = !Objet->Notification_En_Cours;
}


void Action_Test_Click (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (pointer == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Selection sur l'objet (%s)   donnee [%p]", Objet->Texte_Defaut, Objet->Pointeur_Attacher);
}


void Action_Selection_Equipement_Inconnu (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Equipement *Equipement = NULL;

	ERROR_if (pointer == NULL);
	Action_Selection_Equipement (pointer);
	Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
	if (Equipement->Nb_Port_Ouvert != 0)
		gtk_widget_show (Wizard_Add_OS_Fingerprinting);
}

void Action_Selection_Type_OU_Domaine (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	Equipement_Selectionner = NULL;
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);	
	gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
	gtk_widget_set_sensitive (button_Refresh, FALSE);
	gtk_widget_hide (vbox_Milieu);
	Initialisation_Aucun_Module ();
	Objet_Equipement_Selectionner = Objet;
	Ajouter_Nouvelle_Objet (INFO_TYPE_PARENT, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_PARENT_NB_FILS, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
}

void Action_Selection_Equipement (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Modele_Objet *Objet_Nessus;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Historique *Historique = NULL;
	struct Struct_Nessus *Nessus = NULL;
	struct struct_Demande_Rachaichir_Etat_Equipement Message;
	struct Struct_Modele_Objet *Objet_Text;
	gint      i, Nb_Objet_Liste;
	gchar     Texte_Registration_Netbios[100];	
	gchar     Date[30], *Chaine_Historique = NULL;

	ERROR_if (pointer == NULL);
	if (Objet_Equipement_Selectionner != Objet) {	

		Objet_Equipement_Selectionner = Objet;
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
		Equipement_Selectionner = Equipement;

		
		bzero (&Message, sizeof (struct struct_Demande_Rachaichir_Etat_Equipement));
		Message.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_RAFRAICHIR_ETAT_EQUIMEMENT, (gpointer *) & Message, sizeof (Message), Reseau);


		gtk_widget_show (vbox_Milieu);
		gtk_widget_set_sensitive (combobox_liste_Modules, TRUE);
		gtk_widget_set_sensitive (button_Refresh, TRUE);

		if (Equipement->Intrus) {
			Equipement->Intrus = FALSE;
			Reseau->GList_Alerte = Supprime_Dans_Liste_Objets (Reseau->GList_Alerte, Objet, TRUE);
			Affiche_Icone_Defaut_Objet_liste (Objet, Reseau);
			Change_Couleur_Noir_Texte_liste (Objet, Reseau);
			Change_Bold_Texte_Liste (Objet, FALSE, Reseau);
		}
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);	
		Objet_Text = Ajouter_Nouvelle_Objet (INFO_ADRESSE_IP, NULL, (gpointer *) Equipement->Adresse_Ip_Char, NULL, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (!Equipement->Equipement_Allumer) {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Text, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet_Text, Reseau);
		}
		Objet_Text = Ajouter_Nouvelle_Objet (INFO_ADRESSE_MAC, NULL, (gpointer *) Equipement->Adresse_MAC_Char, NULL, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (!Equipement->Equipement_Allumer) {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Text, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet_Text, Reseau);
		}
		Objet_Text = Ajouter_Nouvelle_Objet (INFO_FOURNISSEUR, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (!Equipement->Equipement_Allumer) {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Text, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet_Text, Reseau);
		}
		Objet_Text = Ajouter_Nouvelle_Objet (INFO_OS, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (!Equipement->Equipement_Allumer) {
			Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Text, Reseau);
			Change_Couleur_Gris_Texte_liste (Objet_Text, Reseau);
		}

		if (strlen (Equipement->Smb.HostName) != 0)
			Ajouter_Nouvelle_Objet (INFO_NOM_HOTE, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (strlen (Equipement->Smb.DomainName) != 0) {
			Ajouter_Nouvelle_Objet (INFO_NOM_UTILISATEUR, NULL, NULL, NULL, INFO_NOM_DOMAINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			i = 0;
			while ((i < NUM_MAX_REGISTRATION) && (Equipement->Smb.Smb_Registration[i].Type != 0)) {
				sprintf (Texte_Registration_Netbios, "%s <%02X>", Equipement->Smb.Smb_Registration[i].Name, Equipement->Smb.Smb_Registration[i].Numero);
				if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_GROUP)
					strcat (Texte_Registration_Netbios, "GROUP ");
				if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
					strcat (Texte_Registration_Netbios, "UNIQUE ");
				switch (Equipement->Smb.Smb_Registration[i].Numero) {
				    case 0x00:
					    if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
						    strcat (Texte_Registration_Netbios, " Workstation Service");
					    else
						    strcat (Texte_Registration_Netbios, " Domain Name");
					    break;
				    case 0x01:
					    if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
						    strcat (Texte_Registration_Netbios, " Messenger Service");
					    else
						    strcat (Texte_Registration_Netbios, " Master Browser");
					    break;
				    case 0x03:
					    strcat (Texte_Registration_Netbios, " Messenger Service");
					    break;
				    case 0x06:
					    strcat (Texte_Registration_Netbios, " RAS Server Service");
					    break;
				    case 0x1b:
					    strcat (Texte_Registration_Netbios, " Domain Master Browser");
					    break;
				    case 0x1c:
					    strcat (Texte_Registration_Netbios, " Domain Controllers");
					    break;
				    case 0x1d:
					    strcat (Texte_Registration_Netbios, " Master Browser");
					    break;
				    case 0x1e:
					    if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_GROUP)
						    strcat (Texte_Registration_Netbios, " Browser Service Elections");
					    break;
				    case 0x1F:
					    strcat (Texte_Registration_Netbios, " NetDDE Service");
					    break;
				    case 0x20:
					    strcat (Texte_Registration_Netbios, " File Server Service");
					    break;
				    case 0x21:
					    strcat (Texte_Registration_Netbios, " RAS Client Service");
					    break;
				    case 0x22:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange Interchange(MSMail Connector)");
					    break;
				    case 0x23:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange Store");
					    break;
				    case 0x24:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange Directory");
					    break;
				    case 0x30:
					    strcat (Texte_Registration_Netbios, " Modem Sharing Server Service");
					    break;
				    case 0x31:
					    strcat (Texte_Registration_Netbios, " Modem Sharing Client Service");
					    break;
				    case 0x42:
					    strcat (Texte_Registration_Netbios, " Mcaffee Anti-Virus");
					    break;
				    case 0x43:
					    strcat (Texte_Registration_Netbios, " SMS Clients Remote Control");
					    break;
				    case 0x44:
					    strcat (Texte_Registration_Netbios, " SMS Administrators Remote Control Tool");
					    break;
				    case 0x45:
					    strcat (Texte_Registration_Netbios, " SMS Clients Remote Chat");
					    break;
				    case 0x46:
					    strcat (Texte_Registration_Netbios, " SMS Clients Remote Transfer");
					    break;
				    case 0x4C:
					    strcat (Texte_Registration_Netbios, " DEC Pathworks TCPIP service on Windows NT");
					    break;
				    case 0x52:
					    strcat (Texte_Registration_Netbios, " DEC Pathworks TCPIP service on Windows NT");
					    break;
				    case 0x6a:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange IMC");
					    break;
				    case 0x87:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange MTA");
					    break;
				    case 0xbe:
					    strcat (Texte_Registration_Netbios, " Network Monitor Agent");
					    break;
				    case 0xbf:
					    strcat (Texte_Registration_Netbios, " Network Monitor Application");
					    break;
				    default:
					    strcat (Texte_Registration_Netbios, " Unknown");
					    break;
				}
				Ajouter_Nouvelle_Objet (INFO_NETBIOS_ENFANT, Texte_Registration_Netbios, NULL, NULL, INFO_NETBIOS, NULL, INFO_NOM_DOMAINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				i++;
			}
		}
		Ajouter_Nouvelle_Objet (INFO_PORTS, NULL, NULL, NULL, INFO_INFO, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_CONTACT_ADMIN, NULL, (gpointer *) & Equipement->Contact_Admin, NULL, INFO_INFO, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (Equipement->Snmp_Ouvert) {
			
			if (strlen (Equipement->Snmp.System_Name) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_NAME, NULL, (gpointer *) & Equipement->Snmp.System_Name, NULL, INFO_SNMP_SYSTEM, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (strlen (Equipement->Snmp.Description) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_DESCRIPTION, NULL, (gpointer *) & Equipement->Snmp.Description, NULL, INFO_SNMP_SYSTEM, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (strlen (Equipement->Snmp.Contact) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_CONTACT, NULL, (gpointer *) & Equipement->Snmp.Contact, NULL, INFO_SNMP_SYSTEM, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (strlen (Equipement->Snmp.Location) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_LOCATION, NULL, (gpointer *) & Equipement->Snmp.Location, NULL, INFO_SNMP_SYSTEM, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (strlen (Equipement->Snmp.Uptime) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_UPTIME, NULL, (gpointer *) & Equipement->Snmp.Uptime, NULL, INFO_SNMP_SYSTEM, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Ram != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_RAM, NULL, (gpointer *) Equipement->Snmp.Ram, NULL, INFO_SNMP_SYSTEM, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Glist_Snmp[SNMP_SYSTEM_DEVICE] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_DEVICE, NULL, NULL, NULL, INFO_SNMP_SYSTEM, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Glist_Snmp[SNMP_SYSTEM_LOGICAL_STORAGE] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_LOGICAL_STORAGE, NULL, NULL, NULL, INFO_SNMP_SYSTEM, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Glist_Snmp[SNMP_SYSTEM_SERVICE] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_SYSTEM_SERVICE, NULL, NULL, NULL, INFO_SNMP_SYSTEM, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			
			if (Equipement->Glist_Snmp[SNMP_NETWORK_ARP] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_ARP, NULL, NULL, NULL, INFO_SNMP_NETWORK, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Glist_Snmp[SNMP_NETWORK_ROUTES] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_ROUTES, NULL, NULL, NULL, INFO_SNMP_NETWORK, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			
			if (Equipement->Glist_Snmp[SNMP_NETWORK_INTERFACES_BASIC] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_INTERFACES_BASIC, NULL, NULL, NULL, INFO_SNMP_NETWORK_INTERFACES, NULL, INFO_SNMP_NETWORK, INFO_SNMP, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			
			
			
			
			if (Equipement->Glist_Snmp[SNMP_NETWORK_TCPIP_TCP_CONNECTIONS] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_TCP_CONNECTIONS, NULL, NULL, NULL, INFO_SNMP_NETWORK_TCPIP, NULL, INFO_SNMP_NETWORK, INFO_SNMP, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Glist_Snmp[SNMP_NETWORK_TCPIP_UDP_SERVICES] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_UDP_SERVICES, NULL, NULL, NULL, INFO_SNMP_NETWORK_TCPIP, NULL, INFO_SNMP_NETWORK, INFO_SNMP, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);

			
			if (strlen (Equipement->Snmp.Ip_Forwarding) != 0)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_FORWARDING, NULL, (gpointer *) & Equipement->Snmp.Ip_Forwarding, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Default_TTL != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_TTL, NULL, (gpointer *) Equipement->Snmp.Default_TTL, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Reassembly_Timeout != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_REASS_TIMEOUT, NULL, (gpointer *) Equipement->Snmp.Reassembly_Timeout, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Need_To_Be_Reassembled != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_NEED_REASS, NULL, (gpointer *) Equipement->Snmp.Need_To_Be_Reassembled, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Reassembled != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_RE_ASSEM, NULL, (gpointer *) Equipement->Snmp.Reassembled, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Reassembly_Failures != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_REAS_FAIL, NULL, (gpointer *) Equipement->Snmp.Reassembly_Failures, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Successfully_Fragmented != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_SUCCESS_FRAG, NULL, (gpointer *) Equipement->Snmp.Successfully_Fragmented, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Fragmentation_Failures != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_FRAG_FAIL, NULL, (gpointer *) Equipement->Snmp.Fragmentation_Failures, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Created_Fragments != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_CREAT_FRAG, NULL, (gpointer *) Equipement->Snmp.Created_Fragments, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Discarded_Routing_Entries != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INFO_IP_DISC_ROUT, NULL, (gpointer *) Equipement->Snmp.Discarded_Routing_Entries, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INFO, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			
			if (Equipement->Snmp.All != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_ALL, NULL, (gpointer *) Equipement->Snmp.All, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Forwarded != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_FORWARDED, NULL, (gpointer *) Equipement->Snmp.Forwarded, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Delivered != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_DELIVERED, NULL, (gpointer *) Equipement->Snmp.Delivered, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Header_Errors != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_HEADER, NULL, (gpointer *) Equipement->Snmp.Header_Errors, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Address_Errors != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_ADDRESS, NULL, (gpointer *) Equipement->Snmp.Address_Errors, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Unknown_Protocol != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_PROTOCOL, NULL, (gpointer *) Equipement->Snmp.Unknown_Protocol, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Input_Buffer_Errors != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_INPUT_BUFFER, NULL, (gpointer *) Equipement->Snmp.Input_Buffer_Errors, NULL, INFO_SNMP_NETWORK_TCPIP_IP_INPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			
			if (Equipement->Snmp.Requested != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_REQUESTED, NULL, (gpointer *) Equipement->Snmp.Requested, NULL, INFO_SNMP_NETWORK_TCPIP_IP_OUPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Output_Buffer_Errors != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_BUFFER, NULL, (gpointer *) Equipement->Snmp.Output_Buffer_Errors, NULL, INFO_SNMP_NETWORK_TCPIP_IP_OUPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Snmp.Not_Routed != -1)
				Ajouter_Nouvelle_Objet (INFO_SNMP_NETWORK_TCPIP_IP_OUPUT_ROUTED, NULL, (gpointer *) Equipement->Snmp.Not_Routed, NULL, INFO_SNMP_NETWORK_TCPIP_IP_OUPUT, NULL, INFO_SNMP_NETWORK_TCPIP_IP, INFO_SNMP_NETWORK_TCPIP, INFO_SNMP_NETWORK, INFO_SNMP, ID_Reseau_En_Cours, LISTE_INFO);
			
			if (Equipement->Glist_Snmp[SNMP_SOFTWARE] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_RUNNING_SOFTWARE, NULL, NULL, NULL, INFO_SNMP_SOFTWARE, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			
			if (Equipement->Glist_Snmp[SNMP_BRIDGE_FORWARDING_DATABASE] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_BRIDGE_FORWARDING_DATABASE, NULL, NULL, NULL, INFO_SNMP_BRIDGE, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			if (Equipement->Glist_Snmp[SNMP_BRIDGE_STATIC_DATABASE] != NULL)
				Ajouter_Nouvelle_Objet (INFO_SNMP_BRIDGE_STATIC_DATABASE, NULL, NULL, NULL, INFO_SNMP_BRIDGE, NULL, INFO_SNMP, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		}
		
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_CONTACT, NULL, (gpointer *) & Equipement->Contact, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_TEL_CONTACT, NULL, (gpointer *) & Equipement->Tel_Contact, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_LOCALISATION, NULL, (gpointer *) & Equipement->Localisation, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE, NULL, (gpointer *) & Equipement->Num_Serie, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_ECRAN, NULL, (gpointer *) & Equipement->Num_Serie_Ecran, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_IMPRIMANTE, NULL, (gpointer *) & Equipement->Num_Serie_Imprimante, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_OS, NULL, (gpointer *) & Equipement->Num_Serie_OS, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_SUITE_OFFICE, NULL, (gpointer *) & Equipement->Num_Serie_Office_Suite, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_PROCESSEUR, NULL, (gpointer *) & Equipement->Processeur, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_MEMOIRE, NULL, (gpointer *) & Equipement->Memoire, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_DISQUE, NULL, (gpointer *) & Equipement->Disque, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NOTES, NULL, (gpointer *) & Equipement->Notes, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);

		Ajouter_Nouvelle_Objet (INFO_DERNIER_CHANGEMENT, NULL, NULL, NULL, INFO_INFO, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Nb_Objet_Liste = g_list_length (Equipement->GList_Historique);
		for (i = 0; i < Nb_Objet_Liste; i++) {
			Historique = g_list_nth_data (Equipement->GList_Historique, i);
			ctime_r (&Historique->Date, Date);
			Date[strlen (Date) - 1] = '\0';	
			Chaine_Historique = g_strdup_printf ("%s - %s", Date, Historique->Historique);
			switch (Historique->Niveau_Historique) {
			    case HISTORIQUE_INFO:
				    Ajouter_Nouvelle_Objet (INFO_HISTORIQUE_INFO, Chaine_Historique, NULL, NULL, INFO_HISTORIQUE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    case HISTORIQUE_WARNING:
				    Ajouter_Nouvelle_Objet (INFO_HISTORIQUE_WARNING, Chaine_Historique, NULL, NULL, INFO_HISTORIQUE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    case HISTORIQUE_ALERTE:
				    Ajouter_Nouvelle_Objet (INFO_HISTORIQUE_ALERTE, Chaine_Historique, NULL, NULL, INFO_HISTORIQUE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    default:
				    debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Type Historique Inconnu");
			}
			g_free (Chaine_Historique);
		}
		if (Equipement->Scan_Nessus_En_Cours) {
			Objet_Nessus = Ajouter_Nouvelle_Objet (INFO_NESSUS, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			Objet_Nessus->Nb_Enfant = 0;	
			if (Objet_Nessus != NULL)
				Active_Rachaichissment_Objet (Objet_Nessus, Reseau);
		}
		
		Nb_Objet_Liste = g_list_length (Equipement->GList_Nessus);
		for (i = 0; i < Nb_Objet_Liste; i++) {
			Nessus = g_list_nth_data (Equipement->GList_Nessus, i);
			switch (Nessus->Niveau_Nessus) {
			    case INFO_NIVEAU_NESSUS:
				    Ajouter_Nouvelle_Objet (INFO_NESSUS_ENFANT_INFO, Nessus->Info, NULL, NULL, INFO_NESSUS_INFO, NULL, INFO_NESSUS, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    case NOTE_NIVEAU_NESSUS:
				    Ajouter_Nouvelle_Objet (INFO_NESSUS_ENFANT_POTENTIEL, Nessus->Info, NULL, NULL, INFO_NESSUS_POTENTIEL, NULL, INFO_NESSUS, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    case HOLE_NIVEAU_NESSUS:
				    Ajouter_Nouvelle_Objet (INFO_NESSUS_ENFANT_VULNERABILITE, Nessus->Info, NULL, NULL, INFO_NESSUS_VULNERABILITE, NULL, INFO_NESSUS, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    default:
				    debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Type Nessus Inconnu");
			}
		}
		
		Efface_Combo (combobox_liste_Modules);
		creation_combo_milieu ();	
	}
}


void Edit_Texte_Liste_Machine (gpointer * pointer, gchar * NewTexte)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	GtkTreeModel *model = NULL;

	ERROR_if (pointer == NULL);
	ERROR_if (NewTexte == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Edit_Texte_Liste_Machine");
	
	if (Objet->Chaine_Attacher == NULL)
		return;		
	if (Objet->Pointeur_Attacher == NULL)
		return;		
	if (strncmp (Objet->Chaine_Attacher, NewTexte, strlen (Objet->Chaine_Attacher)) != 0) {
		debug_printf (INTERFACE, D_INFO_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Syntaxe error");
		return;
	}
	
	
	if (*Objet->Pointeur_Attacher != NULL)
		g_free (*Objet->Pointeur_Attacher);
	
	*Objet->Pointeur_Attacher = g_strdup (NewTexte + strlen (Objet->Chaine_Attacher));
	g_free (Objet->Texte_Defaut);
	Objet->Texte_Defaut = g_strdup (NewTexte);
	
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (treeview_Info));
	gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, COL_TEXT_LIST, NewTexte, -1);

}


void Action_Click_Droit (gpointer * pointer, GdkEventButton * bev)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (pointer == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click droit sur l'objet (%s)", Objet->Texte_Defaut);
	Desactive_Rachaichissment_Objet (Objet, Reseau, TRUE);
	
}




void Action_Switch_Mode_Detaille (gpointer * pointer, GdkEventButton * bev)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct Struct_Modele_Objet *ObjetPere = NULL;
	struct Struct_Modele_Objet *Objet_Equipement = NULL;
	GtkTreeModel *model = NULL;
	guint     Nb_Objet_Liste, i, rangPere;

	ERROR_if (pointer == NULL);

	Equipement_Selectionner = NULL;
	Objet_Equipement_Selectionner = NULL;
	gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
	gtk_widget_set_sensitive (button_Refresh, FALSE);
	Modification_Toggle_En_Cours = TRUE;	
	gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification), FALSE);
	Modification_Toggle_En_Cours = FALSE;
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);	
	Initialisation_Aucun_Module ();
	gtk_widget_hide (vbox_Milieu);

	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click Action_Switch_Mode_Detaille sur l'objet (%s)", Objet->Texte_Defaut);
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet, Reseau)));
	if (Reseau->Mode_Liste_Detaille) {
		gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (Reseau->Liste_Equipement), FALSE);
		Reseau->Mode_Liste_Detaille = FALSE;	
		Nb_Objet_Liste = g_list_length (Reseau->GList_Liste_Equipement);
		i = 0;
		while ((Objet = g_list_nth_data (Reseau->GList_Liste_Equipement, i)) != NULL) {
			Objet = g_list_nth_data (Reseau->GList_Liste_Equipement, i);
			ObjetPere = (struct Struct_Modele_Objet *) Objet->Objet_Pere;
			rangPere = g_list_position (Reseau->GList_Liste_Equipement, g_list_find (Reseau->GList_Liste_Equipement, ObjetPere));
			if ((rangPere == -1) && (Objet->Nb_Enfant == 0)) {	
				
				Desactive_Rachaichissment_Objet (Objet, Reseau, FALSE);	
				Desactive_Alerte_Objet (Objet, Reseau, FALSE);
				Desactive_Test_Etat_Objet (Objet, Reseau, FALSE);
				
				Recupere_Nouveau_Pointeur_Liste (Objet, Reseau, Supprime_Dans_Liste_Objets (GList_Liste (Objet, Reseau), Objet, TRUE));
				
				gtk_tree_store_remove (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne);
				
				if (Objet->Objet_Pere != NULL)
					Supprime_Objet_Liste ((struct Struct_Modele_Objet *) Objet->Objet_Pere, Reseau);
				
				Objet_Equipement = Afficher_Nouveau_Equipement ((struct Struct_Equipement *) Objet->Pointeur_Attacher, Objet->ID_Reseau);
				Restore_Different_Etat_Equipement ((struct Struct_Equipement *) Objet->Pointeur_Attacher, Objet_Equipement, Objet->ID_Reseau);
				free (Objet);
				i = 0;
			}
			else
				i++;
		}
	}
	else {
		Reseau->Mode_Liste_Detaille = TRUE;	
		gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (Reseau->Liste_Equipement), TRUE);
		Nb_Objet_Liste = g_list_length (Reseau->GList_Liste_Equipement);
		i = 0;
		while ((Objet = g_list_nth_data (Reseau->GList_Liste_Equipement, i)) != NULL) {
			Objet = g_list_nth_data (Reseau->GList_Liste_Equipement, i);
			ObjetPere = (struct Struct_Modele_Objet *) Objet->Objet_Pere;
			rangPere = g_list_position (Reseau->GList_Liste_Equipement, g_list_find (Reseau->GList_Liste_Equipement, ObjetPere));
			if ((rangPere != -1) && (Objet->Nb_Enfant == 0)) {	
				
				Desactive_Rachaichissment_Objet (Objet, Reseau, FALSE);	
				Desactive_Alerte_Objet (Objet, Reseau, FALSE);
				Desactive_Test_Etat_Objet (Objet, Reseau, FALSE);
				
				Recupere_Nouveau_Pointeur_Liste (Objet, Reseau, Supprime_Dans_Liste_Objets (GList_Liste (Objet, Reseau), Objet, TRUE));
				
				gtk_tree_store_remove (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne);
				
				if (Objet->Objet_Pere != NULL)
					Supprime_Objet_Liste ((struct Struct_Modele_Objet *) Objet->Objet_Pere, Reseau);
				
				Objet_Equipement = Afficher_Nouveau_Equipement_Liste_Detaille ((struct Struct_Equipement *) Objet->Pointeur_Attacher, Objet->ID_Reseau);
				Restore_Different_Etat_Equipement ((struct Struct_Equipement *) Objet->Pointeur_Attacher, Objet_Equipement, Objet->ID_Reseau);
				free (Objet);
				i = 0;
			}
			else
				i++;
		}
	}
	
}
