/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Objet_Gestion_Texte.h"
#include "Objet.h"
#include "Equipement.h"
#include "Settings_Signature.h"
#include "Fournisseur.h"
#include "Debug.h"


gchar    *Gestion_Texte_Default (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Texte = NULL;

	ERROR_if (pointer == NULL);
	Texte = (gchar *) Objet->Pointeur_Attacher;
	
	if (Texte == NULL)	
		Texte = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Texte);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Texte) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Integer_Default (gpointer * pointer)
{
	
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, (gint) Objet->Pointeur_Attacher);
	return Nouveau_Texte;
}

gchar    *Gestion_Pointeur_Texte_Default (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Texte = NULL;

	ERROR_if (pointer == NULL);
	Texte = *Objet->Pointeur_Attacher;
	
	if (Texte == NULL)	
		Texte = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Texte);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Texte) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}




gchar    *Gestion_Texte_Fournisseur_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct struct_MacListe *Mac = NULL;
	gchar    *Nouveau_Texte = NULL, *Fournisseur = NULL;
	gint      i, Nb_Objet_Liste;

	ERROR_if (pointer == NULL);
	i = 0;
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Recherche Fabricant");
	Nb_Objet_Liste = g_list_length (GList_Fournisseur);
	while ((i < Nb_Objet_Liste) && (Fournisseur == NULL)) {
		Mac = g_list_nth_data (GList_Fournisseur, i);
		if (strncmp (Mac->MAC, Equipement->Adresse_MAC_Char, 8) == 0) {
			Fournisseur = Mac->Constructeur;
		}
		i++;
	}
	if (Fournisseur == NULL)	
		Fournisseur = "???";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Fournisseur);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Fournisseur) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Syteme_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *System = NULL;

	ERROR_if (pointer == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Recherche system");
	if (Equipement->Signature != NULL)
		System = Equipement->Signature->System_Name;
	if (System == NULL) {	
		if (Equipement->Agent_AutoScan)
			System = "Agent AutoScan";
		else if (Equipement->Nb_Port_Ouvert != 0)
			System = "Unknow equipment";
		else
			System = "Failed (no port open)";
	}
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, System);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (System) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Port_Info_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Nb_Port_Ouvert, Equipement->Nb_Port_Total_Scanner, Equipement->Nb_Port_Firewaller, Equipement->Nb_Port_Total_Scanner);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Dernier_Changement_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;
	gchar     Date[30];

	ERROR_if (pointer == NULL);
	ctime_r (&Equipement->Derniere_Modification_Etat_Equipement, Date);
	Date[strlen (Date) - 1] = '\0';	
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Date);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]   [%s][%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Date) + 1), Nouveau_Texte, Objet->Texte_Defaut, Date);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_HostName_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *HostName = NULL;

	ERROR_if (pointer == NULL);
	HostName = Equipement->Smb.HostName;
	if (HostName == NULL)	
		HostName = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, HostName);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (HostName) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Domaine_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Domaine = NULL;

	ERROR_if (pointer == NULL);
	Domaine = Equipement->Smb.DomainName;
	if (Domaine == NULL)	
		Domaine = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Domaine);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Domaine) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Utilisateur_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Utilisateur = NULL;

	ERROR_if (pointer == NULL);
	Utilisateur = Equipement->Smb.Utilisateur;
	if (Utilisateur == NULL)	
		Utilisateur = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Utilisateur);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Utilisateur) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}



gchar    *Gestion_Texte_Type_Parent (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Type = NULL;

	ERROR_if (pointer == NULL);
	switch (Objet_Equipement_Selectionner->ID_Modele_Objet) {
	    case LISTE_SERVEUR:
		    Type = "Server";
		    break;
	    case LISTE_SWITCH:
		    Type = "Switch";
		    break;
	    case LISTE_MULTIMEDIA:
		    Type = "Multimedia";
		    break;
	    case LISTE_CONSOLE:
		    Type = "Console";
		    break;
	    case LISTE_WIFI:
		    Type = "Wifi";
		    break;
	    case LISTE_PDA:
		    Type = "Pda";
		    break;
	    case LISTE_IMPRIMANTE:
		    Type = "Printer";
		    break;
	    case LISTE_ROUTEUR:
		    Type = "Router";
		    break;
	    case LISTE_STATION:
		    Type = "Workstation";
		    break;
	    case LISTE_DISQUE:
		    Type = "Disk";
		    break;
	    case LISTE_CAMERA:
		    Type = "Camera";
		    break;
	    case LISTE_UPS:
		    Type = "UPS";
		    break;
	    case LISTE_TELEPHONIE:
		    Type = "Ip phone";
		    break;
	    case LISTE_ROUTEUR_SWITCH:
		    Type = "Router-Switch";
		    break;
	    case LISTE_ROUTEUR_ADSL:
		    Type = "Router ADSL";
		    break;
	    case LISTE_MODEM:
		    Type = "Modem";
		    break;
	    case LISTE_FIREWALL:
		    Type = "Firewall";
		    break;
	    case LISTE_VPN:
		    Type = "Vpn";
		    break;
	    case LISTE_INCONNU:
		    Type = "Unknown";
		    break;
	    case LISTE_FIREWALLED:
		    Type = "Firewalled";
		    break;
	    case LISTE_MODELE_DOMAINE:
		    Type = "Domain";
		    break;
	    default:
		    Type = "unknow";
	}
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Type);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Gestion_Texte_Type_Parent  Taille [%d]   [%s]", (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Type) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}



gchar    *Gestion_Texte_Parent_Nb_Fils (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Objet_Equipement_Selectionner->Nb_Enfant);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Gestion_Texte_Parent_Nb_Fils  Taille [%s]", Nouveau_Texte);
	return Nouveau_Texte;
}
