/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <glib.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include "Erreur.h"
#include "Debug.h"
#include "Socket.h"
#include "Thread.h"
#include "Semaphore.h"
#include "Com/Initialisation_Com.h"

void segfault_handler (int sig)
{
	debug_printf (D_ERRO,__FILE__,__PRETTY_FUNCTION__,__LINE__, "Segmentation fault    Et oui. Encore un bug   pid : %d Socket ouvert[%d]  Thread[%d]", getpid (), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan));
	exit (0);
}

void Control_C (int sig)
{
	debug_printf (D_INFO,__FILE__,__PRETTY_FUNCTION__,__LINE__, "Arret (Control_C) Socket ouvert[%d]  Thread[%d]", Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan));
	exit (0);
}

void Initialisation_Signal_Erreur ()
{
	signal (SIGSEGV, segfault_handler);
	signal (SIGINT, Control_C);
}
