/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Scan_Equipement.h"
#include "Debug.h"
#include "Scan_Port.h"
#include "Scan_Signature.h"
#include "Scan_Netbios.h"
#include "Thread.h"
#include "Scan_Service.h"
#include "Com/Commun.h"
#include "Com/Communication.h"
#include "Com/Initialisation_Com.h"
#include "Semaphore.h"
#include "Snmp.h"
#include "Scan_Arp.h"

void Rescanne_Equipement (struct Struct_Liste_Equipement *Equipement)
{
	struct Struct_Port *Port_Equipement = NULL;
	gchar    *banniere = NULL;
	struct struct_Retour_Rachaichir_Etat_Equipement Message_Etat;
	struct struct_Retour_Rafraichir_Equipement Message;
	gint      Nb_Objet_Liste, i, Port_Ouvert, Port_Fermer, Nb_Port_Ajouter, Tentative_NetBios;
	gboolean  Sauve_Etat;

	Sauve_Etat = Equipement->Equipement_Allumer;
	Equipement->Compteur_Notification = 0;
	Equipement->Equipement_Allumer = FALSE;
	Equipement->Rafraichissement_Etat_En_Cours = TRUE;
	Envoie_Arp_Equipement (Equipement, 4);
	sleep (2);
	Equipement->Rafraichissement_Etat_En_Cours = FALSE;

	bzero (&Message, sizeof (struct struct_Retour_Rafraichir_Equipement));	
	Message.ID_Reseau = Info_Demarrage.ID_Reseau;
	memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
	if (Sauve_Etat != Equipement->Equipement_Allumer) {	
		bzero (&Message_Etat, sizeof (struct struct_Retour_Rachaichir_Etat_Equipement));
		Message_Etat.ID_Reseau = Info_Demarrage.ID_Reseau;
		memcpy (Message_Etat.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Message_Etat.Equipement_Allumer = Equipement->Equipement_Allumer;
		Message_Etat.Derniere_Modification_Etat_Equipement = Equipement->Derniere_Modification_Etat_Equipement;
		Communication_Envoie_Donnee (RETOUR_RAFRAICHIR_ETAT_EQUIMEMENT, (gpointer *) & Message_Etat, sizeof (Message_Etat));
	}
	if (!Equipement->Equipement_Allumer) {	
		debug_printf (D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Equipment : DOWN");
		Message.Scan_Accompli = FALSE;	
		Communication_Envoie_Donnee (RETOUR_RAFRAICHIR_EQUIPEMENT, (gpointer *) & Message, sizeof (Message));
		pthread_exit (NULL);
	}
	Equipement->Scan_Port_En_Cours = TRUE;	
	
	Scanne_Toutes_Les_Ports (Equipement);	
	
	i = 0;
	Nb_Objet_Liste = g_list_length (Equipement->GList_Port);
	Nb_Port_Ajouter = 0;
	while ((i < Nb_Objet_Liste) && (Nb_Port_Ajouter < MAX_PORTS)) {
		Port_Equipement = g_list_nth_data (Equipement->GList_Port, i);
		if ((Port_Equipement->Etat_Port == OUVERT) || (Port_Equipement->Notification)) {	
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter port %d dans la liste", Port_Equipement->Num_Port);
			Message.Port[Nb_Port_Ajouter].Num_Port = Port_Equipement->Num_Port;
			Message.Port[Nb_Port_Ajouter].Derniere_Modification_Etat_Port = Port_Equipement->Derniere_Modification_Etat_Port;
			Message.Port[Nb_Port_Ajouter].Etat_Port = Port_Equipement->Etat_Port;
			Message.Port[Nb_Port_Ajouter].Notification_Active = Port_Equipement->Notification;
			Nb_Port_Ajouter++;
		}
		i++;
	}
	
	Message.Nb_Port_Total_Scanner = Nombre_De_Port_Scanner (Equipement);
	Message.Nb_Port_Ouvert = Nombre_De_Port_Avec_Etat (Equipement, OUVERT);
	Message.Nb_Port_Fermer = Nombre_De_Port_Avec_Etat (Equipement, FERMER);
	Message.Nb_Port_Firewaller = Nombre_De_Port_Avec_Etat (Equipement, FIREWALLED);
	if (memcmp (Equipement->ID_Equipement, Mon_Adresse_MAC, MAC_ADDR_LEN) != 0) {	
		Port_Ouvert = Cherche_Un_Port_Avec_Etat (Equipement, OUVERT);
		Port_Fermer = Cherche_Un_Port_Avec_Etat (Equipement, FERMER);
		
		if (Port_Fermer == -1)
			Port_Fermer = Cherche_Un_Port_Avec_Etat (Equipement, FIREWALLED);	
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Scan os avec comme num port ouvert[%d]   num port fermer[%d]", Port_Ouvert, Port_Fermer);
		if ((Port_Ouvert != -1) && (Port_Fermer != -1))	
			Envoie_Trames_Scanne_Os (Equipement, Port_Ouvert, Port_Fermer);
		
		memcpy (Message.Reponse_Signature, Equipement->Reponse_Signature, sizeof (struct struct_Reponse) * NB_SCAN_OS);
		
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_FTP)) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port FTP ouvert");
			banniere = Recupere_Banniere_FTP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_FTP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_FTP, banniere);
				else {
					strncpy (Message.Entete_FTP, banniere, 499);
					Message.Entete_FTP[499] = '\0';	
				}
				g_free (banniere);
			}
		}
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_HTTP)) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port HTTP ouvert");
			banniere = Recupere_Banniere_HTTP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_HTTP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_HTTP, banniere);
				else {
					strncpy (Message.Entete_HTTP, banniere, 499);
					Message.Entete_HTTP[499] = '\0';	
				}
				g_free (banniere);
			}
		}
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_IMAP)) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port IMAP ouvert");
			banniere = Recupere_Banniere_IMAP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_IMAP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_IMAP, banniere);
				else {
					strncpy (Message.Entete_IMAP, banniere, 499);
					Message.Entete_IMAP[499] = '\0';	
				}
				g_free (banniere);
			}
		}
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_TELNET)) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port TELNET ouvert");
			banniere = Recupere_Banniere_TELNET (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_TELNET, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_TELNET, banniere);
				else {
					strncpy (Message.Entete_TELNET, banniere, 499);
					Message.Entete_TELNET[499] = '\0';	
				}
				g_free (banniere);
			}
		}
	}

	
	if (Cherche_Si_Port_Ouvert (Equipement, PORT_NETBIOS)) {
		Tentative_NetBios = 0;
		while ((Tentative_NetBios < 3) && (!Demande_NetBios (Equipement, Tentative_NetBios))) {	
			Tentative_NetBios++;
			sleep (5);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Nouvelle tentative NETBIOS tentatice(%d) (%s)", Tentative_NetBios, Equipement->Adresse_Ip_Char);
		}
		
		memcpy (&Message.Smb, &Equipement->Smb, sizeof (struct struct_Smb));
	}
	
	Message.Scan_Accompli = TRUE;	
	Communication_Envoie_Donnee (RETOUR_RAFRAICHIR_EQUIPEMENT, (gpointer *) & Message, sizeof (Message));
	Equipement->Scan_Signature = FALSE;	
	Equipement->Scan_Port_En_Cours = FALSE;	
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Fin Rescanne_Equipement");
	pthread_exit (NULL);
}


void Demande_Rafraichir_Equipement (gpointer * Donnee)
{
	struct struct_Demande_Rachaichir_Etat_Equipement *Message = (struct struct_Demande_Rachaichir_Etat_Equipement *) Donnee;
	struct Struct_Liste_Equipement *Equipement = NULL;
	gint      ID_Equipement;

	ERROR_if (Donnee == NULL);
	ID_Equipement = Recherche_Index_Equipement (Message->ID_Equipement);
	if (ID_Equipement == -1) {
		debug_printf (D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Refresh (Equipment unknown)");
		return;		
	}
	Equipement = Retour_Pointeur_Equipement (ID_Equipement);
	
	demmarrage_Thread (&Rescanne_Equipement, (gpointer *) Equipement);
}



void Scanne_Equipement (struct Struct_Liste_Equipement *Equipement)
{
	struct Struct_Port *Port_Equipement = NULL;
	gchar    *banniere = NULL;
	struct struct_Nouveau_Equipement Message;
	gint      Nb_Objet_Liste, i, Port_Ouvert, Port_Fermer, Nb_Port_Ajouter, Tentative_NetBios;

	ERROR_if (Equipement == NULL);
	bzero (&Message, sizeof (struct struct_Nouveau_Equipement));	
	
	Message.ID_Reseau = Info_Demarrage.ID_Reseau;
	memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
	memcpy (Message.Adresse_Ip_Char, Equipement->Adresse_Ip_Char, 15 + 1);
	memcpy (Message.Adresse_MAC_Char, Equipement->Adresse_MAC_Char, 17 + 1);
	
	Scanne_Toutes_Les_Ports (Equipement);
	
	i = 0;
	Nb_Objet_Liste = g_list_length (Equipement->GList_Port);
	Nb_Port_Ajouter = 0;
	while ((i < Nb_Objet_Liste) && (Nb_Port_Ajouter < MAX_PORTS)) {
		Port_Equipement = g_list_nth_data (Equipement->GList_Port, i);
		if (Port_Equipement->Etat_Port == OUVERT) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajouter port %d dans la liste", Port_Equipement->Num_Port);
			Message.Port[Nb_Port_Ajouter].Num_Port = Port_Equipement->Num_Port;
			Message.Port[Nb_Port_Ajouter].Derniere_Modification_Etat_Port = Port_Equipement->Derniere_Modification_Etat_Port;
			Nb_Port_Ajouter++;
		}
		i++;
	}
	Message.Intrus = Equipement->Intrus;
	
	Message.Nb_Port_Total_Scanner = Nombre_De_Port_Scanner (Equipement);
	Message.Nb_Port_Ouvert = Nombre_De_Port_Avec_Etat (Equipement, OUVERT);
	Message.Nb_Port_Fermer = Nombre_De_Port_Avec_Etat (Equipement, FERMER);
	Message.Nb_Port_Firewaller = Nombre_De_Port_Avec_Etat (Equipement, FIREWALLED);
	
	if (memcmp (Equipement->ID_Equipement, Mon_Adresse_MAC, MAC_ADDR_LEN) != 0) {	
		Equipement->Agent_AutoScan = FALSE;
		Message.Agent_AutoScan = FALSE;
		Port_Ouvert = Cherche_Un_Port_Avec_Etat (Equipement, OUVERT);
		Port_Fermer = Cherche_Un_Port_Avec_Etat (Equipement, FERMER);
		
		if (Port_Fermer == -1)
			Port_Fermer = Cherche_Un_Port_Avec_Etat (Equipement, FIREWALLED);	
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Scan os avec comme num port ouvert[%d]   num port fermer[%d]", Port_Ouvert, Port_Fermer);
		if ((Port_Ouvert != -1) && (Port_Fermer != -1))	
			Envoie_Trames_Scanne_Os (Equipement, Port_Ouvert, Port_Fermer);
		
		memcpy (Message.Reponse_Signature, Equipement->Reponse_Signature, sizeof (struct struct_Reponse) * NB_SCAN_OS);
		
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_FTP)) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port FTP ouvert");
			banniere = Recupere_Banniere_FTP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_FTP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_FTP, banniere);
				else {
					strncpy (Message.Entete_FTP, banniere, 499);
					Message.Entete_FTP[499] = '\0';	
				}
				g_free (banniere);
			}
		}
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_HTTP)) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port HTTP ouvert");
			banniere = Recupere_Banniere_HTTP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_HTTP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_HTTP, banniere);
				else {
					strncpy (Message.Entete_HTTP, banniere, 499);
					Message.Entete_HTTP[499] = '\0';	
				}
				g_free (banniere);
			}
		}
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_IMAP)) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port IMAP ouvert");
			banniere = Recupere_Banniere_IMAP (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_IMAP, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_IMAP, banniere);
				else {
					strncpy (Message.Entete_IMAP, banniere, 499);
					Message.Entete_IMAP[499] = '\0';	
				}
				g_free (banniere);
			}
		}
		if (Cherche_Si_Port_Ouvert (Equipement, PORT_TELNET)) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Port TELNET ouvert");
			banniere = Recupere_Banniere_TELNET (Equipement);
			if (banniere == NULL) {
				strcpy (Message.Entete_TELNET, "");
			}
			else {
				if (strlen (banniere) < 499)
					strcpy (Message.Entete_TELNET, banniere);
				else {
					strncpy (Message.Entete_TELNET, banniere, 499);
					Message.Entete_TELNET[499] = '\0';	
				}
				g_free (banniere);
			}
		}
	}
	else {
		Equipement->Agent_AutoScan = TRUE;
		Message.Agent_AutoScan = TRUE;
	}
	
	if (Cherche_Si_Port_Ouvert (Equipement, PORT_NETBIOS)) {
		Tentative_NetBios = 0;
		while ((Tentative_NetBios < 3) && (!Demande_NetBios (Equipement, Tentative_NetBios))) {	
			Tentative_NetBios++;
			sleep (5);
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Nouvelle tentative NETBIOS tentatice(%d) (%s)", Tentative_NetBios, Equipement->Adresse_Ip_Char);
		}
		
		memcpy (&Message.Smb, &Equipement->Smb, sizeof (struct struct_Smb));
	}
	
	Demande_Snmp_Equipement (Equipement);
	Message.Snmp_Ouvert = Equipement->Snmp_Ouvert;
	memcpy (&Message.Snmp, &Equipement->Snmp, sizeof (struct Struct_Snmp));
	
	Communication_Envoie_Donnee (NOUVEAU_EQUIPEMENT, (gpointer *) & Message, sizeof (Message));
	Equipement->Scan_Signature = FALSE;	
	
	if (Equipement->Snmp_Ouvert) {
		for (i = 0; i < NB_ID_SNMP_LISTE; i++)
			Envoie_Snmp_Liste (Equipement, i);
	};
	
	sem_post (&Semaphore_Thread_Scan);



	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Fin thread Scan equipement");
	pthread_exit (NULL);
}
