/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2006 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Thread_Detect.h"
#include "Reseau.h"
#include "Debug.h"
#include "Sous_Reseau_Autorise.h"
#include "Liste_Equipement.h"
#include "Scan_Port.h"
#include "Scan_Equipement.h"
#include "Scan_Signature.h"
#include "Com/Initialisation_Com.h"
#include "Semaphore.h"
#include "Info.h"
#include "Thread.h"
#include "Liste_Sous_Reseau.h"

void Boucle_Scan ()
{
	struct Struct_Liste_Equipement *Equipement;
	gint      Num;

	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Demarrage boucle pid(%d)  scan    En cours de scan (%d) / (%d)", getpid (), Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), Valeur_Semaphore (&Semaphore_Nouveau_Equipement));
	Num = Nb_Machine_Dans_La_Liste;	
	while (1) {
		sem_wait (&Semaphore_Nouveau_Equipement);
		sem_wait (&Semaphore_Thread_Scan);
		Equipement = Retour_Pointeur_Equipement (Num);
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Boucle scan n %d Ip = [%s]  Mac = [%s] En cours de scan (%d) / (%d)", Num, Equipement->Adresse_Ip_Char, Equipement->Adresse_MAC_Char, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), Valeur_Semaphore (&Semaphore_Nouveau_Equipement));
		demmarrage_Thread (&Scanne_Equipement, (gpointer *) Equipement);
		Num++;
	}
}



void Thread_Detect ()
{
	struct Struct_Liste_Equipement *Equipement;
	struct struct_trame Packet;
	unsigned char ID_Equipement[MAC_ADDR_LEN + IP_ADDR_LEN + 1];	
	unsigned short Port_Source, Taille_Ip, Port_Destination;
	unsigned char Type_ICMP, Code_ICMP;
	struct sockaddr sock;
	unsigned char Ma_Plage[4 + 1];
	gint      Socket, n_read, Index_Equipement, Type_Trame;
	gboolean  Arret_NBNS, Equipement_Detecter, Port_Ouvert, Port_Fermer;

	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Thread Detect  pid(%d)", getpid ());
	strcpy (sock.sa_data, Info_Demarrage.Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket_control (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
	}
	memcpy (&Ma_Plage, &Mon_Adresse_Ip, IP_ADDR_LEN);
	Ma_Plage[3] = 0;
	Ajout_Sous_Reseau (Ma_Plage, TRUE);
	
	while (1) {
		Arret_NBNS = FALSE;
		Equipement_Detecter = FALSE;
		Port_Ouvert = FALSE;
		Port_Fermer = FALSE;
		n_read = recvfrom (Socket, &Packet, sizeof (Packet), 0, NULL, 0);
		Type_Trame = 0;
		memcpy (&ID_Equipement, &Packet.Source_MAC, MAC_ADDR_LEN);
		
		switch (htons (Packet.Proto)) {
		    case TRAME_IP:
			    if ((Packet.Datagramme[0] >> 4) == IP_VERSION4) {	
				    memcpy (&ID_Equipement[MAC_ADDR_LEN], &Packet.Datagramme[12], IP_ADDR_LEN);
				    
				    switch (Packet.Datagramme[9]) {
					case TCP:	
						Type_Trame = TCP;
						Taille_Ip = (Packet.Datagramme[0] & 0x0F) << 2;
						memcpy (&Port_Source, &Packet.Datagramme[Taille_Ip], 2);	
						Port_Source = htons (Port_Source);
						memcpy (&Port_Destination, &Packet.Datagramme[Taille_Ip + 2], 2);	
						Port_Destination = htons (Port_Destination);
						switch (Packet.Datagramme[Taille_Ip + 13]) {
						    case 0x14:	
						    case 0x1C:	
						    case 0x15:	
							    Port_Fermer = TRUE;
							    break;
						    case 0x12:	
							    Port_Ouvert = TRUE;
							    break;
						}
						break;
					case UDP:	
						Type_Trame = UDP;
						
						if ((Packet.Dest_MAC[5] == 255) && (Packet.Datagramme[22] == 0) && (Packet.Datagramme[23] == NBNS)) {
							if ((Packet.Datagramme[30] == 0x30) && (Packet.Datagramme[31] == 0x10) && (Packet.Datagramme[71] == 0x41) && (Packet.Datagramme[72] == 0x41))
								Arret_NBNS = TRUE;	
						}
						break;
					case ICMP:	
						Type_Trame = ICMP;
						Taille_Ip = (Packet.Datagramme[0] & 0x0F) << 2;
						Type_ICMP = Packet.Datagramme[Taille_Ip];
						Code_ICMP = Packet.Datagramme[Taille_Ip + 1];
						break;
				    }
				    Equipement_Detecter = TRUE;
			    }
			    break;
		    case TRAME_ARP:
			    Type_Trame = TRAME_ARP;
			    memcpy (&ID_Equipement[MAC_ADDR_LEN], &Packet.Datagramme[14], IP_ADDR_LEN);
			    
			    Equipement_Detecter = TRUE;
			    break;
		}
		if ((Equipement_Detecter) && !((ID_Equipement[0] == 0) && (ID_Equipement[1] == 0) && (ID_Equipement[2] == 0) && (ID_Equipement[3] == 0)) ) {
			if (Recherche_Si_Sous_Reseau_Autoriser (&ID_Equipement[MAC_ADDR_LEN])) {
				if ((Index_Equipement = Recherche_Index_Equipement (ID_Equipement)) == -1) {
					Ajout_Equipement (ID_Equipement);
				}
				else {
					Equipement = Retour_Pointeur_Equipement (Index_Equipement);
					if (Arret_NBNS) {
						
						Equipement_Arreter (Equipement);
					}
					else {
						Reception_Donnee_Equipement_Connu (Equipement);
						switch (Type_Trame) {
						    case TCP:	
							    if (!(Traitement_ScanOS_TCP (Equipement, &Packet, n_read, Taille_Ip, Port_Source, Port_Destination))) {
								    
								    if (Port_Fermer) {
									    debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "port : %d fermer", Port_Source);
									    Modifie_Etat_Port_Equipement (Equipement, Port_Source, FERMER);
								    }
								    if (Port_Ouvert) {
									    debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "port : %d ouvert", Port_Source);
									    Modifie_Etat_Port_Equipement (Equipement, Port_Source, OUVERT);
								    }
							    }
							    break;
						    case UDP:	
							    break;
						    case ICMP:	
							    if (!(Traitement_ScanOS_ICMP (Equipement, &Packet, n_read, Taille_Ip, Type_ICMP, Code_ICMP))) {
								    
							    }
							    break;
						}
					}
				}
			}
		}
	}
}
